

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Function/RptGetCloudVendorName.func] ---------- 


SET QUOTED_IDENTIFIER ON

SET NOCOUNT ON


print '... Creating Function: RptGetCloudVendorName'
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[RptGetCloudVendorName]') and (OBJECTPROPERTY(id, N'IsInlineFunction') = 1 OR OBJECTPROPERTY(id, N'IsTableFunction') = 1 OR OBJECTPROPERTY(id, N'IsScalarFunction') = 1))
BEGIN
  drop function [dbo].[RptGetCloudVendorName]
  delete from GXDBVersions where name = 'RptGetCloudVendorName' and type = 5
END
GO

	CREATE FUNCTION [dbo].[RptGetCloudVendorName]
	(
		@i_CloudDeviceTypeId int = 0
	)
	RETURNS VARCHAR(20)
	AS
	BEGIN
		-- Declare the return variable here
		DECLARE @Output NVARCHAR(128)
		SELECT @Output =
					CASE @i_CloudDeviceTypeId
						WHEN NULL THEN 'None'
						WHEN 0 THEN 'None'
						WHEN 2 THEN 'AMAZON S3'
						WHEN 3 THEN 'MICROSOFT AZURE'
						WHEN 4 THEN 'NIRVANIX MFS'
						WHEN 5 THEN 'RACKSPACE CLOUD FILES'
						WHEN 6 THEN 'IRON MOUNTAIN ARCHIVE'
						WHEN 7 THEN 'SUN CLOUD'
						WHEN 8 THEN 'SEATGATE CLOUD'
						WHEN 9 THEN 'EMC ATMOS'
						WHEN 10 THEN 'ATT SYNAPTIC'
						WHEN 11 THEN 'CV OBJECT LINK'
						WHEN 12 THEN 'HDS HCP'
						WHEN 13 THEN 'MEZEO CS'
						WHEN 14 THEN 'OPENSTACK'
						WHEN 15 THEN 'AMPLIDATA'
						WHEN 16 THEN 'CMCC ONEST'
						WHEN 17 THEN 'HDFS'
						WHEN 18 THEN 'VERIZON CLOUD'
						WHEN 19 THEN 'GOOGLE CLOUD'
						WHEN 20 THEN 'VMWARE CLOUD'
						WHEN 21 THEN 'ORACLE STORAGE CLOUD'
						WHEN 22 THEN 'Oracle Storage Cloud Archive Service'
						WHEN 23 THEN 'AliCloud Object Storage Service'
						WHEN 24 THEN 'Huawei Object Storage'
						WHEN 25 THEN 'Oracle Bare Metal Cloud Object Storage Service (S3 Compatibility)'
						WHEN 26 THEN 'Oracle Bare Metal Cloud Object Storage Service'
						WHEN 27 THEN 'Telefonica Open Cloud Object Storage'
						WHEN 28 THEN 'Oracle Bare Metal Archive Storage'
						WHEN 29 THEN 'Inspur Cloud'
						WHEN 30 THEN 'IBM Cloud'
						WHEN 31 THEN 'Azure Data Lake Store'
						WHEN 32 THEN 'Kingsoft KS3'
						WHEN 39 THEN 'Azure Compatible'
						WHEN 40 THEN 'S3 COMPATIBLE'
						WHEN 41 THEN 'OBJECT BASE START'
						WHEN 51 THEN 'CARINGO CASTOR'
						WHEN 52 THEN 'DELL DX OBJECTSTORAGE'
						WHEN 53 THEN 'AMAZON GLACIER'
						WHEN 54 THEN 'DDN WOS'
						WHEN 59 THEN 'HPE StoreOnce'
						WHEN 60 THEN 'OBJECT BASE END'
						WHEN 62 THEN 'Isilon OneFS'
						WHEN 63 THEN 'Local File'
						Else 'Others'
					END

		RETURN @Output
	END


GO
declare @retCode integer		-- Now do Error Check
set @retCode = @@error
if (@retCode <> 0)
BEGIN
	set @retCode = @@error;
	print 'RETVAL: 04 Function [RptGetCloudVendorName]'
END
GO


if NOT EXISTS (SELECT * FROM GXDBVersions WHERE type = 5 AND name = 'RptGetCloudVendorName' AND revision = '1.1.2.2')

  insert into GXDBVersions values(5, 'RptGetCloudVendorName',  '1.1.2.2', 'RptGetCloudVendorName', '')
GO

declare @retCode integer		-- Now do Error Check
set @retCode = @@error
if (@retCode <> 0)
BEGIN
	set @retCode = @@error;
	print 'RETVAL: 10 Table [GXDBVersions]'
END
GO


SET NOCOUNT OFF
