

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Sp/CV_ExecuteQuery.sp] ---------- 

-- ----------------------------------------------------------------------
--
--           Copyright (c) 1998  CommVault Systems, Inc.
--                  All rights reserved.
--
--
--        This is unpublished proprietary source code of CommVault
--        Systems, Inc. The copyright notice above does not evidence
--        any actual or intended publication of such source code.
--	Author: Sunil Telagamsetti
--	Date:   07/24/2012
-- ----------------------------------------------------------------------*/
-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Sp/CV_ExecuteQuery.sp,v $ $Id: CV_ExecuteQuery.sp,v 1.3.2.2 2018/09/11 17:47:05 hravula Exp $";
-- Following Line Indicates new Class.  It should be identical to filename+revision!
SET QUOTED_IDENTIFIER OFF
print '>>> Drop Stored Procedure: CV_ExecuteQuery <<<'

IF EXISTS (select * from sysobjects where name='CV_ExecuteQuery')
	drop procedure CV_ExecuteQuery
IF EXISTS (select * from GxQscripts where name='CV_ExecuteQuery')
	delete from GxQscripts where name = 'CV_ExecuteQuery'
GO

IF EXISTS (select * from GXDBVersions where aliasname='CV_ExecuteQuery')
	delete from GXDBVersions where aliasname = 'CV_ExecuteQuery'
GO
print '... Creating Procedure: CV_ExecuteQuery'
GO
SET QUOTED_IDENTIFIER ON
GO
create procedure CV_ExecuteQuery
  @i_queryType INT,
  @i_sPName varchar(128),
  @i_argument0 NVARCHAR(MAX) = NULL,
  @i_argument1 NVARCHAR(MAX) = NULL,
  @i_argument2 NVARCHAR(MAX) = NULL,
  @i_argument3 NVARCHAR(MAX) = NULL,
  @i_argument4 NVARCHAR(MAX) = NULL,
  @i_argument5 NVARCHAR(MAX) = NULL,
  @i_argument6 NVARCHAR(MAX) = NULL,
  @i_argument7 NVARCHAR(MAX) = NULL,
  @i_argument8 NVARCHAR(MAX) = NULL,
  @i_argument9 NVARCHAR(MAX) = NULL,
  @i_argument10 NVARCHAR(MAX) = NULL,
  @i_argument11 NVARCHAR(MAX) = NULL,
  @i_argument12 NVARCHAR(MAX) = NULL,
  @i_argument13 NVARCHAR(MAX) = NULL,
  @i_argument14 NVARCHAR(MAX) = NULL,
  @i_argument15 NVARCHAR(MAX) = NULL
AS
BEGIN
	SET NOCOUNT ON
	IF @i_spName = 'CV_ExecuteQuery'
	BEGIN
		PRINT 'Could not run CV_ExecuteQuery'
		RETURN
	END
	IF @i_queryType <> 0
	   RETURN
	If NOT EXISTS(SELECT * FROM cf_CommservSurveyQueries where ParserScriptName = @i_spName)  AND
		NOT EXISTS(SELECT * FROM cf_SurveyReportsProcList where ProcName = @i_spName)
	BEGIN
		PRINT 'Procedure [' + @i_spName + '] not supported.'
		RETURN
	END
	IF @i_queryType = 0 AND ISNULL(OBJECTPROPERTY (object_id(@i_spName), 'IsProcedure'), 0) <> 1
	BEGIN
		PRINT 'Procedure [' + @i_spName + '] not found.'
		RETURN
	END
	DECLARE @i_arguments NVARCHAR(MAX) = ''
	DECLARE @Statement NVARCHAR(MAX) = ''
	DECLARE @arg_list NVARCHAR(512) = N'@i_argument0 NVARCHAR(MAX), @i_argument1 NVARCHAR(MAX), @i_argument2 NVARCHAR(MAX), @i_argument3 NVARCHAR(MAX), @i_argument4 NVARCHAR(MAX), @i_argument5 NVARCHAR(MAX), @i_argument6 NVARCHAR(MAX), @i_argument7 NVARCHAR(MAX), @i_argument8 NVARCHAR(MAX), @i_argument9 NVARCHAR(MAX), @i_argument10 NVARCHAR(MAX), @i_argument11 NVARCHAR(MAX), @i_argument12 NVARCHAR(MAX), @i_argument13 NVARCHAR(MAX), @i_argument14 NVARCHAR(MAX), @i_argument15 NVARCHAR(MAX)'
	BEGIN
		IF @i_argument0 IS NOT NULL
		BEGIN
			--Sanitize input
			IF dbo.IsInputSafe(@i_argument0) = 0
			BEGIN
				PRINT 'Invalid Input ' + @i_argument0
				RETURN
			END
			IF @i_argument0 = 'NULL'
				SET @i_argument0 = NULL
			SET @i_arguments += '@i_argument0'
		END
		IF @i_argument1 IS NOT NULL
		BEGIN
			--Sanitize input
			IF dbo.IsInputSafe(@i_argument1) = 0
			BEGIN
				PRINT 'Invalid Input ' + @i_argument1
				RETURN
			END
			IF DATALENGTH(@i_arguments) <> 0
				SET @i_arguments += ', '
			IF @i_argument1 = 'NULL'
				SET @i_argument1 = NULL
			SET @i_arguments += '@i_argument1'
		END
		IF @i_argument2 IS NOT NULL
		BEGIN
			--Sanitize input
			IF dbo.IsInputSafe(@i_argument2) = 0
			BEGIN
				PRINT 'Invalid Input ' + @i_argument2
				RETURN
			END
			IF DATALENGTH(@i_arguments) <> 0
				SET @i_arguments += ', '
			IF @i_argument2 = 'NULL'
				SET @i_argument2 = NULL
			SET @i_arguments += '@i_argument2'
		END
		IF @i_argument3 IS NOT NULL
		BEGIN
			--Sanitize input
			IF dbo.IsInputSafe(@i_argument3) = 0
			BEGIN
				PRINT 'Invalid Input ' + @i_argument3
				RETURN
			END
			IF DATALENGTH(@i_arguments) <> 0
				SET @i_arguments += ', '
			IF @i_argument3 = 'NULL'
				SET @i_argument3 = NULL
			SET @i_arguments += '@i_argument3'
		END
		IF @i_argument4 IS NOT NULL
		BEGIN
			--Sanitize input
			IF dbo.IsInputSafe(@i_argument4) = 0
			BEGIN
				PRINT 'Invalid Input ' + @i_argument4
				RETURN
			END
			IF DATALENGTH(@i_arguments) <> 0
				SET @i_arguments += ', '
			IF @i_argument4 = 'NULL'
				SET @i_argument4 = NULL
			SET @i_arguments += '@i_argument4'
		END
		IF @i_argument5 IS NOT NULL
		BEGIN
			--Sanitize input
			IF dbo.IsInputSafe(@i_argument5) = 0
			BEGIN
				PRINT 'Invalid Input ' + @i_argument5
				RETURN
			END
			IF DATALENGTH(@i_arguments) <> 0
				SET @i_arguments += ', '
			IF @i_argument5 = 'NULL'
				SET @i_argument5 = NULL
			SET @i_arguments += '@i_argument5'
		END
		IF @i_argument6 IS NOT NULL
		BEGIN
			--Sanitize input
			IF dbo.IsInputSafe(@i_argument6) = 0
			BEGIN
				PRINT 'Invalid Input ' + @i_argument6
				RETURN
			END
			IF DATALENGTH(@i_arguments) <> 0
				SET @i_arguments += ', '
			IF @i_argument6 = 'NULL'
				SET @i_argument6 = NULL
			SET @i_arguments += '@i_argument6'
		END
		IF @i_argument7 IS NOT NULL
		BEGIN
			--Sanitize input
			IF dbo.IsInputSafe(@i_argument7) = 0
			BEGIN
				PRINT 'Invalid Input ' + @i_argument7
				RETURN
			END
			IF DATALENGTH(@i_arguments) <> 0
				SET @i_arguments += ', '
			--Sanitize input
			IF @i_argument7 = 'NULL'
				SET @i_argument7 = NULL
			SET @i_arguments += '@i_argument7'
		END
		IF @i_argument8 IS NOT NULL
		BEGIN
			--Sanitize input
			IF dbo.IsInputSafe(@i_argument8) = 0
			BEGIN
				PRINT 'Invalid Input ' + @i_argument8
				RETURN
			END
			IF DATALENGTH(@i_arguments) <> 0
				SET @i_arguments += ', '
			IF @i_argument8 = 'NULL'
				SET @i_argument8 = NULL
			SET @i_arguments += '@i_argument8'
		END
		IF @i_argument9 IS NOT NULL
		BEGIN
			--Sanitize input
			IF dbo.IsInputSafe(@i_argument9) = 0
			BEGIN
				PRINT 'Invalid Input ' + @i_argument9
				RETURN
			END
			IF DATALENGTH(@i_arguments) <> 0
				SET @i_arguments += ', '
			IF @i_argument9 = 'NULL'
				SET @i_argument9 = NULL
			SET @i_arguments += '@i_argument9'
		END
		IF @i_argument10 IS NOT NULL
		BEGIN
			--Sanitize input
			IF dbo.IsInputSafe(@i_argument10) = 0
			BEGIN
				PRINT 'Invalid Input ' + @i_argument10
				RETURN
			END
			IF DATALENGTH(@i_arguments) <> 0
				SET @i_arguments += ', '
			IF @i_argument10 = 'NULL'
				SET @i_argument10 = NULL
			SET @i_arguments += '@i_argument10'
		END
		IF @i_argument11 IS NOT NULL
		BEGIN
			--Sanitize input
			IF dbo.IsInputSafe(@i_argument11) = 0
			BEGIN
				PRINT 'Invalid Input ' + @i_argument11
				RETURN
			END
			IF DATALENGTH(@i_arguments) <> 0
				SET @i_arguments += ', '
			IF @i_argument11 = 'NULL'
				SET @i_argument11 = NULL
			SET @i_arguments += '@i_argument11'
		END
		IF @i_argument12 IS NOT NULL
		BEGIN
			--Sanitize input
			IF dbo.IsInputSafe(@i_argument12) = 0
			BEGIN
				PRINT 'Invalid Input ' + @i_argument12
				RETURN
			END
			IF DATALENGTH(@i_arguments) <> 0
				SET @i_arguments += ', '
			IF @i_argument12 = 'NULL'
				SET @i_argument12 = NULL
			SET @i_arguments += '@i_argument12'
		END
		IF @i_argument13 IS NOT NULL
		BEGIN
			--Sanitize input
			IF dbo.IsInputSafe(@i_argument13) = 0
			BEGIN
				PRINT 'Invalid Input ' + @i_argument13
				RETURN
			END
			IF DATALENGTH(@i_arguments) <> 0
				SET @i_arguments += ', '
			IF @i_argument13 = 'NULL'
				SET @i_argument13 = NULL
			SET @i_arguments += '@i_argument13'
		END
		IF @i_argument14 IS NOT NULL
		BEGIN
			--Sanitize input
			IF dbo.IsInputSafe(@i_argument14) = 0
			BEGIN
				PRINT 'Invalid Input ' + @i_argument14
				RETURN
			END
			IF DATALENGTH(@i_arguments) <> 0
				SET @i_arguments += ', '
			IF @i_argument14 = 'NULL'
				SET @i_argument14 = NULL
			SET @i_arguments += '@i_argument14'
		END
		IF @i_argument15 IS NOT NULL
		BEGIN
			--Sanitize input
			IF dbo.IsInputSafe(@i_argument15) = 0
			BEGIN
				PRINT 'Invalid Input ' + @i_argument15
				RETURN
			END
			IF DATALENGTH(@i_arguments) <> 0
				SET @i_arguments += ', '
			IF @i_argument15 = 'NULL'
				SET @i_argument15 = NULL
			SET @i_arguments += '@i_argument15'
		END
	END
	BEGIN
		IF DATALENGTH(@i_arguments) <> 0
			SET @Statement = 'EXEC ' + @i_spName  + ' ' + @i_arguments
		ELSE
			SET @Statement = @i_spName
	END
	IF DATALENGTH(@Statement) <> 0
	BEGIN
		DECLARE @P1 INT;
		EXEC sp_prepexec @P1 OUTPUT,
		@arg_list,
		@Statement,
		@i_argument0, @i_argument1, @i_argument2, @i_argument3, @i_argument4, @i_argument5, @i_argument6, @i_argument7, @i_argument8, @i_argument9, @i_argument10, @i_argument11, @i_argument12, @i_argument13, @i_argument14, @i_argument15
		EXEC sp_unprepare @P1;
	END
SET NOCOUNT OFF
END
GO
-- Tell the AWK processor that there are no more input lines to scan

IF EXISTS (select * from GxQscripts where name = 'CV_ExecuteQuery')
	delete from GxQscripts where name = 'CV_ExecuteQuery'
GO

IF EXISTS (select * from GXDBVersions where aliasname='CV_ExecuteQuery')
	delete from GXDBVersions where aliasname = 'CV_ExecuteQuery'
GO

insert into GXDBVersions values(2, 'CV_ExecuteQuery',  '00010003000200020000', 'CV_ExecuteQuery', '00010003000200020000')
GO

