

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Sp/CreateMetricsReportQuery.sp] ---------- 

-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Sp/CreateMetricsReportQuery.sp,v $ $Id: CreateMetricsReportQuery.sp,v 1.6.58.6 2020/12/17 02:50:50 dkraplanee Exp $";
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON


IF EXISTS (select * from sysobjects where name='CreateMetricsReportQuery')
BEGIN
	print '>>> Drop Stored Procedure: CreateMetricsReportQuery <<<'
	drop procedure CreateMetricsReportQuery
END
IF EXISTS (select * from GxQscripts where name='CreateMetricsReportQuery')
	delete from GxQscripts where name = 'CreateMetricsReportQuery'
GO

IF EXISTS (select * from GXDBVersions where aliasname='CreateMetricsReportQuery')
	delete from GXDBVersions where aliasname = 'CreateMetricsReportQuery'
GO
print '... Creating Procedure: CreateMetricsReportQuery'
GO
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON
GO
create procedure CreateMetricsReportQuery
  @i_reportName NVARCHAR(MAX),
  @i_reportDescription NVARCHAR(MAX),
  @i_sqlQuery NVARCHAR(MAX),
  @i_columnList NVARCHAR(MAX),
  @i_flags INT,
  @i_retention INT,
  @i_queryId INT = 0,
  @i_retainData INT = 0
AS
SET NOCOUNT ON
DECLARE @queryId INT = 0
--This is for future. If the @i_retainData > 0 then we want to retain older data and create a new table etc.....
IF @i_queryId <> 0 AND @i_retainData <> 0
BEGIN
	SELECT @queryId
	RETURN
END
IF @i_queryId = 0
BEGIN
	SELECT TOP 1 @queryId =  QueryId + 1 FROM cf_CommservSurveyQueries
	WHERE QueryId >= 10000
	ORDER BY QueryId DESC
	IF @queryId = 0
		SET @queryId = 10000
END
ELSE
BEGIN
	SET @queryId = @i_queryId
	IF  EXISTS( SELECT * FROM cf_CommservSurveyQueries
            WHERE QueryId = @queryId)
	BEGIN
		DELETE FROM cf_CommservSurveyQueries WHERE QueryId = @queryId
	END
END
DECLARE @SplitChar NVARCHAR(10) = ',';
--Get the column names and types
DECLARE @repColsTable TABLE (
	columnName NVARCHAR(200),
	columnType NVARCHAR(200));
Declare @token NVARCHAR(200) = null
Declare @varname NVARCHAR(200) = null
Declare @vartype NVARCHAR(200) = null
Declare @trimvarname NVARCHAR(200) = null
DECLARE @stripRepName NVARCHAR(2000) = 'cf_MetricsQuery' + CAST(@queryId as NVARCHAR(100))
DECLARE @repTableName NVARCHAR(100) = 'cf_MetricsQuery' + CAST(@queryId as NVARCHAR(100))
DECLARE @repParseProcName NVARCHAR(100) = 'ParseCustomQueryResult'
Declare @queryFileName NVARCHAR(200) = 'CommservSurveyQuery_' + CAST(@queryId as NVARCHAR(100))+ '.sql'
DECLARE @createTableQuery NVARCHAR(MAX)
DECLARE @insertQuery NVARCHAR(MAX)
IF EXISTS (SELECT *
           FROM INFORMATION_SCHEMA.TABLES
           WHERE TABLE_TYPE='BASE TABLE'
           AND TABLE_NAME= @repTableName)
BEGIN
	SET @createTableQuery = 'TRUNCATE TABLE ' + @repTableName
	exec sp_executesql @createTableQuery
	SET @createTableQuery = 'DROP TABLE ' + @repTableName
	exec sp_executesql @createTableQuery
END
SET @insertQuery = 'INSERT INTO cf_CommservSurveyQueries (QueryId, Name, Description, Details, SubmittedBy, AssignedTo, LastUpdatedBy, LastUpdatedTime, Status, Flags, Type, CollectScriptName, CollectScript, CollectScriptURL, ParserScriptName ,ParserScript, DataRetentionDays, DataRetentionIntervalHrs, DataTableName) VALUES(' + CAST(@queryId as NVARCHAR(100)) + ',N''' + @i_reportName + ''',N''' + @i_reportDescription + ''',N'''
	+ @i_reportDescription + ''',''CloudUsage@commvault.com'',''CloudUsage@commvault.com'',''CloudUsage@commvault.com'',GETUTCDATE(),''In Production'', ' + CAST(@i_flags as NVARCHAR(100)) + ',1,''CommservSurveyQuery_' + CAST(@queryId as NVARCHAR(100)) + '.sql'',''' + @i_sqlQuery + ''','''','''','''
	+ @repParseProcName + ''',' + CAST(@i_retention as NVARCHAR(100)) + ', ' + CAST((@i_retention * 24)as NVARCHAR(100)) + ', ''' + @repTableName + ''')'
WHILE LEN(@i_columnList) > 0
BEGIN
    IF PATINDEX('%;%',@i_columnList) > 0
    BEGIN
        SET @token = SUBSTRING(@i_columnList, 0, PATINDEX('%;%',@i_columnList))
        SET @i_columnList = SUBSTRING(@i_columnList, LEN(@token + ';') + 1,
                                                     LEN(@i_columnList))
    END
    ELSE
    BEGIN
        SET @token = @i_columnList
        SET @i_columnList = NULL
    END
    SET @token = LTRIM(RTRIM(@token))
    IF PATINDEX('%:%',@token) > 0
    BEGIN
        SET @varname = SUBSTRING(@token, 0, PATINDEX('%:%',@token))
        SET @vartype = SUBSTRING(@token, LEN(@varname + ':') + 1,
                                                     LEN(@token))
        SET @varname = LTRIM(RTRIM(@varname))
        SET @vartype = LTRIM(RTRIM(@vartype))
        insert into @repColsTable values (@varname, @vartype)
    END
END
SET @createTableQuery = 'CREATE TABLE [dbo].[' + @repTableName + '] ([SurveyResultId] [bigint] NOT NULL'
DECLARE columns CURSOR FOR
	SELECT columnName, columnType FROM @repColsTable
OPEN columns
	FETCH NEXT FROM columns INTO @varname, @vartype
WHILE @@FETCH_STATUS = 0
BEGIN
	SET @trimvarname = LTRIM(RTRIM(REPLACE(@varname,' ','')))
	SET @createTableQuery = @createTableQuery + ',[' + @trimvarname + '] ' + @vartype
	FETCH NEXT FROM columns INTO @varname, @vartype
END
CLOSE  columns
DEALLOCATE  columns
SET @createTableQuery = @createTableQuery + ', FOREIGN KEY (SurveyResultId) REFERENCES cf_CommservSurveyResults (CommservSurveyResults_ID) ON DELETE CASCADE);'
SET @createTableQuery = @createTableQuery + ' CREATE CLUSTERED INDEX ' + @repTableName + '_SurveyResultId_idx ON ' + @repTableName + ' (SurveyResultId);'
IF NOT EXISTS (SELECT 1
           FROM INFORMATION_SCHEMA.TABLES
           WHERE TABLE_TYPE = 'BASE TABLE'
           AND TABLE_NAME = @repTableName)
BEGIN
	exec sp_executesql @createTableQuery
END
exec sp_executesql @insertQuery
select @queryId, @repTableName
SET NOCOUNT OFF
GO

IF EXISTS (select * from GxQscripts where name = 'CreateMetricsReportQuery')
	delete from GxQscripts where name = 'CreateMetricsReportQuery'
GO

IF EXISTS (select * from GXDBVersions where aliasname='CreateMetricsReportQuery')
	delete from GXDBVersions where aliasname = 'CreateMetricsReportQuery'
GO

insert into GXDBVersions values(2, 'CreateMetricsReportQuery',  '00010006005800060000', 'CreateMetricsReportQuery', '00010006005800060000')
GO

