

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Sp/ParseAvgBkpThroughput.sp] ---------- 

-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Sp/ParseAvgBkpThroughput.sp,v $ $Id: ParseAvgBkpThroughput.sp,v 1.3.60.9 2020/12/17 02:52:35 dkraplanee Exp $";
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON


IF EXISTS (select * from sysobjects where name='ParseAvgBkpThroughput')
BEGIN
	print '>>> Drop Stored Procedure: ParseAvgBkpThroughput <<<'
	drop procedure ParseAvgBkpThroughput
END
IF EXISTS (select * from GxQscripts where name='ParseAvgBkpThroughput')
	delete from GxQscripts where name = 'ParseAvgBkpThroughput'
GO

IF EXISTS (select * from GXDBVersions where aliasname='ParseAvgBkpThroughput')
	delete from GXDBVersions where aliasname = 'ParseAvgBkpThroughput'
GO
print '... Creating Procedure: ParseAvgBkpThroughput'
GO
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON
GO
create procedure ParseAvgBkpThroughput
  @QueryId INTEGER,
  @ResultId BIGINT,
  @CSUniqueId INTEGER,
  @LogDateUTC DATETIME,
  @LogDate DATETIME,
  @LogLevel INTEGER = 0
AS
SET NOCOUNT ON 
  DECLARE @StartDate DATETIME = GETUTCDATE() 
  DECLARE @TempDate  DATETIME 
  DECLARE @Duration  INTEGER = 0 
  DECLARE @SkipOnErr INTEGER = 1 
  DECLARE @ErrorCode INTEGER = 0 
  DECLARE @ErrorMsg  NVARCHAR(MAX) 
  DECLARE @LogString NVARCHAR(MAX) 
  IF @LogLevel > 1 
  BEGIN 
  	SELECT @LogString = 'Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ') - started' 
  	INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET @LogString = '' 
  BEGIN TRY 
  	BEGIN TRANSACTION ParseAvgBkpThroughputTran 
  	SELECT @ErrorCode = @@ERROR
--  QUERY SPECIFIC CODE BEGIN --
DECLARE @ResultXml XML = (SELECT CollectedResults FROM cf_CommservSurveyResults WITH (NOLOCK) WHERE CommservSurveyResults_ID = @ResultId)
	IF 	@ErrorCode = 0
	BEGIN
		INSERT	INTO cf_SurveyAuxCopyThroughput (SurveyResultId, AppSizeGB, WriteTimeHr, IsDisk, JobsEndDate)
		SELECT	@ResultId,
				csInfo.n.value('@AppSizeGB', 'FLOAT'),
				csInfo.n.value('@WriteTimeHr', 'FLOAT'),
				csInfo.n.value('@IsDisk', 'INT'),
				csInfo.n.value('@EndDate', 'DATETIME')
		FROM	@ResultXml.nodes('/AuxCopyThroughput') AS csInfo(n)
		SELECT @ErrorCode = @@ERROR
	END
	IF 	@ErrorCode = 0
	BEGIN
		INSERT	INTO cf_SurveyAvgBkpThroughputV1 (CommServUniqueId, SurveyResultId, LogDateUTC, LogDate, AppSizeGB, WriteTimeHr, IsDisk, JobsEndDate)
		SELECT	@CSUniqueId,
				@ResultId,
				@LogDateUTC,
				@LogDate,
				csInfo.n.value('@AppSizeGB', 'FLOAT'),
				csInfo.n.value('@WriteTimeHr', 'FLOAT'),
				csInfo.n.value('@IsDisk', 'INT'),
				csInfo.n.value('@EndDate', 'DATETIME')
		FROM	@ResultXml.nodes('/AvgBkpThroughputInfo') AS csInfo(n)
		SELECT @ErrorCode = @@ERROR
	END
	IF 	@ErrorCode = 0
	BEGIN
		INSERT	INTO cf_SurveyBkpThroughputByAgentType (SurveyResultId, AppTypeId, JobsEndDate, AppSizeGB, WriteTime)
		SELECT	@ResultId,
				csInfo.n.value('@AppTypeId', 'INT'),
				csInfo.n.value('@EndDate', 'DATETIME'),
				csInfo.n.value('@AppSizeGB', 'FLOAT'),
				csInfo.n.value('@WriteTime', 'INT')
		FROM	@ResultXml.nodes('/BkpThroughputByAgent') AS csInfo(n)
		SELECT @ErrorCode = @@ERROR
	END
	IF 	@ErrorCode = 0
	BEGIN
		INSERT	INTO cf_SurveyBkpThroughputByStoragePolicy (SurveyResultId, PolicyId, PolicyName, JobsEndDate, AppSizeGB, WriteTime)
		SELECT	@ResultId,
				csInfo.n.value('@PolicyId', 'INT'),
				csInfo.n.value('@PolicyName', 'NVARCHAR(144)'),
				csInfo.n.value('@EndDate', 'DATETIME'),
				csInfo.n.value('@AppSizeGB', 'FLOAT'),
				csInfo.n.value('@WriteTime', 'INT')
		FROM	@ResultXml.nodes('/BkpThroughputByPolicy') AS csInfo(n)
		SELECT @ErrorCode = @@ERROR
	END
	IF 	@ErrorCode = 0
	BEGIN
		INSERT	INTO cf_SurveyRstThroughputByAgentType (SurveyResultId, AppTypeId, JobsEndDate, AppSizeGB, WriteTime)
		SELECT	@ResultId,
				csInfo.n.value('@AppTypeId', 'INT'),
				csInfo.n.value('@EndDate', 'DATETIME'),
				csInfo.n.value('@AppSizeGB', 'FLOAT'),
				csInfo.n.value('@WriteTime', 'INT')
		FROM	@ResultXml.nodes('/RstThroughputByAgent') AS csInfo(n)
		SELECT @ErrorCode = @@ERROR
	END
--  QUERY SPECIFIC CODE END --
IF @ErrorCode = 0 
  	BEGIN 
  		DECLARE	@ResultFlagsTbl TABLE (ResultId BIGINT, Flags INT) 
  		DECLARE	@LatestParsedResultId BIGINT = 0 
  		SELECT	@LatestParsedResultId = CommservSurveyResults_ID 
  		FROM	cf_CommservSurveyResults 
  		WHERE	QueryId = @QueryId AND CommcellIdNameMap_ID = @CSUniqueId AND Flags = 1 
  		SELECT @ErrorCode = @@ERROR 
  		IF @ErrorCode = 0 
  		BEGIN 
  			IF @LatestParsedResultId = 0 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 
  			ELSE IF @LatestParsedResultId < @ResultId 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 UNION SELECT @LatestParsedResultId, 0 
  			ELSE 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 0 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  		IF @ErrorCode = 0 
  		BEGIN 
  			UPDATE	R SET ShredStatus = 2, Flags = F.Flags, CollectedResults = NULL 
  			FROM	cf_CommservSurveyResults R 
  					INNER JOIN @ResultFlagsTbl F ON R.CommservSurveyResults_ID = F.ResultId 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  	END 
  	IF @ErrorCode = 0 AND XACT_STATE() = 1 
  	BEGIN 
  		COMMIT TRANSACTION ParseAvgBkpThroughputTran 
  		SELECT @ErrorCode = @@ERROR 
  	END 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	IF @ErrorCode = 0 AND @LogLevel > 1 
  		SET @LogString += ' - Completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  	ELSE IF @ErrorCode <> 0 AND @SkipOnErr = 0 
  		SET @LogString += ' - Failed to update status after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  	ELSE IF @ErrorCode <> 0 
  		SET @LogString += ' - Failed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  END TRY 
  BEGIN CATCH 
  	SELECT @ErrorCode = ERROR_NUMBER(), @ErrorMsg = ERROR_MESSAGE() 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	SET @LogString += ' - Exception in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20))+ ' ERROR MESSAGE: ' + ISNULL(@ErrorMsg, '') 
  END CATCH 
  IF @@TRANCOUNT > 0 
  BEGIN 
      SET @LogString += ' - Rollback uncommitted transaction after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
      SET @TempDate = GETUTCDATE() 
      ROLLBACK TRANSACTION 
      SET	@Duration = DATEDIFF(SS, @TempDate, GETUTCDATE()) 
      SET @LogString += ' - Rollback completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  END 
  IF @ErrorCode <> 0 AND @SkipOnErr > 0 
      UPDATE cf_CommservSurveyResults SET ShredStatus = 3 WHERE CommservSurveyResults_ID = @ResultId 
  IF @LogString <> '' 
  BEGIN 
      SET @LogString = ('Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ')' + @LogString) 
      INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET NOCOUNT OFF
GO

IF EXISTS (select * from GxQscripts where name = 'ParseAvgBkpThroughput')
	delete from GxQscripts where name = 'ParseAvgBkpThroughput'
GO

IF EXISTS (select * from GXDBVersions where aliasname='ParseAvgBkpThroughput')
	delete from GXDBVersions where aliasname = 'ParseAvgBkpThroughput'
GO

insert into GXDBVersions values(2, 'ParseAvgBkpThroughput',  '00010003006000090000', 'ParseAvgBkpThroughput', '00010003006000090000')
GO

