

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Sp/ParseBackupSchedules.sp] ---------- 

-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Sp/ParseBackupSchedules.sp,v $ $Id: ParseBackupSchedules.sp,v 1.8.14.6 2020/12/17 02:51:44 dkraplanee Exp $";
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON


IF EXISTS (select * from sysobjects where name='ParseBackupSchedules')
BEGIN
	print '>>> Drop Stored Procedure: ParseBackupSchedules <<<'
	drop procedure ParseBackupSchedules
END
IF EXISTS (select * from GxQscripts where name='ParseBackupSchedules')
	delete from GxQscripts where name = 'ParseBackupSchedules'
GO

IF EXISTS (select * from GXDBVersions where aliasname='ParseBackupSchedules')
	delete from GXDBVersions where aliasname = 'ParseBackupSchedules'
GO
print '... Creating Procedure: ParseBackupSchedules'
GO
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON
GO
create procedure ParseBackupSchedules
  @QueryId INTEGER,
  @ResultId BIGINT,
  @CSUniqueId INTEGER,
  @LogDateUTC DATETIME,
  @LogDate DATETIME,
  @LogLevel INTEGER = 0
AS
SET NOCOUNT ON 
  DECLARE @StartDate DATETIME = GETUTCDATE() 
  DECLARE @TempDate  DATETIME 
  DECLARE @Duration  INTEGER = 0 
  DECLARE @SkipOnErr INTEGER = 1 
  DECLARE @ErrorCode INTEGER = 0 
  DECLARE @ErrorMsg  NVARCHAR(MAX) 
  DECLARE @LogString NVARCHAR(MAX) 
  IF @LogLevel > 1 
  BEGIN 
  	SELECT @LogString = 'Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ') - started' 
  	INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET @LogString = '' 
  BEGIN TRY 
  	BEGIN TRANSACTION ParseBackupSchedulesTran 
  	SELECT @ErrorCode = @@ERROR
--  QUERY SPECIFIC CODE BEGIN --
IF 	@ErrorCode = 0
BEGIN
	DELETE cf_SurveyBackupSchedule WHERE CommservUniqueId = @CSUniqueId
	SELECT @ErrorCode = @@ERROR
END
IF 	@ErrorCode = 0
BEGIN
	INSERT INTO cf_SurveyBackupSchedule (
		CommservUniqueId, SchedulePolicy, ScheduleName, Disabled, SchedBackupType,
		SchedPattern, SchedInterval, SchedBackupDay, SchedBackupTime, SchedNextBackupTime,
		ClientGroupId, ClientId, AppTypeId, InstanceId, BackupsetId, AppId, AssocType, MaxRunningSec, Exclude)
	SELECT
		@CSUniqueId,
		csInfo.n.value('@schedulePolicy','NVARCHAR(256)'),
		csInfo.n.value('@scheduleName','NVARCHAR(256)'),
		csInfo.n.value('@disabled','INT'),
		csInfo.n.value('@schedBackupType','VARCHAR(32)'),
		csInfo.n.value('@schedPattern','VARCHAR(32)'),
		csInfo.n.value('@schedInterval','VARCHAR(32)'),
		csInfo.n.value('@schedBackupDay','VARCHAR(MAX)'),
		csInfo.n.value('@schedBackupTime','VARCHAR(12)'),
		csInfo.n.value('@schedNextBackupTime','DATETIME'),
		csInfo.n.value('@clientGroupId','INT'),
		csInfo.n.value('@clientId','INT'),
		csInfo.n.value('@appTypeId','INT'),
		csInfo.n.value('@instanceId','INT'),
		csInfo.n.value('@backupsetId','INT'),
		csInfo.n.value('@appId','INT'),
		ISNULL(csInfo.n.value('@assocType','INT'), 0),
		ISNULL(csInfo.n.value('@maxRunningSec','INT'), -1),
		ISNULL(csInfo.n.value('@exclude','INT'), 0)
	FROM
		cf_CommservSurveyResults
		CROSS APPLY CollectedResults.nodes('Schedule') AS csInfo(n)
	WHERE
		CommservSurveyResults_ID = @ResultId
	SELECT @ErrorCode = @@ERROR
END
IF 	@ErrorCode = 0
BEGIN
	DELETE cf_SurveyBackupMaxRunningTime WHERE CommservUniqueId = @CSUniqueId
	SELECT @ErrorCode = @@ERROR
END
IF 	@ErrorCode = 0
BEGIN
	INSERT INTO cf_SurveyBackupMaxRunningTime (
		CommservUniqueId, AppTypeId, MaxRunningSec)
	SELECT
		@CSUniqueId,
		csInfo.n.value('@appTypeId','INT'),
		csInfo.n.value('@maxRunningSec','INT')
	FROM
		cf_CommservSurveyResults
		CROSS APPLY CollectedResults.nodes('MaxRunningTime') AS csInfo(n)
	WHERE
		CommservSurveyResults_ID = @ResultId
	SELECT @ErrorCode = @@ERROR
END
IF 	@ErrorCode = 0
BEGIN
	DELETE cf_SurveyHoliday WHERE CommservUniqueId = @CSUniqueId
	SELECT @ErrorCode = @@ERROR
END
IF 	@ErrorCode = 0
BEGIN
	INSERT INTO cf_SurveyHoliday (
		CommservUniqueId, StartYear, StartMonth, StartDay, StartHour, StartMinute, StartSecond,
		EndYear, EndMonth, EndDay, EndHour, EndMinute, EndSecond, Description, ClientGroupId, ClientId)
	SELECT
		@CSUniqueId,
		csInfo.n.value('@startYear','INT'),
		csInfo.n.value('@startMonth','INT'),
		csInfo.n.value('@startDay','INT'),
		csInfo.n.value('@startHour','INT'),
		csInfo.n.value('@startMinute','INT'),
		csInfo.n.value('@startSecond','INT'),
		csInfo.n.value('@endYear','INT'),
		csInfo.n.value('@endMonth','INT'),
		csInfo.n.value('@endDay','INT'),
		csInfo.n.value('@endHour','INT'),
		csInfo.n.value('@endMinute','INT'),
		csInfo.n.value('@endSecond','INT'),
		csInfo.n.value('@description','NVARCHAR(80)'),
		csInfo.n.value('@clientGroupId','INT'),
		csInfo.n.value('@clientId','INT')
	FROM
		cf_CommservSurveyResults
		CROSS APPLY CollectedResults.nodes('Holiday') AS csInfo(n)
	WHERE
		CommservSurveyResults_ID = @ResultId
	SELECT @ErrorCode = @@ERROR
END
--  QUERY SPECIFIC CODE END --
IF @ErrorCode = 0 
  	BEGIN 
  		DECLARE	@ResultFlagsTbl TABLE (ResultId BIGINT, Flags INT) 
  		DECLARE	@LatestParsedResultId BIGINT = 0 
  		SELECT	@LatestParsedResultId = CommservSurveyResults_ID 
  		FROM	cf_CommservSurveyResults 
  		WHERE	QueryId = @QueryId AND CommcellIdNameMap_ID = @CSUniqueId AND Flags = 1 
  		SELECT @ErrorCode = @@ERROR 
  		IF @ErrorCode = 0 
  		BEGIN 
  			IF @LatestParsedResultId = 0 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 
  			ELSE IF @LatestParsedResultId < @ResultId 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 UNION SELECT @LatestParsedResultId, 0 
  			ELSE 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 0 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  		IF @ErrorCode = 0 
  		BEGIN 
  			UPDATE	R SET ShredStatus = 2, Flags = F.Flags, CollectedResults = NULL 
  			FROM	cf_CommservSurveyResults R 
  					INNER JOIN @ResultFlagsTbl F ON R.CommservSurveyResults_ID = F.ResultId 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  	END 
  	IF @ErrorCode = 0 AND XACT_STATE() = 1 
  	BEGIN 
  		COMMIT TRANSACTION ParseBackupSchedulesTran 
  		SELECT @ErrorCode = @@ERROR 
  	END 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	IF @ErrorCode = 0 AND @LogLevel > 1 
  		SET @LogString += ' - Completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  	ELSE IF @ErrorCode <> 0 AND @SkipOnErr = 0 
  		SET @LogString += ' - Failed to update status after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  	ELSE IF @ErrorCode <> 0 
  		SET @LogString += ' - Failed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  END TRY 
  BEGIN CATCH 
  	SELECT @ErrorCode = ERROR_NUMBER(), @ErrorMsg = ERROR_MESSAGE() 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	SET @LogString += ' - Exception in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20))+ ' ERROR MESSAGE: ' + ISNULL(@ErrorMsg, '') 
  END CATCH 
  IF @@TRANCOUNT > 0 
  BEGIN 
      SET @LogString += ' - Rollback uncommitted transaction after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
      SET @TempDate = GETUTCDATE() 
      ROLLBACK TRANSACTION 
      SET	@Duration = DATEDIFF(SS, @TempDate, GETUTCDATE()) 
      SET @LogString += ' - Rollback completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  END 
  IF @ErrorCode <> 0 AND @SkipOnErr > 0 
      UPDATE cf_CommservSurveyResults SET ShredStatus = 3 WHERE CommservSurveyResults_ID = @ResultId 
  IF @LogString <> '' 
  BEGIN 
      SET @LogString = ('Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ')' + @LogString) 
      INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET NOCOUNT OFF
GO

IF EXISTS (select * from GxQscripts where name = 'ParseBackupSchedules')
	delete from GxQscripts where name = 'ParseBackupSchedules'
GO

IF EXISTS (select * from GXDBVersions where aliasname='ParseBackupSchedules')
	delete from GXDBVersions where aliasname = 'ParseBackupSchedules'
GO

insert into GXDBVersions values(2, 'ParseBackupSchedules',  '00010008001400060000', 'ParseBackupSchedules', '00010008001400060000')
GO

