

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Sp/ParseClientStatisticsSurvey.sp] ---------- 

-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Sp/ParseClientStatisticsSurvey.sp,v $ $Id: ParseClientStatisticsSurvey.sp,v 1.2.60.7 2020/12/17 02:51:02 dkraplanee Exp $";
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON


IF EXISTS (select * from sysobjects where name='ParseClientStatisticsSurvey')
BEGIN
	print '>>> Drop Stored Procedure: ParseClientStatisticsSurvey <<<'
	drop procedure ParseClientStatisticsSurvey
END
IF EXISTS (select * from GxQscripts where name='ParseClientStatisticsSurvey')
	delete from GxQscripts where name = 'ParseClientStatisticsSurvey'
GO

IF EXISTS (select * from GXDBVersions where aliasname='ParseClientStatisticsSurvey')
	delete from GXDBVersions where aliasname = 'ParseClientStatisticsSurvey'
GO
print '... Creating Procedure: ParseClientStatisticsSurvey'
GO
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON
GO
create procedure ParseClientStatisticsSurvey
  @QueryId INTEGER,
  @ResultId BIGINT,
  @CSUniqueId INTEGER,
  @LogDateUTC DATETIME,
  @LogDate DATETIME,
  @LogLevel INTEGER = 0
AS
SET NOCOUNT ON 
  DECLARE @StartDate DATETIME = GETUTCDATE() 
  DECLARE @TempDate  DATETIME 
  DECLARE @Duration  INTEGER = 0 
  DECLARE @SkipOnErr INTEGER = 1 
  DECLARE @ErrorCode INTEGER = 0 
  DECLARE @ErrorMsg  NVARCHAR(MAX) 
  DECLARE @LogString NVARCHAR(MAX) 
  IF @LogLevel > 1 
  BEGIN 
  	SELECT @LogString = 'Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ') - started' 
  	INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET @LogString = '' 
  BEGIN TRY 
  	BEGIN TRANSACTION ParseClientStatisticsSurveyTran 
  	SELECT @ErrorCode = @@ERROR
--  QUERY SPECIFIC CODE BEGIN --
DECLARE @ResultXml XML = (SELECT CollectedResults FROM cf_CommservSurveyResults WITH (NOLOCK) WHERE CommservSurveyResults_ID = @ResultId)
IF 	@ErrorCode = 0
BEGIN
	INSERT INTO cf_SurveyClientStatisticsInfo (
		CommServUniqueId, SurveyResultId, LogDateUTC, LogDate,
		TotalClients, TotalLaptops, TotalActiveClients, TotalUninstalledClients, TotalDeconfiguredClients, RestoreonlyClients,
		UninstalledSRMAgentlessClients, UninstalledVirtualServerDiscoveredClients, UninstalledProxyforExchangeClients,
		UninstalledDataClassificationInstalledClients, UninstalledDB2DPFClients, UninstalledORACLERacClients,
		UninstalledDAGClients, UninstalledEDCdiscoveredClients, UninstalledOtherClients, TotalActiveVMs)
	SELECT
		@CSUniqueId,
		@ResultId,
		@LogDateUTC,
		@LogDate,
		csInfo.n.value('@total', 'INTEGER'),
		csInfo.n.value('LAPTOPCLIENTS[1]/@totalclients', 'INTEGER'),
		csInfo.n.value('INSTALLED[1]/@totalClients', 'INTEGER'),
		csInfo.n.value('UNINSTALLED[1]/@totalclient', 'INTEGER'),
		csInfo.n.value('DECONFIGURED[1]/@totalclient', 'INTEGER'),
		csInfo.n.value('DECONFIGURED[1]/@restoreonlyclients', 'INTEGER'),
		csInfo.n.value('UNINSTALLED[1]/@MiniSRMAgent', 'INTEGER'),
		csInfo.n.value('UNINSTALLED[1]/@VirtualServerDiscoveredClients', 'INTEGER'),
		csInfo.n.value('UNINSTALLED[1]/@ProxyforExchange', 'INTEGER'),
		csInfo.n.value('UNINSTALLED[1]/@DataClassificationInstalledonClient', 'INTEGER'),
		csInfo.n.value('UNINSTALLED[1]/@DB2DPF', 'INTEGER'),
		csInfo.n.value('UNINSTALLED[1]/@ORACLERac', 'INTEGER'),
		csInfo.n.value('UNINSTALLED[1]/@DAG', 'INTEGER'),
		csInfo.n.value('UNINSTALLED[1]/@EDCdiscoveredClient', 'INTEGER'),
		csInfo.n.value('UNINSTALLED[1]/@others', 'INTEGER'),
		csInfo.n.value('UNINSTALLED[1]/@ActiveDiscoveredVMs', 'INTEGER')
	FROM
		@ResultXml.nodes('/CLIENTS') AS csInfo(n)
	SELECT @ErrorCode = @@ERROR
END
--  QUERY SPECIFIC CODE END --
IF @ErrorCode = 0 
  	BEGIN 
  		DECLARE	@ResultFlagsTbl TABLE (ResultId BIGINT, Flags INT) 
  		DECLARE	@LatestParsedResultId BIGINT = 0 
  		SELECT	@LatestParsedResultId = CommservSurveyResults_ID 
  		FROM	cf_CommservSurveyResults 
  		WHERE	QueryId = @QueryId AND CommcellIdNameMap_ID = @CSUniqueId AND Flags = 1 
  		SELECT @ErrorCode = @@ERROR 
  		IF @ErrorCode = 0 
  		BEGIN 
  			IF @LatestParsedResultId = 0 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 
  			ELSE IF @LatestParsedResultId < @ResultId 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 UNION SELECT @LatestParsedResultId, 0 
  			ELSE 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 0 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  		IF @ErrorCode = 0 
  		BEGIN 
  			UPDATE	R SET ShredStatus = 2, Flags = F.Flags, CollectedResults = NULL 
  			FROM	cf_CommservSurveyResults R 
  					INNER JOIN @ResultFlagsTbl F ON R.CommservSurveyResults_ID = F.ResultId 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  	END 
  	IF @ErrorCode = 0 AND XACT_STATE() = 1 
  	BEGIN 
  		COMMIT TRANSACTION ParseClientStatisticsSurveyTran 
  		SELECT @ErrorCode = @@ERROR 
  	END 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	IF @ErrorCode = 0 AND @LogLevel > 1 
  		SET @LogString += ' - Completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  	ELSE IF @ErrorCode <> 0 AND @SkipOnErr = 0 
  		SET @LogString += ' - Failed to update status after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  	ELSE IF @ErrorCode <> 0 
  		SET @LogString += ' - Failed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  END TRY 
  BEGIN CATCH 
  	SELECT @ErrorCode = ERROR_NUMBER(), @ErrorMsg = ERROR_MESSAGE() 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	SET @LogString += ' - Exception in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20))+ ' ERROR MESSAGE: ' + ISNULL(@ErrorMsg, '') 
  END CATCH 
  IF @@TRANCOUNT > 0 
  BEGIN 
      SET @LogString += ' - Rollback uncommitted transaction after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
      SET @TempDate = GETUTCDATE() 
      ROLLBACK TRANSACTION 
      SET	@Duration = DATEDIFF(SS, @TempDate, GETUTCDATE()) 
      SET @LogString += ' - Rollback completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  END 
  IF @ErrorCode <> 0 AND @SkipOnErr > 0 
      UPDATE cf_CommservSurveyResults SET ShredStatus = 3 WHERE CommservSurveyResults_ID = @ResultId 
  IF @LogString <> '' 
  BEGIN 
      SET @LogString = ('Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ')' + @LogString) 
      INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET NOCOUNT OFF
GO

IF EXISTS (select * from GxQscripts where name = 'ParseClientStatisticsSurvey')
	delete from GxQscripts where name = 'ParseClientStatisticsSurvey'
GO

IF EXISTS (select * from GXDBVersions where aliasname='ParseClientStatisticsSurvey')
	delete from GXDBVersions where aliasname = 'ParseClientStatisticsSurvey'
GO

insert into GXDBVersions values(2, 'ParseClientStatisticsSurvey',  '00010002006000070000', 'ParseClientStatisticsSurvey', '00010002006000070000')
GO

