

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Sp/ParseDATroubleshootingInfo.sp] ---------- 

-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Sp/ParseDATroubleshootingInfo.sp,v $ $Id: ParseDATroubleshootingInfo.sp,v 1.1.2.2 2020/12/17 02:50:56 dkraplanee Exp $";
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON


IF EXISTS (select * from sysobjects where name='ParseDATroubleshootingInfo')
BEGIN
	print '>>> Drop Stored Procedure: ParseDATroubleshootingInfo <<<'
	drop procedure ParseDATroubleshootingInfo
END
IF EXISTS (select * from GxQscripts where name='ParseDATroubleshootingInfo')
	delete from GxQscripts where name = 'ParseDATroubleshootingInfo'
GO

IF EXISTS (select * from GXDBVersions where aliasname='ParseDATroubleshootingInfo')
	delete from GXDBVersions where aliasname = 'ParseDATroubleshootingInfo'
GO
print '... Creating Procedure: ParseDATroubleshootingInfo'
GO
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON
GO
create procedure ParseDATroubleshootingInfo
  @QueryId INTEGER,
  @ResultId BIGINT,
  @CSUniqueId INTEGER,
  @LogDateUTC DATETIME,
  @LogDate DATETIME,
  @LogLevel INTEGER = 0
AS
SET NOCOUNT ON 
  DECLARE @StartDate DATETIME = GETUTCDATE() 
  DECLARE @TempDate  DATETIME 
  DECLARE @Duration  INTEGER = 0 
  DECLARE @SkipOnErr INTEGER = 1 
  DECLARE @ErrorCode INTEGER = 0 
  DECLARE @ErrorMsg  NVARCHAR(MAX) 
  DECLARE @LogString NVARCHAR(MAX) 
  IF @LogLevel > 1 
  BEGIN 
  	SELECT @LogString = 'Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ') - started' 
  	INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET @LogString = '' 
  BEGIN TRY 
  	BEGIN TRANSACTION ParseDATroubleshootingInfoTran 
  	SELECT @ErrorCode = @@ERROR
--  QUERY SPECIFIC CODE BEGIN --
DECLARE @ResultXml XML = (SELECT CollectedResults FROM cf_CommservSurveyResults WITH (NOLOCK) WHERE CommservSurveyResults_ID = @ResultId)
CREATE TABLE #DATroubleshootingInfo
(
	SurveyResultId		BIGINT NOT NULL,
	LibraryId			INT,
	MountPathId			INT,
	MountPathName		NVARCHAR(256),
	PendingDeletes		INT,
	ProblemFlag			BIGINT,
	JobRetentionFlag	BIGINT,
	ProblemDescription	NVARCHAR(MAX),
	Recommendation		NVARCHAR(MAX),
	Doclink				NVARCHAR(MAX),
	Severity			INT
)
IF 	@ErrorCode = 0
BEGIN
	INSERT INTO #DATroubleshootingInfo (
		SurveyResultId, LibraryId, MountPathId, MountPathName,
		PendingDeletes, ProblemFlag, JobRetentionFlag, ProblemDescription, Recommendation, Doclink, Severity)
	SELECT DISTINCT
		@ResultId,
		csInfo.n.value('@LibraryId', 'INT'),
		csInfo.n.value('@MountPathId', 'INT'),
		csInfo.n.value('@MountPathName', 'NVARCHAR(256)'),
		csInfo.n.value('@PendingDeletes', 'INT'),
		csInfo.n.value('@ProblemFlag', 'BIGINT'),
		csInfo.n.value('@JobRetentionFlag', 'BIGINT'),
		csInfo.n.value('@ProblemDescription', 'NVARCHAR(MAX)'),
		csInfo.n.value('@Recommendation', 'NVARCHAR(MAX)'),
		csInfo.n.value('@Doclink', 'NVARCHAR(MAX)'),
		csInfo.n.value('@Severity', 'INT')
	FROM
		@ResultXml.nodes('/DATroubleshootingInfo/Info') AS csInfo(n)
	SELECT @ErrorCode = @@ERROR
END
IF 	@ErrorCode = 0 AND EXISTS (SELECT 1 FROM #DATroubleshootingInfo)
BEGIN
	INSERT INTO cf_SurveyDATroubleshootingInfo (
			SurveyResultId, LibraryId, MountPathId, MountPathName,
			PendingDeletes, ProblemFlag, JobRetentionFlag, ProblemDescription, Recommendation, Doclink, Severity)
	SELECT	SurveyResultId, LibraryId, MountPathId, MountPathName,
			PendingDeletes, ProblemFlag, JobRetentionFlag, ProblemDescription, Recommendation, Doclink, Severity
	FROM	#DATroubleshootingInfo
	SELECT @ErrorCode = @@ERROR
END
DROP TABLE #DATroubleshootingInfo
--  QUERY SPECIFIC CODE END --
IF @ErrorCode = 0 
  	BEGIN 
  		DECLARE	@ResultFlagsTbl TABLE (ResultId BIGINT, Flags INT) 
  		DECLARE	@LatestParsedResultId BIGINT = 0 
  		SELECT	@LatestParsedResultId = CommservSurveyResults_ID 
  		FROM	cf_CommservSurveyResults 
  		WHERE	QueryId = @QueryId AND CommcellIdNameMap_ID = @CSUniqueId AND Flags = 1 
  		SELECT @ErrorCode = @@ERROR 
  		IF @ErrorCode = 0 
  		BEGIN 
  			IF @LatestParsedResultId = 0 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 
  			ELSE IF @LatestParsedResultId < @ResultId 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 UNION SELECT @LatestParsedResultId, 0 
  			ELSE 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 0 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  		IF @ErrorCode = 0 
  		BEGIN 
  			UPDATE	R SET ShredStatus = 2, Flags = F.Flags, CollectedResults = NULL 
  			FROM	cf_CommservSurveyResults R 
  					INNER JOIN @ResultFlagsTbl F ON R.CommservSurveyResults_ID = F.ResultId 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  	END 
  	IF @ErrorCode = 0 AND XACT_STATE() = 1 
  	BEGIN 
  		COMMIT TRANSACTION ParseDATroubleshootingInfoTran 
  		SELECT @ErrorCode = @@ERROR 
  	END 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	IF @ErrorCode = 0 AND @LogLevel > 1 
  		SET @LogString += ' - Completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  	ELSE IF @ErrorCode <> 0 AND @SkipOnErr = 0 
  		SET @LogString += ' - Failed to update status after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  	ELSE IF @ErrorCode <> 0 
  		SET @LogString += ' - Failed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  END TRY 
  BEGIN CATCH 
  	SELECT @ErrorCode = ERROR_NUMBER(), @ErrorMsg = ERROR_MESSAGE() 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	SET @LogString += ' - Exception in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20))+ ' ERROR MESSAGE: ' + ISNULL(@ErrorMsg, '') 
  END CATCH 
  IF @@TRANCOUNT > 0 
  BEGIN 
      SET @LogString += ' - Rollback uncommitted transaction after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
      SET @TempDate = GETUTCDATE() 
      ROLLBACK TRANSACTION 
      SET	@Duration = DATEDIFF(SS, @TempDate, GETUTCDATE()) 
      SET @LogString += ' - Rollback completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  END 
  IF @ErrorCode <> 0 AND @SkipOnErr > 0 
      UPDATE cf_CommservSurveyResults SET ShredStatus = 3 WHERE CommservSurveyResults_ID = @ResultId 
  IF @LogString <> '' 
  BEGIN 
      SET @LogString = ('Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ')' + @LogString) 
      INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET NOCOUNT OFF
GO

IF EXISTS (select * from GxQscripts where name = 'ParseDATroubleshootingInfo')
	delete from GxQscripts where name = 'ParseDATroubleshootingInfo'
GO

IF EXISTS (select * from GXDBVersions where aliasname='ParseDATroubleshootingInfo')
	delete from GXDBVersions where aliasname = 'ParseDATroubleshootingInfo'
GO

insert into GXDBVersions values(2, 'ParseDATroubleshootingInfo',  '00010001000200020000', 'ParseDATroubleshootingInfo', '00010001000200020000')
GO

