

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Sp/ParseFallenBehindBackupCopies.sp] ---------- 

-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Sp/ParseFallenBehindBackupCopies.sp,v $ $Id: ParseFallenBehindBackupCopies.sp,v 1.1.2.7 2020/12/17 02:53:29 dkraplanee Exp $";
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON


IF EXISTS (select * from sysobjects where name='ParseFallenBehindBackupCopies')
BEGIN
	print '>>> Drop Stored Procedure: ParseFallenBehindBackupCopies <<<'
	drop procedure ParseFallenBehindBackupCopies
END
IF EXISTS (select * from GxQscripts where name='ParseFallenBehindBackupCopies')
	delete from GxQscripts where name = 'ParseFallenBehindBackupCopies'
GO

IF EXISTS (select * from GXDBVersions where aliasname='ParseFallenBehindBackupCopies')
	delete from GXDBVersions where aliasname = 'ParseFallenBehindBackupCopies'
GO
print '... Creating Procedure: ParseFallenBehindBackupCopies'
GO
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON
GO
create procedure ParseFallenBehindBackupCopies
  @QueryId INTEGER,
  @ResultId BIGINT,
  @CSUniqueId INTEGER,
  @LogDateUTC DATETIME,
  @LogDate DATETIME,
  @LogLevel INTEGER = 0
AS
SET NOCOUNT ON 
  DECLARE @StartDate DATETIME = GETUTCDATE() 
  DECLARE @TempDate  DATETIME 
  DECLARE @Duration  INTEGER = 0 
  DECLARE @SkipOnErr INTEGER = 1 
  DECLARE @ErrorCode INTEGER = 0 
  DECLARE @ErrorMsg  NVARCHAR(MAX) 
  DECLARE @LogString NVARCHAR(MAX) 
  IF @LogLevel > 1 
  BEGIN 
  	SELECT @LogString = 'Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ') - started' 
  	INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET @LogString = '' 
  BEGIN TRY 
  	BEGIN TRANSACTION ParseFallenBehindBkpCopiesTran 
  	SELECT @ErrorCode = @@ERROR
--  QUERY SPECIFIC CODE BEGIN --
DECLARE @ResultXml XML = (SELECT CollectedResults FROM cf_CommservSurveyResults WITH (NOLOCK) WHERE CommservSurveyResults_ID = @ResultId)
IF OBJECT_ID('tempdb.dbo.#SurveyFallenBehindCopies') IS NOT NULL DROP TABLE #SurveyFallenBehindCopies
CREATE TABLE #SurveyFallenBehindCopies (CommservUniqueId int, JobId int, SubclientId int, CopyId int, JobEndDateUTC bigint, isNewJob int)
IF 	@ErrorCode = 0
BEGIN
	INSERT INTO #SurveyFallenBehindCopies
        (CommservUniqueId
        ,[JobId]
        ,[SubclientId]
        ,[CopyId]
        ,[JobEndDateUTC]
        ,[IsNewJob]
		)
	SELECT
		@CSUniqueId,
		csInfo.job.value('@id', 'INT'),
		csInfo.job.value('@appid', 'INT'),
		csInfo.job.value('@copy', 'INT'),
		csInfo.job.value('@enddate', 'BIGINT'),
		csInfo.job.value('@isnew', 'INT')
	FROM
		@ResultXml.nodes('/FallenBehindBackupCopies/Job') AS csInfo(job)
	SELECT @ErrorCode = @@ERROR
END
IF 	@ErrorCode = 0
BEGIN
	--Deleting jobs that are not fallen behind anymore.
	DELETE FROM F
	FROM cf_SurveyFallenBehindBackupCopies F LEFT OUTER JOIN #SurveyFallenBehindCopies T
		ON F.CommservUniqueId = T.CommservUniqueId AND F.JobId = T.JobId
	WHERE F.CommservUniqueId = @CSUniqueId AND T.CommservUniqueId IS NULL
	SELECT @ErrorCode = @@ERROR
END
IF 	@ErrorCode = 0
BEGIN
	MERGE cf_SurveyFallenBehindBackupCopies AS F
	USING #SurveyFallenBehindCopies AS T
	ON F.CommservUniqueId = T.CommservUniqueId AND F.JobId = T.JobId
	WHEN NOT MATCHED AND IsNewJob = 1 THEN
	INSERT (CommservUniqueId, JobId, SubclientId, CopyId, JobEndDateUTC)
	VALUES (T.CommservUniqueId, T.JobId, T.SubclientId, T.CopyId, T.JobEndDateUTC);
	SELECT @ErrorCode = @@ERROR
END
--  QUERY SPECIFIC CODE END --
IF @ErrorCode = 0 
  	BEGIN 
  		DECLARE	@ResultFlagsTbl TABLE (ResultId BIGINT, Flags INT) 
  		DECLARE	@LatestParsedResultId BIGINT = 0 
  		SELECT	@LatestParsedResultId = CommservSurveyResults_ID 
  		FROM	cf_CommservSurveyResults 
  		WHERE	QueryId = @QueryId AND CommcellIdNameMap_ID = @CSUniqueId AND Flags = 1 
  		SELECT @ErrorCode = @@ERROR 
  		IF @ErrorCode = 0 
  		BEGIN 
  			IF @LatestParsedResultId = 0 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 
  			ELSE IF @LatestParsedResultId < @ResultId 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 UNION SELECT @LatestParsedResultId, 0 
  			ELSE 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 0 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  		IF @ErrorCode = 0 
  		BEGIN 
  			UPDATE	R SET ShredStatus = 2, Flags = F.Flags, CollectedResults = NULL 
  			FROM	cf_CommservSurveyResults R 
  					INNER JOIN @ResultFlagsTbl F ON R.CommservSurveyResults_ID = F.ResultId 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  	END 
  	IF @ErrorCode = 0 AND XACT_STATE() = 1 
  	BEGIN 
  		COMMIT TRANSACTION ParseFallenBehindBkpCopiesTran 
  		SELECT @ErrorCode = @@ERROR 
  	END 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	IF @ErrorCode = 0 AND @LogLevel > 1 
  		SET @LogString += ' - Completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  	ELSE IF @ErrorCode <> 0 AND @SkipOnErr = 0 
  		SET @LogString += ' - Failed to update status after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  	ELSE IF @ErrorCode <> 0 
  		SET @LogString += ' - Failed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  END TRY 
  BEGIN CATCH 
  	SELECT @ErrorCode = ERROR_NUMBER(), @ErrorMsg = ERROR_MESSAGE() 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	SET @LogString += ' - Exception in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20))+ ' ERROR MESSAGE: ' + ISNULL(@ErrorMsg, '') 
  END CATCH 
  IF @@TRANCOUNT > 0 
  BEGIN 
      SET @LogString += ' - Rollback uncommitted transaction after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
      SET @TempDate = GETUTCDATE() 
      ROLLBACK TRANSACTION 
      SET	@Duration = DATEDIFF(SS, @TempDate, GETUTCDATE()) 
      SET @LogString += ' - Rollback completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  END 
  IF @ErrorCode <> 0 AND @SkipOnErr > 0 
      UPDATE cf_CommservSurveyResults SET ShredStatus = 3 WHERE CommservSurveyResults_ID = @ResultId 
  IF @LogString <> '' 
  BEGIN 
      SET @LogString = ('Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ')' + @LogString) 
      INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET NOCOUNT OFF
GO

IF EXISTS (select * from GxQscripts where name = 'ParseFallenBehindBackupCopies')
	delete from GxQscripts where name = 'ParseFallenBehindBackupCopies'
GO

IF EXISTS (select * from GXDBVersions where aliasname='ParseFallenBehindBackupCopies')
	delete from GXDBVersions where aliasname = 'ParseFallenBehindBackupCopies'
GO

insert into GXDBVersions values(2, 'ParseFallenBehindBackupCopies',  '00010001000200070000', 'ParseFallenBehindBackupCopies', '00010001000200070000')
GO

