

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Sp/ParseFallenBehindCopies.sp] ---------- 

-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Sp/ParseFallenBehindCopies.sp,v $ $Id: ParseFallenBehindCopies.sp,v 1.3.60.12 2020/12/17 02:49:41 dkraplanee Exp $";
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON


IF EXISTS (select * from sysobjects where name='ParseFallenBehindCopies')
BEGIN
	print '>>> Drop Stored Procedure: ParseFallenBehindCopies <<<'
	drop procedure ParseFallenBehindCopies
END
IF EXISTS (select * from GxQscripts where name='ParseFallenBehindCopies')
	delete from GxQscripts where name = 'ParseFallenBehindCopies'
GO

IF EXISTS (select * from GXDBVersions where aliasname='ParseFallenBehindCopies')
	delete from GXDBVersions where aliasname = 'ParseFallenBehindCopies'
GO
print '... Creating Procedure: ParseFallenBehindCopies'
GO
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON
GO
create procedure ParseFallenBehindCopies
  @QueryId INTEGER,
  @ResultId BIGINT,
  @CSUniqueId INTEGER,
  @LogDateUTC DATETIME,
  @LogDate DATETIME,
  @LogLevel INTEGER = 0
AS
SET NOCOUNT ON 
  DECLARE @StartDate DATETIME = GETUTCDATE() 
  DECLARE @TempDate  DATETIME 
  DECLARE @Duration  INTEGER = 0 
  DECLARE @SkipOnErr INTEGER = 1 
  DECLARE @ErrorCode INTEGER = 0 
  DECLARE @ErrorMsg  NVARCHAR(MAX) 
  DECLARE @LogString NVARCHAR(MAX) 
  IF @LogLevel > 1 
  BEGIN 
  	SELECT @LogString = 'Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ') - started' 
  	INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET @LogString = '' 
  BEGIN TRY 
  	BEGIN TRANSACTION ParseFallenBehindCopiesTran 
  	SELECT @ErrorCode = @@ERROR
--  QUERY SPECIFIC CODE BEGIN --
IF 	@ErrorCode = 0
BEGIN
	INSERT INTO [cf_SurveyFallenBehindCopies]
        ([CopyId]
        ,[SurveyResultId]
        ,[FallenBehindDays]
        ,[JobsToCopyCount]
        ,[OldestJobId]
        ,[OldestJobStartTime]
        ,[TotalToBeCopiedJobsApplicationSizeGB]
        ,[EstTotalToBeCopiedJobsMediaSizeGB]
        ,[EstCompletionDateForAllData]
		,[AvgAuxCopyJobThroughput]
		,[ActiveJobId]
		,[ActiveJobStartTime]
		,[ActiveJobState]
		,[ActiveJobProgress]
		,[ActiveJobDelayReason]
		,[AuxCopyScheduled]
		,[AppSizeGBCopiedIn24Hr]
		,[MediaSizeGBCopiedIn24Hr]
		,[AuxCopyAlertGB]
		,[AuxCopyAlertDays]
		,[FallenBehindJobCount]
		,[FallenBehindAppSizeMB]
		,[CorruptedJobsCountOnSrcCopy]
		)
	SELECT
		csInfo.n.value('@CopyId', 'INT'),
		CommservSurveyResults_ID,
		csInfo.n.value('@FallenBehindDays', 'int'),
		csInfo.n.value('@JobsToCopyCount', 'int'),
		csInfo.n.value('@OldestJobId', 'int'),
		csInfo.n.value('@OldestJobStartTime', 'datetime'),
		ISNULL(csInfo.n.value('@TotalToBeCopiedJobsApplicationSizeGB', 'FLOAT'), 0),
		ISNULL(csInfo.n.value('@EstTotalToBeCopiedJobsMediaSizeGB', 'FLOAT'), 0),
		ISNULL(csInfo.n.value('@EstCompletionDateForAllData', 'BIGINT'), -1),
		ISNULL(csInfo.n.value('@AvgAuxCopyJobThroughput', 'FLOAT'), -1),
		csInfo.n.value('@ActiveJobId', 'INT'),
		csInfo.n.value('@ActiveJobStartTime', 'DATETIME'),
		csInfo.n.value('@ActiveJobState', 'VARCHAR(255)'),
		csInfo.n.value('@ActiveJobProgress', 'INT'),
		csInfo.n.value('@ActiveJobDelayReason', 'NVARCHAR(2048)'),
		csInfo.n.value('@AuxCopyScheduled', 'INT'),
		csInfo.n.value('@AppSizeGBCopiedIn24Hr', 'FLOAT'),
		csInfo.n.value('@MediaSizeGBCopiedIn24Hr', 'FLOAT'),
		csInfo.n.value('@AuxCopyAlertGB', 'INT'),
		csInfo.n.value('@AuxCopyAlertDays', 'INT'),
		csInfo.n.value('@FallenBehindJobCount', 'INT'),
		csInfo.n.value('@FallenBehindAppSizeMB', 'BIGINT'),
		ISNULL(csInfo.n.value('@CorruptedJobsCountOnSrcCopy', 'INT'), 0)
	FROM
		cf_CommservSurveyResults
		CROSS APPLY CollectedResults.nodes('/FallenBehindCopy/DashCopy') AS csInfo(n)
	WHERE
		CommservSurveyResults_ID = @ResultId
		AND csInfo.n.value('@CopyId', 'INT') IS NOT NULL
	SELECT @ErrorCode = @@ERROR
END
--  QUERY SPECIFIC CODE END --
IF @ErrorCode = 0 
  	BEGIN 
  		DECLARE	@ResultFlagsTbl TABLE (ResultId BIGINT, Flags INT) 
  		DECLARE	@LatestParsedResultId BIGINT = 0 
  		SELECT	@LatestParsedResultId = CommservSurveyResults_ID 
  		FROM	cf_CommservSurveyResults 
  		WHERE	QueryId = @QueryId AND CommcellIdNameMap_ID = @CSUniqueId AND Flags = 1 
  		SELECT @ErrorCode = @@ERROR 
  		IF @ErrorCode = 0 
  		BEGIN 
  			IF @LatestParsedResultId = 0 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 
  			ELSE IF @LatestParsedResultId < @ResultId 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 UNION SELECT @LatestParsedResultId, 0 
  			ELSE 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 0 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  		IF @ErrorCode = 0 
  		BEGIN 
  			UPDATE	R SET ShredStatus = 2, Flags = F.Flags, CollectedResults = NULL 
  			FROM	cf_CommservSurveyResults R 
  					INNER JOIN @ResultFlagsTbl F ON R.CommservSurveyResults_ID = F.ResultId 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  	END 
  	IF @ErrorCode = 0 AND XACT_STATE() = 1 
  	BEGIN 
  		COMMIT TRANSACTION ParseFallenBehindCopiesTran 
  		SELECT @ErrorCode = @@ERROR 
  	END 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	IF @ErrorCode = 0 AND @LogLevel > 1 
  		SET @LogString += ' - Completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  	ELSE IF @ErrorCode <> 0 AND @SkipOnErr = 0 
  		SET @LogString += ' - Failed to update status after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  	ELSE IF @ErrorCode <> 0 
  		SET @LogString += ' - Failed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  END TRY 
  BEGIN CATCH 
  	SELECT @ErrorCode = ERROR_NUMBER(), @ErrorMsg = ERROR_MESSAGE() 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	SET @LogString += ' - Exception in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20))+ ' ERROR MESSAGE: ' + ISNULL(@ErrorMsg, '') 
  END CATCH 
  IF @@TRANCOUNT > 0 
  BEGIN 
      SET @LogString += ' - Rollback uncommitted transaction after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
      SET @TempDate = GETUTCDATE() 
      ROLLBACK TRANSACTION 
      SET	@Duration = DATEDIFF(SS, @TempDate, GETUTCDATE()) 
      SET @LogString += ' - Rollback completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  END 
  IF @ErrorCode <> 0 AND @SkipOnErr > 0 
      UPDATE cf_CommservSurveyResults SET ShredStatus = 3 WHERE CommservSurveyResults_ID = @ResultId 
  IF @LogString <> '' 
  BEGIN 
      SET @LogString = ('Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ')' + @LogString) 
      INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET NOCOUNT OFF
GO

IF EXISTS (select * from GxQscripts where name = 'ParseFallenBehindCopies')
	delete from GxQscripts where name = 'ParseFallenBehindCopies'
GO

IF EXISTS (select * from GXDBVersions where aliasname='ParseFallenBehindCopies')
	delete from GXDBVersions where aliasname = 'ParseFallenBehindCopies'
GO

insert into GXDBVersions values(2, 'ParseFallenBehindCopies',  '00010003006000120000', 'ParseFallenBehindCopies', '00010003006000120000')
GO

