

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Sp/ParseFeatureTracking.sp] ---------- 

-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Sp/ParseFeatureTracking.sp,v $ $Id: ParseFeatureTracking.sp,v 1.1.2.3 2020/12/17 02:50:11 dkraplanee Exp $";
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON


IF EXISTS (select * from sysobjects where name='ParseFeatureTracking')
BEGIN
	print '>>> Drop Stored Procedure: ParseFeatureTracking <<<'
	drop procedure ParseFeatureTracking
END
IF EXISTS (select * from GxQscripts where name='ParseFeatureTracking')
	delete from GxQscripts where name = 'ParseFeatureTracking'
GO

IF EXISTS (select * from GXDBVersions where aliasname='ParseFeatureTracking')
	delete from GXDBVersions where aliasname = 'ParseFeatureTracking'
GO
print '... Creating Procedure: ParseFeatureTracking'
GO
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON
GO
create procedure ParseFeatureTracking
  @QueryId INTEGER,
  @ResultId BIGINT,
  @CSUniqueId INTEGER,
  @LogDateUTC DATETIME,
  @LogDate DATETIME,
  @LogLevel INTEGER = 0
AS
SET NOCOUNT ON 
  DECLARE @StartDate DATETIME = GETUTCDATE() 
  DECLARE @TempDate  DATETIME 
  DECLARE @Duration  INTEGER = 0 
  DECLARE @SkipOnErr INTEGER = 1 
  DECLARE @ErrorCode INTEGER = 0 
  DECLARE @ErrorMsg  NVARCHAR(MAX) 
  DECLARE @LogString NVARCHAR(MAX) 
  IF @LogLevel > 1 
  BEGIN 
  	SELECT @LogString = 'Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ') - started' 
  	INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET @LogString = '' 
  BEGIN TRY 
  	BEGIN TRANSACTION ParseFeatureTrackingTran 
  	SELECT @ErrorCode = @@ERROR
--  QUERY SPECIFIC CODE BEGIN --
IF OBJECT_ID('tempdb..#AToZFeatureDetails') IS NOT NULL
    DROP TABLE #AToZFeatureDetails
CREATE TABLE #AToZFeatureDetails
(
	Id NVARCHAR(MAX),
	AttrName NVARCHAR(MAX),
	AttrType NVARCHAR(MAX),
	AttrVal NVARCHAR(MAX),
	CollectionTime NVARCHAR(MAX)
)
DECLARE @FileName NVARCHAR(1024)
SELECT	@FileName = CAST(CollectedResults as NVARCHAR(1024))
FROM	cf_CommservSurveyResults
WHERE	CommservSurveyResults_ID = @ResultId
IF 	@ErrorCode = 0 and DATALENGTH(@FileName) > 0
BEGIN
    DECLARE @sql NVARCHAR(256) = 'BULK INSERT #AToZFeatureDetails FROM ''' + @FileName + ''' WITH ( FIELDTERMINATOR =''],['', ROWTERMINATOR =''\n'' )';
	EXEC(@sql);
	SELECT @ErrorCode = @@ERROR
END
IF 	@ErrorCode = 0
BEGIN
	INSERT INTO cf_AToZFeatureDetails( CommServUniqueId, SurveyResultId, AToZFeatureId, AttrName, AttrType, AttrVal, CollectionTime )
	SELECT
		@CSUniqueId,
		@ResultId,
		cast(SUBSTRING(id, 2, len(id)-1) as int) as id,
		AttrName,
		AttrType,
		AttrVal,
		cast(SUBSTRING(CollectionTime, 1, len(CollectionTime)-1) as datetime)
	FROM #AToZFeatureDetails
	SELECT @ErrorCode = @@ERROR
END
else
begin
	print 'ParseFeatureTracking: Failed to insert data from ' + @FileName
end
DROP TABLE #AToZFeatureDetails
--  QUERY SPECIFIC CODE END --
IF @ErrorCode = 0 
  	BEGIN 
  		DECLARE	@ResultFlagsTbl TABLE (ResultId BIGINT, Flags INT) 
  		DECLARE	@LatestParsedResultId BIGINT = 0 
  		SELECT	@LatestParsedResultId = CommservSurveyResults_ID 
  		FROM	cf_CommservSurveyResults 
  		WHERE	QueryId = @QueryId AND CommcellIdNameMap_ID = @CSUniqueId AND Flags = 1 
  		SELECT @ErrorCode = @@ERROR 
  		IF @ErrorCode = 0 
  		BEGIN 
  			IF @LatestParsedResultId = 0 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 
  			ELSE IF @LatestParsedResultId < @ResultId 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 UNION SELECT @LatestParsedResultId, 0 
  			ELSE 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 0 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  		IF @ErrorCode = 0 
  		BEGIN 
  			UPDATE	R SET ShredStatus = 2, Flags = F.Flags, CollectedResults = NULL 
  			FROM	cf_CommservSurveyResults R 
  					INNER JOIN @ResultFlagsTbl F ON R.CommservSurveyResults_ID = F.ResultId 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  	END 
  	IF @ErrorCode = 0 AND XACT_STATE() = 1 
  	BEGIN 
  		COMMIT TRANSACTION ParseFeatureTrackingTran 
  		SELECT @ErrorCode = @@ERROR 
  	END 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	IF @ErrorCode = 0 AND @LogLevel > 1 
  		SET @LogString += ' - Completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  	ELSE IF @ErrorCode <> 0 AND @SkipOnErr = 0 
  		SET @LogString += ' - Failed to update status after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  	ELSE IF @ErrorCode <> 0 
  		SET @LogString += ' - Failed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  END TRY 
  BEGIN CATCH 
  	SELECT @ErrorCode = ERROR_NUMBER(), @ErrorMsg = ERROR_MESSAGE() 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	SET @LogString += ' - Exception in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20))+ ' ERROR MESSAGE: ' + ISNULL(@ErrorMsg, '') 
  END CATCH 
  IF @@TRANCOUNT > 0 
  BEGIN 
      SET @LogString += ' - Rollback uncommitted transaction after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
      SET @TempDate = GETUTCDATE() 
      ROLLBACK TRANSACTION 
      SET	@Duration = DATEDIFF(SS, @TempDate, GETUTCDATE()) 
      SET @LogString += ' - Rollback completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  END 
  IF @ErrorCode <> 0 AND @SkipOnErr > 0 
      UPDATE cf_CommservSurveyResults SET ShredStatus = 3 WHERE CommservSurveyResults_ID = @ResultId 
  IF @LogString <> '' 
  BEGIN 
      SET @LogString = ('Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ')' + @LogString) 
      INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET NOCOUNT OFF
SET NOCOUNT OFF
GO

IF EXISTS (select * from GxQscripts where name = 'ParseFeatureTracking')
	delete from GxQscripts where name = 'ParseFeatureTracking'
GO

IF EXISTS (select * from GXDBVersions where aliasname='ParseFeatureTracking')
	delete from GXDBVersions where aliasname = 'ParseFeatureTracking'
GO

insert into GXDBVersions values(2, 'ParseFeatureTracking',  '00010001000200030000', 'ParseFeatureTracking', '00010001000200030000')
GO

