

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Sp/ParseLibraryProp.sp] ---------- 

-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Sp/ParseLibraryProp.sp,v $ $Id: ParseLibraryProp.sp,v 1.3.60.8 2020/12/17 02:55:26 dkraplanee Exp $";
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON


IF EXISTS (select * from sysobjects where name='ParseLibraryProp')
BEGIN
	print '>>> Drop Stored Procedure: ParseLibraryProp <<<'
	drop procedure ParseLibraryProp
END
IF EXISTS (select * from GxQscripts where name='ParseLibraryProp')
	delete from GxQscripts where name = 'ParseLibraryProp'
GO

IF EXISTS (select * from GXDBVersions where aliasname='ParseLibraryProp')
	delete from GXDBVersions where aliasname = 'ParseLibraryProp'
GO
print '... Creating Procedure: ParseLibraryProp'
GO
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON
GO
create procedure ParseLibraryProp
  @QueryId INTEGER,
  @ResultId BIGINT,
  @CSUniqueId INTEGER,
  @LogDateUTC DATETIME,
  @LogDate DATETIME,
  @LogLevel INTEGER = 0
AS
SET NOCOUNT ON 
  DECLARE @StartDate DATETIME = GETUTCDATE() 
  DECLARE @TempDate  DATETIME 
  DECLARE @Duration  INTEGER = 0 
  DECLARE @SkipOnErr INTEGER = 1 
  DECLARE @ErrorCode INTEGER = 0 
  DECLARE @ErrorMsg  NVARCHAR(MAX) 
  DECLARE @LogString NVARCHAR(MAX) 
  IF @LogLevel > 1 
  BEGIN 
  	SELECT @LogString = 'Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ') - started' 
  	INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET @LogString = '' 
  BEGIN TRY 
  	BEGIN TRANSACTION ParseLibraryPropTran 
  	SELECT @ErrorCode = @@ERROR
--  QUERY SPECIFIC CODE BEGIN --
DECLARE @ResultXml XML = (SELECT CollectedResults FROM cf_CommservSurveyResults WITH (NOLOCK) WHERE CommservSurveyResults_ID = @ResultId)
IF 	@ErrorCode = 0
BEGIN
	INSERT INTO cf_SurveyLibraryProp
	SELECT DISTINCT
		@ResultId,
		csInfo.n.value('@LibraryId', 'INT'),
		csInfo.n.value('@LibraryName', 'NVARCHAR(128)'),
		csInfo.n.value('@LibraryEnabled', 'INT'),
		csInfo.n.value('@LibraryTypeId', 'INT'),
		csInfo.n.value('@LowWaterMarkMB', 'INT'),
		csInfo.n.value('@LibraryAttribute', 'INT'),
		csInfo.n.value('@MountTimeoutSec', 'INT'),
		csInfo.n.value('@UnmountTimeoutSec', 'INT'),
		csInfo.n.value('@DefaultMediaTypeName', 'VARCHAR(32)'),
		csInfo.n.value('@UseWithinDaysInSec', 'INT'),
		csInfo.n.value('@DriveCleanIntervalInSec', 'INT'),
		csInfo.n.value('@VMSDirection', 'INT'),
		csInfo.n.value('@CacheMountPeriodInSec', 'INT'),
		csInfo.n.value('@StdAlnMedRetentionTime', 'INT'),
		csInfo.n.value('@TURIntervalInSec', 'INT'),
		csInfo.n.value('@ConfigParams', 'VARCHAR(256)'),
		csInfo.n.value('@StdAlnChkIntervalInSec', 'INT'),
		csInfo.n.value('@ReadRetryIntervalInSec', 'INT'),
		csInfo.n.value('@ReadRetryAttempts', 'INT'),
		csInfo.n.value('@StartVMSElementAddress', 'INT'),
		csInfo.n.value('@ExtendedAttributes', 'INT'),
		csInfo.n.value('@ThresholdPercentage', 'INT'),
		csInfo.n.value('@ThresholdVariation', 'INT'),
		csInfo.n.value('@WarningWaterMark', 'INT'),
		csInfo.n.value('@MaxSwitchForHost', 'INT')
	FROM
		@ResultXml.nodes('/LibraryAudit/Library') AS csInfo(n)
	SELECT @ErrorCode = @@ERROR
END
IF 	@ErrorCode = 0
BEGIN
	INSERT INTO cf_SurveyMountPathProp
	SELECT DISTINCT
		@ResultId,
		csInfo.n.value('@LibraryId', 'INT'),
		csInfo.n.value('@MountPathId', 'INT'),
		csInfo.n.value('@MountPathName', 'NVARCHAR(1024)'),
		csInfo.n.value('@IsEnabled', 'INT'),
		csInfo.n.value('@MaxConcurrentWriters', 'INT'),
		csInfo.n.value('@MaxDataToWriteMB', 'INT'),
		csInfo.n.value('@MagneticSpaceRsrvInMB', 'INT'),
		csInfo.n.value('@Attribute', 'INT'),
		csInfo.n.value('@MagneticChunkFileIncrSizeMB', 'INT'),
		csInfo.n.value('@DeviceEnabled', 'INT')
	FROM
		@ResultXml.nodes('/LibraryAudit/MountPath') AS csInfo(n)
	SELECT @ErrorCode = @@ERROR
END
--  QUERY SPECIFIC CODE END --
IF @ErrorCode = 0 
  	BEGIN 
  		DECLARE	@ResultFlagsTbl TABLE (ResultId BIGINT, Flags INT) 
  		DECLARE	@LatestParsedResultId BIGINT = 0 
  		SELECT	@LatestParsedResultId = CommservSurveyResults_ID 
  		FROM	cf_CommservSurveyResults 
  		WHERE	QueryId = @QueryId AND CommcellIdNameMap_ID = @CSUniqueId AND Flags = 1 
  		SELECT @ErrorCode = @@ERROR 
  		IF @ErrorCode = 0 
  		BEGIN 
  			IF @LatestParsedResultId = 0 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 
  			ELSE IF @LatestParsedResultId < @ResultId 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 UNION SELECT @LatestParsedResultId, 0 
  			ELSE 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 0 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  		IF @ErrorCode = 0 
  		BEGIN 
  			UPDATE	R SET ShredStatus = 2, Flags = F.Flags, CollectedResults = NULL 
  			FROM	cf_CommservSurveyResults R 
  					INNER JOIN @ResultFlagsTbl F ON R.CommservSurveyResults_ID = F.ResultId 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  	END 
  	IF @ErrorCode = 0 AND XACT_STATE() = 1 
  	BEGIN 
  		COMMIT TRANSACTION ParseLibraryPropTran 
  		SELECT @ErrorCode = @@ERROR 
  	END 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	IF @ErrorCode = 0 AND @LogLevel > 1 
  		SET @LogString += ' - Completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  	ELSE IF @ErrorCode <> 0 AND @SkipOnErr = 0 
  		SET @LogString += ' - Failed to update status after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  	ELSE IF @ErrorCode <> 0 
  		SET @LogString += ' - Failed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  END TRY 
  BEGIN CATCH 
  	SELECT @ErrorCode = ERROR_NUMBER(), @ErrorMsg = ERROR_MESSAGE() 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	SET @LogString += ' - Exception in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20))+ ' ERROR MESSAGE: ' + ISNULL(@ErrorMsg, '') 
  END CATCH 
  IF @@TRANCOUNT > 0 
  BEGIN 
      SET @LogString += ' - Rollback uncommitted transaction after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
      SET @TempDate = GETUTCDATE() 
      ROLLBACK TRANSACTION 
      SET	@Duration = DATEDIFF(SS, @TempDate, GETUTCDATE()) 
      SET @LogString += ' - Rollback completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  END 
  IF @ErrorCode <> 0 AND @SkipOnErr > 0 
      UPDATE cf_CommservSurveyResults SET ShredStatus = 3 WHERE CommservSurveyResults_ID = @ResultId 
  IF @LogString <> '' 
  BEGIN 
      SET @LogString = ('Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ')' + @LogString) 
      INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET NOCOUNT OFF
GO

IF EXISTS (select * from GxQscripts where name = 'ParseLibraryProp')
	delete from GxQscripts where name = 'ParseLibraryProp'
GO

IF EXISTS (select * from GXDBVersions where aliasname='ParseLibraryProp')
	delete from GXDBVersions where aliasname = 'ParseLibraryProp'
GO

insert into GXDBVersions values(2, 'ParseLibraryProp',  '00010003006000080000', 'ParseLibraryProp', '00010003006000080000')
GO

