

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Sp/ParseLicPeakSCLDetailsV2.sp] ---------- 

-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Sp/ParseLicPeakSCLDetailsV2.sp,v $ $Id: ParseLicPeakSCLDetailsV2.sp,v 1.1.2.2 2018/08/30 22:24:45 lgeorge Exp $";
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER OFF

IF EXISTS (select * from sysobjects where name='ParseLicPeakSCLDetailsV2')
BEGIN
	print '>>> Drop Stored Procedure: ParseLicPeakSCLDetailsV2 <<<'
	drop procedure ParseLicPeakSCLDetailsV2
END
IF EXISTS (select * from GxQscripts where name='ParseLicPeakSCLDetailsV2')
	delete from GxQscripts where name = 'ParseLicPeakSCLDetailsV2'
GO

IF EXISTS (select * from GXDBVersions where aliasname='ParseLicPeakSCLDetailsV2')
	delete from GXDBVersions where aliasname = 'ParseLicPeakSCLDetailsV2'
GO
print '... Creating Procedure: ParseLicPeakSCLDetailsV2'
GO
SET QUOTED_IDENTIFIER ON
GO
create procedure ParseLicPeakSCLDetailsV2
  @QueryId INTEGER,
  @ResultId INTEGER,
  @CSUniqueId INTEGER,
  @LogDateUTC DATETIME,
  @LogDate DATETIME,
  @LogLevel INTEGER = 0
AS
SET NOCOUNT ON 
  DECLARE @StartDate DATETIME = GETUTCDATE() 
  DECLARE @TempDate  DATETIME 
  DECLARE @Duration  INTEGER = 0 
  DECLARE @SkipOnErr INTEGER = 1 
  DECLARE @ErrorCode INTEGER = 0 
  DECLARE @ErrorMsg  NVARCHAR(MAX) 
  DECLARE @LogString NVARCHAR(MAX) 
  IF @LogLevel > 1 
  BEGIN 
  	SELECT @LogString = 'Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ') - started' 
  	INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET @LogString = '' 
  BEGIN TRY 
  	BEGIN TRANSACTION ParseLicPeakSCLDetailsV2Tran 
  	SELECT @ErrorCode = @@ERROR
--  QUERY SPECIFIC CODE BEGIN --
DECLARE @FileName NVARCHAR(1024)
DECLARE @monthStart DATETIME = DATEADD(MM, DATEDIFF(MM, 0, GETDATE()), 0)
SELECT  @FileName = CAST(CollectedResults as NVARCHAR(1024))
FROM    cf_CommservSurveyResults WITH(NOLOCK)
WHERE   CommservSurveyResults_ID = @ResultId
SELECT @ErrorCode = @@ERROR
IF OBJECT_ID('tempdb..#SCLPeakLicenseUsage') IS NOT NULL
    DROP TABLE #SCLPeakLicenseUsage
CREATE TABLE #SCLPeakLicenseUsage
(
	MonthStart					DATETIME NOT NULL,
	PeakDate					DATETIME NOT NULL,
	nJobType					INT,
	AppId						INT,
	JobId						INT,
	ClientId					INT,
	AppTypeId					INT,
	SPId						INT,
	AppSizeMB					BIGINT,
	LicType						INT,
	IsVM						INT,
	CapacityFlag				INT,
	Organization				NVARCHAR(1024),
	OrgGUID						VARCHAR(40),
	ObjectName					NVARCHAR(1024),
	Association					NVARCHAR(255),
	PlanName				NVARCHAR(1024)
)
IF 	@ErrorCode = 0
BEGIN
	DECLARE @sql NVARCHAR(256) = 'BULK INSERT #SCLPeakLicenseUsage FROM ''' + @FileName + ''' WITH ( FIELDTERMINATOR ='','', ROWTERMINATOR =''\n'' )';
	EXEC(@sql);
	SELECT @ErrorCode = @@ERROR
END
IF 	@ErrorCode = 0
BEGIN
	--handle comma in the column values
	UPDATE #SCLPeakLicenseUsage SET
	Organization = CASE WHEN Organization IS NOT NULL AND CHARINDEX('<COMMA>', Organization) > 0 THEN REPLACE (Organization,'<COMMA>',',')
						ELSE Organization
					END,
	ObjectName = CASE WHEN ObjectName IS NOT NULL AND CHARINDEX('<COMMA>', ObjectName) > 0 THEN REPLACE (ObjectName,'<COMMA>',',')
					  ELSE ObjectName
					END,
	Association = CASE WHEN Association IS NOT NULL AND CHARINDEX('<COMMA>', Association) > 0 THEN REPLACE (Association,'<COMMA>',',')
					   ELSE Association
					END,
	PlanName = CASE WHEN PlanName IS NOT NULL AND CHARINDEX('<COMMA>', PlanName) > 0 THEN REPLACE (PlanName,'<COMMA>',',')
						ELSE PlanName
					END
	SELECT @ErrorCode = @@ERROR
END
IF @ErrorCode = 0 AND EXISTS (SELECT 1 FROM #SCLPeakLicenseUsage)
BEGIN
	MERGE cf_SurveyLicSCLPeakUsageDetails AS T
	USING (SELECT MonthStart, PeakDate,	nJobType, AppId, JobId, ClientId, AppTypeId, SPId, AppSizeMB, LicType, IsVM, CapacityFlag, Organization, OrgGUID, PlanName
			FROM #SCLPeakLicenseUsage WHERE IsVM<>-2 ) AS S
	ON T.CommServUniqueId = @CSUniqueId AND T.MonthStart=S.MonthStart AND T.nJobType=S.nJobType AND T.ClientId=S.ClientId AND T.AppId=S.AppId
	WHEN MATCHED
		THEN UPDATE SET T.PeakDate=S.PeakDate, T.JobId=S.JobId, T.AppTypeId=S.AppTypeId, T.SPId=S.SPId, T.AppSizeMB=S.AppSizeMB, T.LicType=S.LicType, T.IsVM=S.IsVM, T.CapacityFlag=S.CapacityFlag, T.Organization=S.Organization, T.OrgGUID=S.OrgGUID, T.PlanName=S.PlanName
	WHEN NOT MATCHED BY TARGET
		THEN INSERT (CommServUniqueId, MonthStart, PeakDate, nJobType, AppId, JobId, ClientId, AppTypeId, SPId, AppSizeMB, LicType, IsVM, CapacityFlag, Organization, OrgGUID, PlanName)
		VALUES(@CSUniqueId, S.MonthStart, S.PeakDate, S.nJobType, S.AppId, S.JobId, S.ClientId, S.AppTypeId ,S.SPId, S.AppSizeMB, S.LicType, S.IsVM, S.CapacityFlag, S.Organization, S.OrgGUID, S.PlanName)
	;
	SELECT @ErrorCode = @@ERROR
	IF 	@ErrorCode = 0
	BEGIN
		MERGE cf_SurveyLicSCLPeakCALDetails AS T
		USING (SELECT MonthStart, PeakDate,	nJobType, AppId, JobId, ClientId, AppTypeId, SPId, AppSizeMB, LicType, IsVM, Organization, OrgGUID, ObjectName, Association, PlanName
				FROM #SCLPeakLicenseUsage WHERE IsVM=-2) AS S
		ON T.CommServUniqueId = @CSUniqueId AND T.MonthStart=S.MonthStart AND T.ObjectType=S.nJobType AND T.ClientId=S.ClientId AND T.AppId=S.AppId AND T.LicType=S.LicType AND T.AppTypeId=S.AppTypeId AND T.ObjectId=S.SPId AND T.ObjectName=S.ObjectName
		WHEN MATCHED
			THEN UPDATE SET T.PeakDate=S.PeakDate, T.JobId=S.JobId, T.AppSizeMB=S.AppSizeMB, T.Organization=S.Organization, T.OrgGUID=S.OrgGUID, T.Associations=S.Association, T.PlanName=S.PlanName
		WHEN NOT MATCHED BY TARGET
			THEN INSERT (CommServUniqueId, MonthStart, PeakDate, ObjectType, ClientId, AppId, AppTypeId, LicType, JobId, AppSizeMB, ObjectId, ObjectName, Associations, Organization, OrgGUID, PlanName)
			VALUES(@CSUniqueId, S.MonthStart, S.PeakDate, S.nJobType, S.ClientId, S.AppId, S.AppTypeId, S.LicType, S.JobId, S.AppSizeMB, S.SPId, S.ObjectName, S.Association, S.Organization, S.OrgGUID, S.PlanName)
		;
		SELECT @ErrorCode = @@ERROR
	END
END
--  QUERY SPECIFIC CODE END --
IF @ErrorCode = 0 
  	BEGIN 
  		DECLARE	@ResultFlagsTbl TABLE (ResultId INT, Flags INT) 
  		DECLARE	@LatestParsedResultId INT = 0 
  		SELECT	@LatestParsedResultId = CommservSurveyResults_ID 
  		FROM	cf_CommservSurveyResults 
  		WHERE	QueryId = @QueryId AND CommcellIdNameMap_ID = @CSUniqueId AND Flags = 1 
  		SELECT @ErrorCode = @@ERROR 
  		IF @ErrorCode = 0 
  		BEGIN 
  			IF @LatestParsedResultId = 0 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 
  			ELSE IF @LatestParsedResultId < @ResultId 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 UNION SELECT @LatestParsedResultId, 0 
  			ELSE 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 0 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  		IF @ErrorCode = 0 
  		BEGIN 
  			UPDATE	R SET ShredStatus = 2, Flags = F.Flags, CollectedResults = NULL 
  			FROM	cf_CommservSurveyResults R 
  					INNER JOIN @ResultFlagsTbl F ON R.CommservSurveyResults_ID = F.ResultId 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  	END 
  	IF @ErrorCode = 0 AND XACT_STATE() = 1 
  	BEGIN 
  		COMMIT TRANSACTION ParseLicPeakSCLDetailsV2Tran 
  		SELECT @ErrorCode = @@ERROR 
  	END 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	IF @ErrorCode = 0 AND @LogLevel > 1 
  		SET @LogString += ' - Completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  	ELSE IF @ErrorCode <> 0 AND @SkipOnErr = 0 
  		SET @LogString += ' - Failed to update status after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  	ELSE IF @ErrorCode <> 0 
  		SET @LogString += ' - Failed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  END TRY 
  BEGIN CATCH 
  	SELECT @ErrorCode = ERROR_NUMBER(), @ErrorMsg = ERROR_MESSAGE() 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	SET @LogString += ' - Exception in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20))+ ' ERROR MESSAGE: ' + ISNULL(@ErrorMsg, '') 
  END CATCH 
  IF @@TRANCOUNT > 0 
  BEGIN 
      SET @LogString += ' - Rollback uncommitted transaction after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
      SET @TempDate = GETUTCDATE() 
      ROLLBACK TRANSACTION 
      SET	@Duration = DATEDIFF(SS, @TempDate, GETUTCDATE()) 
      SET @LogString += ' - Rollback completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  END 
  IF @ErrorCode <> 0 AND @SkipOnErr > 0 
      UPDATE cf_CommservSurveyResults SET ShredStatus = 3 WHERE CommservSurveyResults_ID = @ResultId 
  IF @LogString <> '' 
  BEGIN 
      SET @LogString = ('Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ')' + @LogString) 
      INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET NOCOUNT OFF
GO

IF EXISTS (select * from GxQscripts where name = 'ParseLicPeakSCLDetailsV2')
	delete from GxQscripts where name = 'ParseLicPeakSCLDetailsV2'
GO

IF EXISTS (select * from GXDBVersions where aliasname='ParseLicPeakSCLDetailsV2')
	delete from GXDBVersions where aliasname = 'ParseLicPeakSCLDetailsV2'
GO

insert into GXDBVersions values(2, 'ParseLicPeakSCLDetailsV2',  '00010001000200020000', 'ParseLicPeakSCLDetailsV2', '00010001000200020000')
GO

