

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Sp/ParseLiveSyncVMDetails.sp] ---------- 

-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Sp/ParseLiveSyncVMDetails.sp,v $ $Id: ParseLiveSyncVMDetails.sp,v 1.1.2.7 2020/12/17 02:46:53 dkraplanee Exp $";
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON


IF EXISTS (select * from sysobjects where name='ParseLiveSyncVMDetails')
BEGIN
	print '>>> Drop Stored Procedure: ParseLiveSyncVMDetails <<<'
	drop procedure ParseLiveSyncVMDetails
END
IF EXISTS (select * from GxQscripts where name='ParseLiveSyncVMDetails')
	delete from GxQscripts where name = 'ParseLiveSyncVMDetails'
GO

IF EXISTS (select * from GXDBVersions where aliasname='ParseLiveSyncVMDetails')
	delete from GXDBVersions where aliasname = 'ParseLiveSyncVMDetails'
GO
print '... Creating Procedure: ParseLiveSyncVMDetails'
GO
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON
GO
create procedure ParseLiveSyncVMDetails
  @QueryId INTEGER,
  @ResultId BIGINT,
  @CSUniqueId INTEGER,
  @LogDateUTC DATETIME,
  @LogDate DATETIME,
  @LogLevel INTEGER = 0
AS
SET NOCOUNT ON 
  DECLARE @StartDate DATETIME = GETUTCDATE() 
  DECLARE @TempDate  DATETIME 
  DECLARE @Duration  INTEGER = 0 
  DECLARE @SkipOnErr INTEGER = 1 
  DECLARE @ErrorCode INTEGER = 0 
  DECLARE @ErrorMsg  NVARCHAR(MAX) 
  DECLARE @LogString NVARCHAR(MAX) 
  IF @LogLevel > 1 
  BEGIN 
  	SELECT @LogString = 'Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ') - started' 
  	INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET @LogString = '' 
  BEGIN TRY 
  	BEGIN TRANSACTION ParseLiveSyncVMDetailsTran 
  	SELECT @ErrorCode = @@ERROR
--  QUERY SPECIFIC CODE BEGIN --
IF 	@ErrorCode = 0
BEGIN
    INSERT INTO cf_SurveyLiveSyncVMDetails
    SELECT
        results.CommservSurveyResults_ID,
        csInfo.n.value('@SourceVMClientName','NVARCHAR(256)'),
        csInfo.n.value('@SourceVMHyperVisorType','INT'),
        csInfo.n.value('@DestVMClientName','NVARCHAR(256)'),
        csInfo.n.value('@DestVMHyperVisorType','INT'),
        csInfo.n.value('@LastRestoreTime','INT'),
        csInfo.n.value('@LastBackupTime','INT'),
        csInfo.n.value('@TaskId','INT'),
        csInfo.n.value('@TaskName','NVARCHAR(256)'),
        csInfo.n.value('@SubclientId','INT'),
        csInfo.n.value('@SubClientName','NVARCHAR(256)'),
        csInfo.n.value('@Flags','INT'),
        csInfo.n.value('@Status','INT'),
        csInfo.n.value('@BackupSetId','INT'),
        csInfo.n.value('@BackupSetName','NVARCHAR(256)'),
        csInfo.n.value('@LastSyncedBkpJob','INT'),
        csInfo.n.value('@VMSyncedTillTime','INT'),
        csInfo.n.value('@BkpJobsToSync','NVARCHAR(MAX)'),
        csInfo.n.value('@ValidationFailCount','INT'),
        csInfo.n.value('@FailoverStatus','INT')
    FROM
    cf_CommservSurveyResults AS results
        CROSS apply results.CollectedResults.nodes('/LiveSyncVMDetails') AS csInfo(n)
    WHERE
        CommservSurveyResults_ID = @ResultId
	SELECT @ErrorCode = @@ERROR
END
--  QUERY SPECIFIC CODE END --
IF @ErrorCode = 0 
  	BEGIN 
  		DECLARE	@ResultFlagsTbl TABLE (ResultId BIGINT, Flags INT) 
  		DECLARE	@LatestParsedResultId BIGINT = 0 
  		SELECT	@LatestParsedResultId = CommservSurveyResults_ID 
  		FROM	cf_CommservSurveyResults 
  		WHERE	QueryId = @QueryId AND CommcellIdNameMap_ID = @CSUniqueId AND Flags = 1 
  		SELECT @ErrorCode = @@ERROR 
  		IF @ErrorCode = 0 
  		BEGIN 
  			IF @LatestParsedResultId = 0 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 
  			ELSE IF @LatestParsedResultId < @ResultId 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 UNION SELECT @LatestParsedResultId, 0 
  			ELSE 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 0 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  		IF @ErrorCode = 0 
  		BEGIN 
  			UPDATE	R SET ShredStatus = 2, Flags = F.Flags, CollectedResults = NULL 
  			FROM	cf_CommservSurveyResults R 
  					INNER JOIN @ResultFlagsTbl F ON R.CommservSurveyResults_ID = F.ResultId 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  	END 
  	IF @ErrorCode = 0 AND XACT_STATE() = 1 
  	BEGIN 
  		COMMIT TRANSACTION ParseLiveSyncVMDetailsTran 
  		SELECT @ErrorCode = @@ERROR 
  	END 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	IF @ErrorCode = 0 AND @LogLevel > 1 
  		SET @LogString += ' - Completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  	ELSE IF @ErrorCode <> 0 AND @SkipOnErr = 0 
  		SET @LogString += ' - Failed to update status after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  	ELSE IF @ErrorCode <> 0 
  		SET @LogString += ' - Failed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  END TRY 
  BEGIN CATCH 
  	SELECT @ErrorCode = ERROR_NUMBER(), @ErrorMsg = ERROR_MESSAGE() 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	SET @LogString += ' - Exception in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20))+ ' ERROR MESSAGE: ' + ISNULL(@ErrorMsg, '') 
  END CATCH 
  IF @@TRANCOUNT > 0 
  BEGIN 
      SET @LogString += ' - Rollback uncommitted transaction after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
      SET @TempDate = GETUTCDATE() 
      ROLLBACK TRANSACTION 
      SET	@Duration = DATEDIFF(SS, @TempDate, GETUTCDATE()) 
      SET @LogString += ' - Rollback completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  END 
  IF @ErrorCode <> 0 AND @SkipOnErr > 0 
      UPDATE cf_CommservSurveyResults SET ShredStatus = 3 WHERE CommservSurveyResults_ID = @ResultId 
  IF @LogString <> '' 
  BEGIN 
      SET @LogString = ('Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ')' + @LogString) 
      INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET NOCOUNT OFF
GO

IF EXISTS (select * from GxQscripts where name = 'ParseLiveSyncVMDetails')
	delete from GxQscripts where name = 'ParseLiveSyncVMDetails'
GO

IF EXISTS (select * from GXDBVersions where aliasname='ParseLiveSyncVMDetails')
	delete from GXDBVersions where aliasname = 'ParseLiveSyncVMDetails'
GO

insert into GXDBVersions values(2, 'ParseLiveSyncVMDetails',  '00010001000200070000', 'ParseLiveSyncVMDetails', '00010001000200070000')
GO

