

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Sp/ParseMountPathThroughput.sp] ---------- 

-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Sp/ParseMountPathThroughput.sp,v $ $Id: ParseMountPathThroughput.sp,v 1.1.2.7 2020/12/17 02:48:17 dkraplanee Exp $";
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON


IF EXISTS (select * from sysobjects where name='ParseMountPathThroughput')
BEGIN
	print '>>> Drop Stored Procedure: ParseMountPathThroughput <<<'
	drop procedure ParseMountPathThroughput
END
IF EXISTS (select * from GxQscripts where name='ParseMountPathThroughput')
	delete from GxQscripts where name = 'ParseMountPathThroughput'
GO

IF EXISTS (select * from GXDBVersions where aliasname='ParseMountPathThroughput')
	delete from GXDBVersions where aliasname = 'ParseMountPathThroughput'
GO
print '... Creating Procedure: ParseMountPathThroughput'
GO
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON
GO
create procedure ParseMountPathThroughput
  @QueryId INTEGER,
  @ResultId BIGINT,
  @CSUniqueId INTEGER,
  @LogDateUTC DATETIME,
  @LogDate DATETIME,
  @LogLevel INTEGER = 0
AS
SET NOCOUNT ON 
  DECLARE @StartDate DATETIME = GETUTCDATE() 
  DECLARE @TempDate  DATETIME 
  DECLARE @Duration  INTEGER = 0 
  DECLARE @SkipOnErr INTEGER = 1 
  DECLARE @ErrorCode INTEGER = 0 
  DECLARE @ErrorMsg  NVARCHAR(MAX) 
  DECLARE @LogString NVARCHAR(MAX) 
  IF @LogLevel > 1 
  BEGIN 
  	SELECT @LogString = 'Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ') - started' 
  	INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET @LogString = '' 
  BEGIN TRY 
  	BEGIN TRANSACTION ParseMountPathThroughputTran 
  	SELECT @ErrorCode = @@ERROR
--  QUERY SPECIFIC CODE BEGIN --
CREATE TABLE #MountPathThroughput
(
	CommservUniqueId	INT,
	LibraryId			INT NOT NULL,
	MountPathId			INT NOT NULL,
	MountPathName		NVARCHAR(1024) NOT NULL,
	IntervalType		CHAR NOT NULL,
	IntervalStart		DATETIME NOT NULL,
	UsedSeconds 		INT NOT NULL,
	DataReadMB 			BIGINT NOT NULL,
	DataWrittenMB		BIGINT NOT NULL
)
IF 	@ErrorCode = 0
BEGIN
	INSERT INTO #MountPathThroughput (
			CommservUniqueId, LibraryId, MountPathId, MountPathName, IntervalType, IntervalStart, UsedSeconds, DataReadMB, DataWrittenMB)
	SELECT DISTINCT
			@CSUniqueId,
			csInfo.n.value('@LibraryId', 'INT'),
			csInfo.n.value('@MountPathId', 'INT'),
			csInfo.n.value('@MountPathName', 'NVARCHAR(1024)'),
			csInfo.n.value('@IntervalType', 'CHAR'),
			csInfo.n.value('@IntervalStart', 'DATETIME'),
			csInfo.n.value('@UsedSeconds', 'INT'),
			csInfo.n.value('@DataReadMB', 'BIGINT'),
			csInfo.n.value('@DataWrittenMB', 'BIGINT')
	FROM	cf_CommservSurveyResults AS results
			CROSS APPLY results.CollectedResults.nodes('/MountPathThroughput') AS csInfo(n)
	WHERE	CommservSurveyResults_ID = @ResultId
	SELECT @ErrorCode = @@ERROR
END
IF 	@ErrorCode = 0
	AND EXISTS (SELECT * FROM #MountPathThroughput WHERE IntervalType = 'H')
	AND NOT EXISTS (SELECT * FROM #MountPathThroughput WHERE IntervalType = 'D')
BEGIN
	INSERT INTO #MountPathThroughput (
			CommservUniqueId, LibraryId, MountPathId, MountPathName, IntervalType, IntervalStart, UsedSeconds, DataReadMB, DataWrittenMB)
	SELECT	CommservUniqueId, LibraryId, MountPathId, MountPathName, 'D', CAST(IntervalStart AS DATE), SUM(UsedSeconds), SUM(DataReadMB), SUM(DataWrittenMB)
	FROM	#MountPathThroughput
	WHERE	IntervalType = 'H'
	GROUP BY CommservUniqueId, LibraryId, MountPathId, MountPathName, CAST(IntervalStart AS DATE)
	SELECT @ErrorCode = @@ERROR
END
IF 	@ErrorCode = 0
BEGIN
	DELETE	L
	FROM	#MountPathThroughput L INNER JOIN cf_SurveyMountPathThroughput S
			ON S.CommservUniqueId = @CSUniqueId AND L.MountPathId = S.MountPathId AND L.IntervalType = S.IntervalType AND L.IntervalStart = S.IntervalStart
	SELECT @ErrorCode = @@ERROR
END
IF 	@ErrorCode = 0
BEGIN
	INSERT INTO cf_SurveyMountPathThroughput (
			CommservUniqueId, LibraryId, MountPathId, MountPathName, IntervalType, IntervalStart, UsedSeconds, DataReadMB, DataWrittenMB)
	SELECT	CommservUniqueId, LibraryId, MountPathId, MountPathName, IntervalType, IntervalStart, UsedSeconds, DataReadMB, DataWrittenMB
	FROM	#MountPathThroughput
	SELECT @ErrorCode = @@ERROR
END
--  QUERY SPECIFIC CODE END --
IF @ErrorCode = 0 
  	BEGIN 
  		DECLARE	@ResultFlagsTbl TABLE (ResultId BIGINT, Flags INT) 
  		DECLARE	@LatestParsedResultId BIGINT = 0 
  		SELECT	@LatestParsedResultId = CommservSurveyResults_ID 
  		FROM	cf_CommservSurveyResults 
  		WHERE	QueryId = @QueryId AND CommcellIdNameMap_ID = @CSUniqueId AND Flags = 1 
  		SELECT @ErrorCode = @@ERROR 
  		IF @ErrorCode = 0 
  		BEGIN 
  			IF @LatestParsedResultId = 0 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 
  			ELSE IF @LatestParsedResultId < @ResultId 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 UNION SELECT @LatestParsedResultId, 0 
  			ELSE 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 0 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  		IF @ErrorCode = 0 
  		BEGIN 
  			UPDATE	R SET ShredStatus = 2, Flags = F.Flags, CollectedResults = NULL 
  			FROM	cf_CommservSurveyResults R 
  					INNER JOIN @ResultFlagsTbl F ON R.CommservSurveyResults_ID = F.ResultId 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  	END 
  	IF @ErrorCode = 0 AND XACT_STATE() = 1 
  	BEGIN 
  		COMMIT TRANSACTION ParseMountPathThroughputTran 
  		SELECT @ErrorCode = @@ERROR 
  	END 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	IF @ErrorCode = 0 AND @LogLevel > 1 
  		SET @LogString += ' - Completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  	ELSE IF @ErrorCode <> 0 AND @SkipOnErr = 0 
  		SET @LogString += ' - Failed to update status after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  	ELSE IF @ErrorCode <> 0 
  		SET @LogString += ' - Failed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  END TRY 
  BEGIN CATCH 
  	SELECT @ErrorCode = ERROR_NUMBER(), @ErrorMsg = ERROR_MESSAGE() 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	SET @LogString += ' - Exception in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20))+ ' ERROR MESSAGE: ' + ISNULL(@ErrorMsg, '') 
  END CATCH 
  IF @@TRANCOUNT > 0 
  BEGIN 
      SET @LogString += ' - Rollback uncommitted transaction after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
      SET @TempDate = GETUTCDATE() 
      ROLLBACK TRANSACTION 
      SET	@Duration = DATEDIFF(SS, @TempDate, GETUTCDATE()) 
      SET @LogString += ' - Rollback completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  END 
  IF @ErrorCode <> 0 AND @SkipOnErr > 0 
      UPDATE cf_CommservSurveyResults SET ShredStatus = 3 WHERE CommservSurveyResults_ID = @ResultId 
  IF @LogString <> '' 
  BEGIN 
      SET @LogString = ('Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ')' + @LogString) 
      INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET NOCOUNT OFF
GO

IF EXISTS (select * from GxQscripts where name = 'ParseMountPathThroughput')
	delete from GxQscripts where name = 'ParseMountPathThroughput'
GO

IF EXISTS (select * from GXDBVersions where aliasname='ParseMountPathThroughput')
	delete from GXDBVersions where aliasname = 'ParseMountPathThroughput'
GO

insert into GXDBVersions values(2, 'ParseMountPathThroughput',  '00010001000200070000', 'ParseMountPathThroughput', '00010001000200070000')
GO

