

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Sp/ParseUpgradeCheck.sp] ---------- 

-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Sp/ParseUpgradeCheck.sp,v $ $Id: ParseUpgradeCheck.sp,v 1.2.60.5 2020/12/17 02:50:20 dkraplanee Exp $";
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON


IF EXISTS (select * from sysobjects where name='ParseUpgradeCheck')
BEGIN
	print '>>> Drop Stored Procedure: ParseUpgradeCheck <<<'
	drop procedure ParseUpgradeCheck
END
IF EXISTS (select * from GxQscripts where name='ParseUpgradeCheck')
	delete from GxQscripts where name = 'ParseUpgradeCheck'
GO

IF EXISTS (select * from GXDBVersions where aliasname='ParseUpgradeCheck')
	delete from GXDBVersions where aliasname = 'ParseUpgradeCheck'
GO
print '... Creating Procedure: ParseUpgradeCheck'
GO
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON
GO
create procedure ParseUpgradeCheck
  @QueryId INTEGER,
  @ResultId BIGINT,
  @CSUniqueId INTEGER,
  @LogDateUTC DATETIME,
  @LogDate DATETIME,
  @LogLevel INTEGER = 0
AS
SET NOCOUNT ON 
  DECLARE @StartDate DATETIME = GETUTCDATE() 
  DECLARE @TempDate  DATETIME 
  DECLARE @Duration  INTEGER = 0 
  DECLARE @SkipOnErr INTEGER = 1 
  DECLARE @ErrorCode INTEGER = 0 
  DECLARE @ErrorMsg  NVARCHAR(MAX) 
  DECLARE @LogString NVARCHAR(MAX) 
  IF @LogLevel > 1 
  BEGIN 
  	SELECT @LogString = 'Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ') - started' 
  	INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET @LogString = '' 
  BEGIN TRY 
  	BEGIN TRANSACTION ParseUpgradeCheckTran 
  	SELECT @ErrorCode = @@ERROR
--  QUERY SPECIFIC CODE BEGIN --
IF 	@ErrorCode = 0
BEGIN
	INSERT INTO cf_SurveyUpgradeCheck
	SELECT
		@CSUniqueId,
		@ResultId,
		@LogDateUTC,
		@LogDate,
		csInfo.n.value('@appTypeName', 'NVARCHAR(MAX)'),
		csInfo.n.value('@totalNoOfJobs', 'BIGINT'),
		csInfo.n.value('@noOfJobsSucceeded', 'BIGINT'),
		csInfo.n.value('@noOfJobsCWE', 'BIGINT'),
		csInfo.n.value('@noOfJobsFailed', 'BIGINT'),
		csInfo.n.value('@noOfJobsKilled', 'BIGINT'),
		csInfo.n.value('@avgJobThroughput', 'FLOAT(2)'),
		csInfo.n.value('@avgJobAttempts', 'BIGINT'),
		csInfo.n.value('@avgJobRunTime', 'BIGINT'),
		1,
		3,
		csInfo.n.value('@failureReason', 'NVARCHAR(MAX)')
	FROM
		cf_CommservSurveyResults AS results
		CROSS apply results.CollectedResults.nodes('/JobAggregateStats/JobStatsForPre3Days/Jobstats') AS csInfo(n)
	WHERE
		CommservSurveyResults_ID = @ResultId
	SELECT @ErrorCode = @@ERROR
END
IF 	@ErrorCode = 0
BEGIN
	INSERT INTO cf_SurveyUpgradeCheck
	SELECT
		@CSUniqueId,
		@ResultId,
		@LogDateUTC,
		@LogDate,
		csInfo.n.value('@appTypeName', 'NVARCHAR(MAX)'),
		csInfo.n.value('@totalNoOfJobs', 'BIGINT'),
		csInfo.n.value('@noOfJobsSucceeded', 'BIGINT'),
		csInfo.n.value('@noOfJobsCWE', 'BIGINT'),
		csInfo.n.value('@noOfJobsFailed', 'BIGINT'),
		csInfo.n.value('@noOfJobsKilled', 'BIGINT'),
		csInfo.n.value('@avgJobThroughput', 'FLOAT(2)'),
		csInfo.n.value('@avgJobAttempts', 'BIGINT'),
		csInfo.n.value('@avgJobRunTime', 'BIGINT'),
		1,
		7,
		csInfo.n.value('@failureReason', 'NVARCHAR(MAX)')
	FROM
		cf_CommservSurveyResults AS results
		CROSS apply results.CollectedResults.nodes('/JobAggregateStats/JobStatsForPre7Days/Jobstats') AS csInfo(n)
	WHERE
		CommservSurveyResults_ID = @ResultId
	SELECT @ErrorCode = @@ERROR
END
IF 	@ErrorCode = 0
BEGIN
	INSERT INTO cf_SurveyUpgradeCheck
	SELECT
		@CSUniqueId,
		@ResultId,
		@LogDateUTC,
		@LogDate,
		csInfo.n.value('@appTypeName', 'NVARCHAR(MAX)'),
		csInfo.n.value('@totalNoOfJobs', 'BIGINT'),
		csInfo.n.value('@noOfJobsSucceeded', 'BIGINT'),
		csInfo.n.value('@noOfJobsCWE', 'BIGINT'),
		csInfo.n.value('@noOfJobsFailed', 'BIGINT'),
		csInfo.n.value('@noOfJobsKilled', 'BIGINT'),
		csInfo.n.value('@avgJobThroughput', 'FLOAT(2)'),
		csInfo.n.value('@avgJobAttempts', 'BIGINT'),
		csInfo.n.value('@avgJobRunTime', 'BIGINT'),
		1,
		21,
		csInfo.n.value('@failureReason', 'NVARCHAR(MAX)')
	FROM
		cf_CommservSurveyResults AS results
		CROSS apply results.CollectedResults.nodes('/JobAggregateStats/JobStatsForPre21Days/Jobstats') AS csInfo(n)
	WHERE
		CommservSurveyResults_ID = @ResultId
	SELECT @ErrorCode = @@ERROR
END
IF 	@ErrorCode = 0
BEGIN
	INSERT INTO cf_SurveyUpgradeCheck
	SELECT
		@CSUniqueId,
		@ResultId,
		@LogDateUTC,
		@LogDate,
		csInfo.n.value('@appTypeName', 'NVARCHAR(MAX)'),
		csInfo.n.value('@totalNoOfJobs', 'BIGINT'),
		csInfo.n.value('@noOfJobsSucceeded', 'BIGINT'),
		csInfo.n.value('@noOfJobsCWE', 'BIGINT'),
		csInfo.n.value('@noOfJobsFailed', 'BIGINT'),
		csInfo.n.value('@noOfJobsKilled', 'BIGINT'),
		csInfo.n.value('@avgJobThroughput', 'FLOAT(2)'),
		csInfo.n.value('@avgJobAttempts', 'BIGINT'),
		csInfo.n.value('@avgJobRunTime', 'BIGINT'),
		2,
		3,
		csInfo.n.value('@failureReason', 'NVARCHAR(MAX)')
	FROM
		cf_CommservSurveyResults AS results
		CROSS apply results.CollectedResults.nodes('/JobAggregateStats/JobStatsForPost3Days/Jobstats') AS csInfo(n)
	WHERE
		CommservSurveyResults_ID = @ResultId
	SELECT @ErrorCode = @@ERROR
END
IF 	@ErrorCode = 0
BEGIN
	INSERT INTO cf_SurveyUpgradeCheck
	SELECT
		@CSUniqueId,
		@ResultId,
		@LogDateUTC,
		@LogDate,
		csInfo.n.value('@appTypeName', 'NVARCHAR(MAX)'),
		csInfo.n.value('@totalNoOfJobs', 'BIGINT'),
		csInfo.n.value('@noOfJobsSucceeded', 'BIGINT'),
		csInfo.n.value('@noOfJobsCWE', 'BIGINT'),
		csInfo.n.value('@noOfJobsFailed', 'BIGINT'),
		csInfo.n.value('@noOfJobsKilled', 'BIGINT'),
		csInfo.n.value('@avgJobThroughput', 'FLOAT(2)'),
		csInfo.n.value('@avgJobAttempts', 'BIGINT'),
		csInfo.n.value('@avgJobRunTime', 'BIGINT'),
		2,
		7,
		csInfo.n.value('@failureReason', 'NVARCHAR(MAX)')
	FROM
		cf_CommservSurveyResults AS results
		CROSS apply results.CollectedResults.nodes('/JobAggregateStats/JobStatsForPost7Days/Jobstats') AS csInfo(n)
	WHERE
		CommservSurveyResults_ID = @ResultId
	SELECT @ErrorCode = @@ERROR
END
IF 	@ErrorCode = 0
BEGIN
	INSERT INTO cf_SurveyUpgradeCheck
	SELECT
		@CSUniqueId,
		@ResultId,
		@LogDateUTC,
		@LogDate,
		csInfo.n.value('@appTypeName', 'NVARCHAR(MAX)'),
		csInfo.n.value('@totalNoOfJobs', 'BIGINT'),
		csInfo.n.value('@noOfJobsSucceeded', 'BIGINT'),
		csInfo.n.value('@noOfJobsCWE', 'BIGINT'),
		csInfo.n.value('@noOfJobsFailed', 'BIGINT'),
		csInfo.n.value('@noOfJobsKilled', 'BIGINT'),
		csInfo.n.value('@avgJobThroughput', 'FLOAT(2)'),
		csInfo.n.value('@avgJobAttempts', 'BIGINT'),
		csInfo.n.value('@avgJobRunTime', 'BIGINT'),
		2,
		21,
		csInfo.n.value('@failureReason', 'NVARCHAR(MAX)')
	FROM
		cf_CommservSurveyResults AS results
		CROSS apply results.CollectedResults.nodes('/JobAggregateStats/JobStatsForPost21Days/Jobstats') AS csInfo(n)
	WHERE
		CommservSurveyResults_ID = @ResultId
	SELECT @ErrorCode = @@ERROR
END
IF 	@ErrorCode = 0
BEGIN
	INSERT INTO cf_SurveyUpgradeCheck
	SELECT
		@CSUniqueId,
		@ResultId,
		@LogDateUTC,
		@LogDate,
		csInfo.n.value('@appTypeName', 'NVARCHAR(MAX)'),
		csInfo.n.value('@totalNoOfJobs', 'BIGINT'),
		csInfo.n.value('@noOfJobsSucceeded', 'BIGINT'),
		csInfo.n.value('@noOfJobsCWE', 'BIGINT'),
		csInfo.n.value('@noOfJobsFailed', 'BIGINT'),
		csInfo.n.value('@noOfJobsKilled', 'BIGINT'),
		csInfo.n.value('@avgJobThroughput', 'FLOAT(2)'),
		csInfo.n.value('@avgJobAttempts', 'BIGINT'),
		csInfo.n.value('@avgJobRunTime', 'BIGINT'),
		3,
		3,
		csInfo.n.value('@failureReason', 'NVARCHAR(MAX)')
	FROM
		cf_CommservSurveyResults AS results
		CROSS apply results.CollectedResults.nodes('/JobAggregateStats/JobStatsForLatest3Days/Jobstats') AS csInfo(n)
	WHERE
		CommservSurveyResults_ID = @ResultId
	SELECT @ErrorCode = @@ERROR
END
IF 	@ErrorCode = 0
BEGIN
	INSERT INTO cf_SurveyUpgradeCheck
	SELECT
		@CSUniqueId,
		@ResultId,
		@LogDateUTC,
		@LogDate,
		csInfo.n.value('@appTypeName', 'NVARCHAR(MAX)'),
		csInfo.n.value('@totalNoOfJobs', 'BIGINT'),
		csInfo.n.value('@noOfJobsSucceeded', 'BIGINT'),
		csInfo.n.value('@noOfJobsCWE', 'BIGINT'),
		csInfo.n.value('@noOfJobsFailed', 'BIGINT'),
		csInfo.n.value('@noOfJobsKilled', 'BIGINT'),
		csInfo.n.value('@avgJobThroughput', 'FLOAT(2)'),
		csInfo.n.value('@avgJobAttempts', 'BIGINT'),
		csInfo.n.value('@avgJobRunTime', 'BIGINT'),
		3,
		7,
		csInfo.n.value('@failureReason', 'NVARCHAR(MAX)')
	FROM
		cf_CommservSurveyResults AS results
		CROSS apply results.CollectedResults.nodes('/JobAggregateStats/JobStatsForLatest7Days/Jobstats') AS csInfo(n)
	WHERE
		CommservSurveyResults_ID = @ResultId
	SELECT @ErrorCode = @@ERROR
END
IF 	@ErrorCode = 0
BEGIN
	INSERT INTO cf_SurveyUpgradeCheck
	SELECT
		@CSUniqueId,
		@ResultId,
		@LogDateUTC,
		@LogDate,
		csInfo.n.value('@appTypeName', 'NVARCHAR(MAX)'),
		csInfo.n.value('@totalNoOfJobs', 'BIGINT'),
		csInfo.n.value('@noOfJobsSucceeded', 'BIGINT'),
		csInfo.n.value('@noOfJobsCWE', 'BIGINT'),
		csInfo.n.value('@noOfJobsFailed', 'BIGINT'),
		csInfo.n.value('@noOfJobsKilled', 'BIGINT'),
		csInfo.n.value('@avgJobThroughput', 'FLOAT(2)'),
		csInfo.n.value('@avgJobAttempts', 'BIGINT'),
		csInfo.n.value('@avgJobRunTime', 'BIGINT'),
		3,
		21,
		csInfo.n.value('@failureReason', 'NVARCHAR(MAX)')
	FROM
		cf_CommservSurveyResults AS results
		CROSS apply results.CollectedResults.nodes('/JobAggregateStats/JobStatsForLatest21Days/Jobstats') AS csInfo(n)
	WHERE
		CommservSurveyResults_ID = @ResultId
	SELECT @ErrorCode = @@ERROR
END
--  QUERY SPECIFIC CODE END --
IF @ErrorCode = 0 
  	BEGIN 
  		DECLARE	@ResultFlagsTbl TABLE (ResultId BIGINT, Flags INT) 
  		DECLARE	@LatestParsedResultId BIGINT = 0 
  		SELECT	@LatestParsedResultId = CommservSurveyResults_ID 
  		FROM	cf_CommservSurveyResults 
  		WHERE	QueryId = @QueryId AND CommcellIdNameMap_ID = @CSUniqueId AND Flags = 1 
  		SELECT @ErrorCode = @@ERROR 
  		IF @ErrorCode = 0 
  		BEGIN 
  			IF @LatestParsedResultId = 0 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 
  			ELSE IF @LatestParsedResultId < @ResultId 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 UNION SELECT @LatestParsedResultId, 0 
  			ELSE 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 0 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  		IF @ErrorCode = 0 
  		BEGIN 
  			UPDATE	R SET ShredStatus = 2, Flags = F.Flags, CollectedResults = NULL 
  			FROM	cf_CommservSurveyResults R 
  					INNER JOIN @ResultFlagsTbl F ON R.CommservSurveyResults_ID = F.ResultId 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  	END 
  	IF @ErrorCode = 0 AND XACT_STATE() = 1 
  	BEGIN 
  		COMMIT TRANSACTION ParseUpgradeCheckTran 
  		SELECT @ErrorCode = @@ERROR 
  	END 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	IF @ErrorCode = 0 AND @LogLevel > 1 
  		SET @LogString += ' - Completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  	ELSE IF @ErrorCode <> 0 AND @SkipOnErr = 0 
  		SET @LogString += ' - Failed to update status after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  	ELSE IF @ErrorCode <> 0 
  		SET @LogString += ' - Failed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  END TRY 
  BEGIN CATCH 
  	SELECT @ErrorCode = ERROR_NUMBER(), @ErrorMsg = ERROR_MESSAGE() 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	SET @LogString += ' - Exception in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20))+ ' ERROR MESSAGE: ' + ISNULL(@ErrorMsg, '') 
  END CATCH 
  IF @@TRANCOUNT > 0 
  BEGIN 
      SET @LogString += ' - Rollback uncommitted transaction after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
      SET @TempDate = GETUTCDATE() 
      ROLLBACK TRANSACTION 
      SET	@Duration = DATEDIFF(SS, @TempDate, GETUTCDATE()) 
      SET @LogString += ' - Rollback completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  END 
  IF @ErrorCode <> 0 AND @SkipOnErr > 0 
      UPDATE cf_CommservSurveyResults SET ShredStatus = 3 WHERE CommservSurveyResults_ID = @ResultId 
  IF @LogString <> '' 
  BEGIN 
      SET @LogString = ('Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ')' + @LogString) 
      INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET NOCOUNT OFF
GO

IF EXISTS (select * from GxQscripts where name = 'ParseUpgradeCheck')
	delete from GxQscripts where name = 'ParseUpgradeCheck'
GO

IF EXISTS (select * from GXDBVersions where aliasname='ParseUpgradeCheck')
	delete from GXDBVersions where aliasname = 'ParseUpgradeCheck'
GO

insert into GXDBVersions values(2, 'ParseUpgradeCheck',  '00010002006000050000', 'ParseUpgradeCheck', '00010002006000050000')
GO

