

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Sp/Parse_95MountPathDetails.sp] ---------- 

-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Sp/Parse_95MountPathDetails.sp,v $ $Id: Parse_95MountPathDetails.sp,v 1.5.2.9 2019/08/05 19:37:02 junlu Exp $";
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER OFF

IF EXISTS (select * from sysobjects where name='Parse_95MountPathDetails')
BEGIN
	print '>>> Drop Stored Procedure: Parse_95MountPathDetails <<<'
	drop procedure Parse_95MountPathDetails
END
IF EXISTS (select * from GxQscripts where name='Parse_95MountPathDetails')
	delete from GxQscripts where name = 'Parse_95MountPathDetails'
GO

IF EXISTS (select * from GXDBVersions where aliasname='Parse_95MountPathDetails')
	delete from GXDBVersions where aliasname = 'Parse_95MountPathDetails'
GO
print '... Creating Procedure: Parse_95MountPathDetails'
GO
SET QUOTED_IDENTIFIER ON
GO
create procedure Parse_95MountPathDetails
  @QueryId INTEGER,
  @ResultId INTEGER,
  @CSUniqueId INTEGER,
  @LogDateUTC DATETIME,
  @LogDate DATETIME,
  @LogLevel INTEGER = 0
AS
SET NOCOUNT ON 
  DECLARE @StartDate DATETIME = GETUTCDATE() 
  DECLARE @TempDate  DATETIME 
  DECLARE @Duration  INTEGER = 0 
  DECLARE @SkipOnErr INTEGER = 1 
  DECLARE @ErrorCode INTEGER = 0 
  DECLARE @ErrorMsg  NVARCHAR(MAX) 
  DECLARE @LogString NVARCHAR(MAX) 
  IF @LogLevel > 1 
  BEGIN 
  	SELECT @LogString = 'Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ') - started' 
  	INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET @LogString = '' 
  BEGIN TRY 
  	BEGIN TRANSACTION ParseMountPathDetailsTran 
  	SELECT @ErrorCode = @@ERROR
--  QUERY SPECIFIC CODE BEGIN --
IF 	@ErrorCode = 0
BEGIN
	INSERT INTO cf_Survey95MountPathDetails
	SELECT
		@CSUniqueId,
		@ResultId,
		@LogDateUTC,
		@LogDate,
		csInfo.n.value('@LibraryId',       'BIGINT'),
		csInfo.n.value('@LibraryName',     '[NVARCHAR](MAX)'),
		csInfo.n.value('@MountPathName',   '[NVARCHAR](MAX)'),
		csInfo.n.value('@Status',          '[NVARCHAR](16)'),
		csInfo.n.value('@FreeSpaceGB',     'FLOAT'),
		csInfo.n.value('@TotalCapacityGB', 'FLOAT'),
		csInfo.n.value('@UsedSpaceGB',     'FLOAT'),
		csInfo.n.value('@FreeSpacePerc',   'FLOAT'),
		ISNULL(csInfo.n.value('@MountPathId',      'BIGINT'), 0),
		ISNULL(csInfo.n.value('@BaseFolderName',   '[NVARCHAR](MAX)'), ''),
		ISNULL(csInfo.n.value('@Device',           '[NVARCHAR](MAX)'), ''),
		ISNULL(csInfo.n.value('@MAId',             'INT'), 0),
		ISNULL(csInfo.n.value('@MAName',           '[NVARCHAR](MAX)'), ''),
		ISNULL(csInfo.n.value('@OffLineTimeStamp', 'BIGINT'), 0)
	FROM cf_CommservSurveyResults AS results
		CROSS apply results.CollectedResults.nodes('MountPathDetails/MountPath') AS csInfo(n)
	WHERE CommservSurveyResults_ID = @ResultId
	SELECT @ErrorCode = @@ERROR
END
--  QUERY SPECIFIC CODE END --
IF @ErrorCode = 0 
  	BEGIN 
  		DECLARE	@ResultFlagsTbl TABLE (ResultId INT, Flags INT) 
  		DECLARE	@LatestParsedResultId INT = 0 
  		SELECT	@LatestParsedResultId = CommservSurveyResults_ID 
  		FROM	cf_CommservSurveyResults 
  		WHERE	QueryId = @QueryId AND CommcellIdNameMap_ID = @CSUniqueId AND Flags = 1 
  		SELECT @ErrorCode = @@ERROR 
  		IF @ErrorCode = 0 
  		BEGIN 
  			IF @LatestParsedResultId = 0 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 
  			ELSE IF @LatestParsedResultId < @ResultId 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 1 UNION SELECT @LatestParsedResultId, 0 
  			ELSE 
  				INSERT INTO @ResultFlagsTbl SELECT @ResultId, 0 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  		IF @ErrorCode = 0 
  		BEGIN 
  			UPDATE	R SET ShredStatus = 2, Flags = F.Flags, CollectedResults = NULL 
  			FROM	cf_CommservSurveyResults R 
  					INNER JOIN @ResultFlagsTbl F ON R.CommservSurveyResults_ID = F.ResultId 
  			SELECT @ErrorCode = @@ERROR 
  		END 
  	END 
  	IF @ErrorCode = 0 AND XACT_STATE() = 1 
  	BEGIN 
  		COMMIT TRANSACTION ParseMountPathDetailsTran 
  		SELECT @ErrorCode = @@ERROR 
  	END 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	IF @ErrorCode = 0 AND @LogLevel > 1 
  		SET @LogString += ' - Completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  	ELSE IF @ErrorCode <> 0 AND @SkipOnErr = 0 
  		SET @LogString += ' - Failed to update status after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  	ELSE IF @ErrorCode <> 0 
  		SET @LogString += ' - Failed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20)) 
  END TRY 
  BEGIN CATCH 
  	SELECT @ErrorCode = ERROR_NUMBER(), @ErrorMsg = ERROR_MESSAGE() 
  	SET	@Duration = DATEDIFF(SS, @StartDate, GETUTCDATE()) 
  	SET @LogString += ' - Exception in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec). ERROR CODE: ' + CAST(@ErrorCode AS VARCHAR(20))+ ' ERROR MESSAGE: ' + ISNULL(@ErrorMsg, '') 
  END CATCH 
  IF @@TRANCOUNT > 0 
  BEGIN 
      SET @LogString += ' - Rollback uncommitted transaction after ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
      SET @TempDate = GETUTCDATE() 
      ROLLBACK TRANSACTION 
      SET	@Duration = DATEDIFF(SS, @TempDate, GETUTCDATE()) 
      SET @LogString += ' - Rollback completed in ' + CAST(@Duration AS VARCHAR(10)) + ' (sec).' 
  END 
  IF @ErrorCode <> 0 AND @SkipOnErr > 0 
      UPDATE cf_CommservSurveyResults SET ShredStatus = 3 WHERE CommservSurveyResults_ID = @ResultId 
  IF @LogString <> '' 
  BEGIN 
      SET @LogString = ('Parsing result ' + CAST(@ResultId AS VARCHAR(20)) + ' (QueryId: ' + CAST(@QueryId AS VARCHAR(20)) + ', CSUniqueId: ' + CAST(@CSUniqueId AS VARCHAR(20)) + ')' + @LogString) 
      INSERT INTO cf_SurveyLogger(Message) VALUES(@LogString) 
  END 
  SET NOCOUNT OFF
GO

IF EXISTS (select * from GxQscripts where name = 'Parse_95MountPathDetails')
	delete from GxQscripts where name = 'Parse_95MountPathDetails'
GO

IF EXISTS (select * from GXDBVersions where aliasname='Parse_95MountPathDetails')
	delete from GXDBVersions where aliasname = 'Parse_95MountPathDetails'
GO

insert into GXDBVersions values(2, 'Parse_95MountPathDetails',  '00010005000200090000', 'Parse_95MountPathDetails', '00010005000200090000')
GO

