

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Sp/RptBkpJobStatus_WMonForCompany.sp] ---------- 

-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Sp/RptBkpJobStatus_WMonForCompany.sp,v $ $Id: RptBkpJobStatus_WMonForCompany.sp,v 1.1.2.3 2020/12/17 02:47:44 dkraplanee Exp $";
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON


IF EXISTS (select * from sysobjects where name='RptBkpJobStatus_WMonForCompany')
BEGIN
	print '>>> Drop Stored Procedure: RptBkpJobStatus_WMonForCompany <<<'
	drop procedure RptBkpJobStatus_WMonForCompany
END
IF EXISTS (select * from GxQscripts where name='RptBkpJobStatus_WMonForCompany')
	delete from GxQscripts where name = 'RptBkpJobStatus_WMonForCompany'
GO

IF EXISTS (select * from GXDBVersions where aliasname='RptBkpJobStatus_WMonForCompany')
	delete from GXDBVersions where aliasname = 'RptBkpJobStatus_WMonForCompany'
GO
print '... Creating Procedure: RptBkpJobStatus_WMonForCompany'
GO
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON
GO
create procedure RptBkpJobStatus_WMonForCompany
  @i_UserId INT = NULL,
  @i_GroupId INT = NULL,
  @blaggregate INT = 1,
  @blLatestSurvey INT = 1,
  @i_CommServUniqueID INT = 0,
  @i_LogDateStart DATETIME = NULL,
  @i_LogDateEND DATETIME = NUll,
  @WeeklyMonth INT =0,
  @i_TenantName NVARCHAR(255) = NULL
AS
IF object_id('tempdb.dbo.#TenantClientGroups') IS NOT NULL DROP TABLE #TenantClientGroups
CREATE TABLE #TenantClientGroups (CommServUniqueId INT, TenantName NVARCHAR(255), ClientGroupId INT)
exec GetTenantEntities @i_UserId, @i_GroupId, @blaggregate, @blLatestSurvey, @i_CommServUniqueID, @i_LogDateStart, @i_LogDateEND, @i_TenantName
DECLARE @i_MonthlyQueryId BIGINT = 173
IF object_id('tempdb.dbo.#LatestResult') IS NOT NULL DROP TABLE #LatestResult
CREATE TABLE #LatestResult (SurveyResultId BIGINT, CommServUniqueId INT, CommCellID INT, DisplayName NVARCHAR(256), LogDate DATETIME)
INSERT	INTO #LatestResult
SELECT	SurverResultId, CommServUniqueId, CommCellID, DisplayName, LogDate
FROM	dbo.cf_SurveyResultFuncV1(@i_MonthlyQueryId, @i_CommServUniqueID, @blLatestSurvey, @i_LogDateStart, @i_LogDateEND, @i_UserId, @i_GroupId)
DECLARE @FTSASFailedJobs INT = 0
select @FTSASFailedJobs =  ISNULL(value,0) from cf_surveyConfig WITH (NOLOCK) where name like 'considerFailedToStartAsFailedJobsInActivity'
declare @collectionDate date = (select MAX(LogDate) from #LatestResult)
DECLARE @today DATE =(SELECT CAST(GETDATE()-1 AS DATE))
DECLARE @Last16DaysFrmtoday DATE = DATEADD(DD,-15, @today)
SET NOCOUNT ON
IF(@blaggregate=1)
BEGIN
IF @WeeklyMonth = 0 --TODAY DATA ONLY
BEGIN
SELECT
	CAST(CAST(CASE SUM(csInfo.CompletedJobs+csInfo.CWEJobs+csInfo.CWWJobs)
	WHEN 0 THEN 0
	ELSE (SUM(csInfo.CompletedJobs+csInfo.CWEJobs+csInfo.CWWJobs) * 100.0)/(SUM(csInfo.TotalJobs)-ISNULL(SUM(csInfo.SkippedJobs),0)-(CASE WHEN @FTSASFailedJobs = 0 THEN SUM(csInfo.FailedToStartJobs)  ELSE 0 END))  END
	AS DECIMAL(7, 1)) AS VARCHAR(MAX))  AS 'Success Rate',
	SUM(csInfo.TotalJobs)-ISNULL(SUM(csInfo.SkippedJobs),0)-(CASE WHEN @FTSASFailedJobs = 0 THEN SUM(csInfo.FailedToStartJobs)  ELSE 0 END) AS 'Total',
	SUM(csInfo.CompletedJobs) AS 'Completed',
	SUM(csInfo.CWEJobs) + SUM(csInfo.CWWJobs)  'Completed with Errors or Warnings',
	SUM(csInfo.FailedJobs)+(CASE WHEN @FTSASFailedJobs = 1 THEN SUM(csInfo.FailedToStartJobs)  ELSE 0 END) AS 'Failed',
	ISNULL(SUM(csInfo.KilledJobs),-1) AS 'Killed',
	ISNULL(SUM(csInfo.SkippedJobs)+(CASE WHEN @FTSASFailedJobs = 0 THEN SUM(csInfo.FailedToStartJobs)  ELSE 0 END),-1)AS 'Skipped',
	ISNULL(SUM(csInfo.CommittedJobs),-1) AS 'Committed'
FROM cf_SurveyCompanyDailyBkpJobStats AS csInfo WITH (NOLOCK)
INNER JOIN #LatestResult AS resultView
	ON resultView.CommServUniqueId = csInfo.CommServUniqueId
	AND JobEndDate>=@today
INNER JOIN #TenantClientGroups AS T ON T.CommServUniqueId = csInfo.CommServUniqueId AND T.ClientGroupId = csInfo.ClientGroupId
	RETURN
END
ELSE IF @WeeklyMonth = 1 --Last 16 days
BEGIN
SELECT
	CAST(CAST(CASE SUM(csInfo.CompletedJobs+csInfo.CWEJobs+csInfo.CWWJobs)
	WHEN 0 THEN 0
	ELSE (SUM(csInfo.CompletedJobs+csInfo.CWEJobs+csInfo.CWWJobs) * 100.0)/(SUM(csInfo.TotalJobs)-ISNULL(SUM(csInfo.SkippedJobs),0)-(CASE WHEN @FTSASFailedJobs = 0 THEN SUM(csInfo.FailedToStartJobs)  ELSE 0 END))  END
	AS DECIMAL(7, 1)) AS VARCHAR(MAX))  AS 'Success Rate',
	SUM(csInfo.TotalJobs)-ISNULL(SUM(csInfo.SkippedJobs),0)-(CASE WHEN @FTSASFailedJobs = 0 THEN SUM(csInfo.FailedToStartJobs)  ELSE 0 END) AS 'Total',
	SUM(csInfo.CompletedJobs) AS 'Completed',
	SUM(csInfo.CWEJobs) + SUM(csInfo.CWWJobs)  'Completed with Errors or Warnings',
	SUM(csInfo.FailedJobs)+(CASE WHEN @FTSASFailedJobs = 1 THEN SUM(csInfo.FailedToStartJobs)  ELSE 0 END) AS 'Failed',
	ISNULL(SUM(csInfo.KilledJobs),-1) AS 'Killed',
	ISNULL(SUM(csInfo.SkippedJobs)+(CASE WHEN @FTSASFailedJobs = 0 THEN SUM(csInfo.FailedToStartJobs)  ELSE 0 END),-1)AS 'Skipped',
	ISNULL(SUM(csInfo.CommittedJobs),-1) AS 'Committed'
FROM cf_SurveyCompanyDailyBkpJobStats AS csInfo WITH (NOLOCK)
INNER JOIN #LatestResult AS resultView
	ON resultView.CommServUniqueId = csInfo.CommServUniqueId
	AND JobEndDate>=@Last16DaysFrmtoday
INNER JOIN #TenantClientGroups AS T ON T.CommServUniqueId = csInfo.CommServUniqueId AND T.ClientGroupId = csInfo.ClientGroupId
	RETURN
END
END
IF @WeeklyMonth = 0 --TODAY DATA ONLY
BEGIN
	SELECT
		csInfo.CommServUniqueId AS 'CommServ UniqueId',
		resultView.CommCellID AS 'CommCell ID',
		resultView.DisplayName AS 'CommCell Name',
		CAST(CAST(CASE SUM(csInfo.CompletedJobs+csInfo.CWEJobs+csInfo.CWWJobs)
		WHEN 0 THEN 0
		ELSE (SUM(csInfo.CompletedJobs+csInfo.CWEJobs+csInfo.CWWJobs) * 100.0)/(SUM(csInfo.TotalJobs)-ISNULL(SUM(csInfo.SkippedJobs),0)-(CASE WHEN @FTSASFailedJobs = 0 THEN SUM(csInfo.FailedToStartJobs)  ELSE 0 END))  END
		AS DECIMAL(7, 1)) AS VARCHAR(MAX)) AS 'Success Rate (%)',
		SUM(csInfo.TotalJobs)-ISNULL(SUM(csInfo.SkippedJobs),0)-(CASE WHEN @FTSASFailedJobs = 0 THEN SUM(csInfo.FailedToStartJobs)  ELSE 0 END) AS 'Total',
		SUM(csInfo.CompletedJobs) AS 'Completed',
		SUM(csInfo.CWEJobs + csInfo.CWWJobs) AS 'Completed with Errors or Warnings',
	    SUM(csInfo.FailedJobs)+(CASE WHEN @FTSASFailedJobs = 1 THEN SUM(csInfo.FailedToStartJobs)  ELSE 0 END) AS 'Failed',
		ISNULL(SUM(csInfo.KilledJobs),-1) AS 'Killed',
		ISNULL(SUM(csInfo.SkippedJobs)+(CASE WHEN @FTSASFailedJobs = 0 THEN SUM(csInfo.FailedToStartJobs)  ELSE 0 END),-1)AS 'Skipped',
		ISNULL(SUM(csInfo.CommittedJobs),-1) AS 'Committed',
		datediff(second, '01/01/1970', CAST(csInfo.JobEndDate AS DATE)) AS 'As Of<DWDDMMM>'
	FROM cf_SurveyCompanyDailyBkpJobStats AS csInfo WITH (NOLOCK)
		INNER JOIN #LatestResult AS resultView
			ON resultView.CommServUniqueId = csInfo.CommServUniqueId
			AND JobEndDate>=@today
		INNER JOIN #TenantClientGroups AS T ON T.CommServUniqueId = csInfo.CommServUniqueId AND T.ClientGroupId = csInfo.ClientGroupId
	GROUP BY csInfo.CommServUniqueId, resultView.CommCellID, resultView.DisplayName, csInfo.JobEndDate
	ORDER BY csInfo.JobEndDate desc
END
ELSE IF @WeeklyMonth = 1 --LAST WEEK DATA ONLY
BEGIN
	IF object_id('tempdb.dbo.#TempIdaDailyBkp') IS NOT NULL DROP TABLE #TempIdaDailyBkp
	CREATE TABLE #TempIdaDailyBkp (s_Rate DECIMAL(7, 1), t_Jobs BIGINT, s_Jobs BIGINT, se_Jobs BIGINT, sw_Jobs BIGINT, f_Jobs BIGINT, k_Jobs BIGINT, SK_Jobs BIGINT, C_Jobs BIGINT, sdate DATE)
	INSERT INTO #TempIdaDailyBkp
	SELECT
			CAST(CASE SUM(csInfo.CompletedJobs)+SUM(csInfo.CWEJobs)+SUM(csInfo.CWWJobs)
			WHEN 0 THEN 0
			ELSE ((SUM(csInfo.CompletedJobs) +SUM(csInfo.CWEJobs)+SUM(csInfo.CWWJobs))* 100.0)/(SUM(csInfo.TotalJobs)-ISNULL(SUM(csInfo.SkippedJobs),0)-(CASE WHEN @FTSASFailedJobs = 0 THEN SUM(csInfo.FailedToStartJobs)  ELSE 0 END))  END
			AS DECIMAL(7, 1)) AS  s_Rate,
		SUM(csInfo.TotalJobs)-ISNULL(SUM(csInfo.SkippedJobs),0)-(CASE WHEN @FTSASFailedJobs = 0 THEN SUM(csInfo.FailedToStartJobs)  ELSE 0 END) AS  t_Jobs,
		SUM(csInfo.CompletedJobs) AS  s_Jobs,
		SUM(csInfo.CWEJobs) AS  se_Jobs,
		SUM(csInfo.CWWJobs) AS  sw_Jobs,
		SUM(csInfo.FailedJobs)+(CASE WHEN @FTSASFailedJobs = 1 THEN SUM(csInfo.FailedToStartJobs)  ELSE 0 END) AS  f_Jobs,
		ISNULL(SUM(csInfo.KilledJobs),-1)  AS  k_Jobs,
		ISNULL(SUM(csInfo.SkippedJobs)+(CASE WHEN @FTSASFailedJobs = 0 THEN SUM(csInfo.FailedToStartJobs)  ELSE 0 END),-1)AS SK_Jobs,
		ISNULL(SUM(csInfo.CommittedJobs),-1) AS C_Jobs,
		JobEndDate as sdate
	FROM cf_SurveyCompanyDailyBkpJobStats AS csInfo WITH (NOLOCK)
		INNER JOIN #LatestResult AS resultView
			ON resultView.CommServUniqueId = csInfo.CommServUniqueId
			AND JobEndDate>=@Last16DaysFrmtoday
		INNER JOIN #TenantClientGroups AS T ON T.CommServUniqueId = csInfo.CommServUniqueId AND T.ClientGroupId = csInfo.ClientGroupId
		GROUP BY JobEndDate
	DECLARE @Week_table TABLE
	(
	S_Rate						DECIMAL(7, 1),
	Total						BIGINT ,
	Successful					BIGINT ,
	CompletedWithErrorJobs		BIGINT ,
	CompletedWithWarningJobs	BIGINT ,
	Failed                      BIGINT ,
	Killed                      BIGINT ,
	Skipped                     BIGINT ,
	CommittedJ                   BIGINT,
	servEndDate					DATE
	)
	if ( @i_CommServUniqueID =0)
	SET @today = (SELECT CAST(GETDATE() AS DATE))
	else
	set @today = @collectionDate
	;WITH R(N) AS
	(
	SELECT 0
	UNION ALL
	SELECT N+1
	FROM R
	WHERE N < 15
	)
	INSERT INTO @Week_table
	SELECT   -1,-1,-1,-1,-1,-1,-1,-1,-1,DATEADD(DAY,-N,@today)
	FROM R
	SET @Last16DaysFrmtoday  = DATEADD(DD,-15, @today)
	UPDATE @Week_table
	SET				 S_Rate = Sub.s_Rate ,
	Total	 				= Sub.t_Jobs,
	Successful				= Sub.s_Jobs,
	CompletedWithErrorJobs	= Sub.se_Jobs,
	CompletedWithWarningJobs= Sub.sw_Jobs,
	Failed					= Sub.f_Jobs,
	Killed					= Sub.k_Jobs,
	Skipped					= Sub.SK_Jobs,
	CommittedJ				= Sub.C_Jobs
	FROM #TempIdaDailyBkp as Sub
	INNER JOIN @Week_table AS week
	ON week.servEndDate = Sub.sdate
	IF EXISTS(SELECT Total FROM @Week_table WHERE Total<>-1)
	BEGIN
	SELECT
		CAST(CASE S_Rate
			 WHEN -1 THEN '-'
			 ELSE CAST(S_Rate AS VARCHAR(MAX))
			 END
		 AS VARCHAR(MAX)) AS 'Success Rate (%)',
		CAST(CASE Total
			 WHEN -1 THEN '-'
			 ELSE CAST(Total AS VARCHAR(MAX))
			 END
		 AS VARCHAR(MAX)) AS 'Total',
		CAST(CASE Successful
			 WHEN -1 THEN '-'
			 ELSE CAST(Successful AS VARCHAR(MAX))
			 END
		 AS VARCHAR(MAX)) AS 'Completed',
		CAST(CASE CompletedWithErrorJobs + CompletedWithWarningJobs
			 WHEN -2 THEN '-'
			 ELSE CAST(CompletedWithErrorJobs + CompletedWithWarningJobs AS VARCHAR(MAX))
			 END
		 AS VARCHAR(MAX)) AS 'Completed with Errors or Warnings',
		CAST(CASE Failed
			 WHEN -1 THEN '-'
			 ELSE CAST(Failed AS VARCHAR(MAX))
			 END
		 AS VARCHAR(MAX)) AS 'Failed',
		CAST(CASE Killed
					 WHEN -1 THEN '-'
					 ELSE CAST(Killed AS VARCHAR(MAX))
					 END
				 AS VARCHAR(MAX)) AS 'Killed',
		CAST(CASE Skipped
				WHEN -1 THEN '-'
				ELSE CAST(Skipped AS VARCHAR(MAX))
				END
			AS VARCHAR(MAX)) AS 'Skipped',
		CAST(CASE CommittedJ
				WHEN -1 THEN '-'
				ELSE CAST(CommittedJ AS VARCHAR(MAX))
				END
			AS VARCHAR(MAX)) AS 'Committed',
		datediff(second, '01/01/1970',servEndDate) AS 'As Of<DWDDMMM>'
	FROM @Week_table
	ORDER BY servEndDate
	END
	ELSE
	BEGIN
	SELECT
		CAST(CASE S_Rate
			 WHEN -1 THEN '-'
			 ELSE CAST(S_Rate AS VARCHAR(MAX))
			 END
		 AS VARCHAR(MAX)) AS 'Success Rate (%)',
		CAST(CASE Total
			 WHEN -1 THEN '-'
			 ELSE CAST(Total AS VARCHAR(MAX))
			 END
		 AS VARCHAR(MAX)) AS 'Total',
		CAST(CASE Successful
			 WHEN -1 THEN '-'
			 ELSE CAST(Successful AS VARCHAR(MAX))
			 END
		 AS VARCHAR(MAX)) AS 'Completed',
		CAST(CASE CompletedWithErrorJobs + CompletedWithWarningJobs
			 WHEN -2 THEN '-'
			 ELSE CAST(CompletedWithErrorJobs + CompletedWithWarningJobs AS VARCHAR(MAX))
			 END
		 AS VARCHAR(MAX)) AS 'Completed with Errors or Warnings',
		CAST(CASE Failed
			 WHEN -1 THEN '-'
			 ELSE CAST(Failed AS VARCHAR(MAX))
			 END
		 AS VARCHAR(MAX)) AS 'Failed',
		CAST(CASE Killed
			 WHEN -1 THEN '-'
			 ELSE CAST(Killed AS VARCHAR(MAX))
			 END
		 AS VARCHAR(MAX)) AS 'Killed',
		CAST(CASE Skipped
				WHEN -1 THEN '-'
				ELSE CAST(Skipped AS VARCHAR(MAX))
				END
			AS VARCHAR(MAX)) AS 'Skipped',
		CAST(CASE CommittedJ
				WHEN -1 THEN '-'
				ELSE CAST(CommittedJ AS VARCHAR(MAX))
				END
			AS VARCHAR(MAX)) AS 'Committed',
		datediff(second, '01/01/1970',servEndDate) AS 'As Of<DWDDMMM>'
	FROM @Week_table WHERE Total<>-1
	ORDER BY servEndDate
	END
	IF object_id('tempdb.dbo.#TempIdaDailyBkp') IS NOT NULL DROP TABLE #TempIdaDailyBkp
END
ELSE IF @WeeklyMonth = 2 --MONTHLY DATA ONLY
BEGIN
	DECLARE @Month_table TABLE
	(
	S_Rate						DECIMAL(7, 1),
	Total						BIGINT ,
	Successful					BIGINT ,
	CompletedWithErrorJobs		BIGINT ,
	CompletedWithWarningJobs	BIGINT ,
	Failed                      BIGINT ,
	Killed                      BIGINT ,
	Skipped                     BIGINT ,
	CommittedJ                   BIGINT ,
	servEndDate					DATE
	)
	DECLARE @mtoday DATE
	if ( @i_CommServUniqueID =0)
	SET @mtoday = (SELECT CAST(GETDATE() AS DATE))
	else
	set @mtoday = @collectionDate
	;WITH R(N) AS
	(
	SELECT 0
	UNION ALL
	SELECT N+1
	FROM R
	WHERE N < 11
	)
	INSERT INTO @Month_table
	SELECT   -1,-1,-1,-1,-1,-1,-1,-1,-1, DATEADD(MONTH,-N,DATEADD(DAY, -(DAY(@mtoday)-1),@mtoday))
	FROM R
	UPDATE @Month_table
	set Total					= (T.Total) ,
	Successful				= (T.Successful) ,
	CompletedWithErrorJobs	= (t.CompletedWithErrorJobs) ,
	CompletedWithWarningJobs= (T.CompletedWithWarningJobs) ,
	S_Rate = T.S_Rate,
	Failed = T.Failed,
	Killed = T.Killed,
	Skipped = T.Skipped,
	CommittedJ = T.CommittedJ
	FROM
	(
	SELECT S_Rate = CAST(CASE SUM(csInfo.completedjobs) +SUM(csInfo.CWEJobs)+SUM(csInfo.CWWJobs)
						WHEN 0 THEN 0
						ELSE ((SUM(csInfo.completedjobs) +SUM(csInfo.CWEJobs)+SUM(csInfo.CWWJobs)) * 100.0)/(SUM(csInfo.totaljobs)-ISNULL(SUM(csInfo.SkippedJobs),0)-(CASE WHEN @FTSASFailedJobs = 0 THEN SUM(csInfo.FailedToStartJobs)  ELSE 0 END))
					 END
					AS DECIMAL(7, 2)),
	Total					= SUM(csInfo.totaljobs) -ISNULL(SUM(csInfo.SkippedJobs),0)-(CASE WHEN @FTSASFailedJobs = 0 THEN SUM(csInfo.FailedToStartJobs)  ELSE 0 END),
	Successful				= SUM(csInfo.completedjobs) ,
	CompletedWithErrorJobs	= SUM(csInfo.CWEJobs) ,
	CompletedWithWarningJobs= SUM(csInfo.CWWJobs) ,
	Failed			= sum(csInfo.FailedJobs)+(CASE WHEN @FTSASFailedJobs = 1 THEN SUM(csInfo.FailedToStartJobs)  ELSE 0 END),
	Killed			= ISNULL(SUM(csInfo.KilledJobs),-1),
	Skipped			= ISNULL(SUM(csInfo.SkippedJobs)+(CASE WHEN @FTSASFailedJobs = 0 THEN SUM(csInfo.FailedToStartJobs)  ELSE 0 END),-1),
	CommittedJ		= ISNULL(SUM(csInfo.CommittedJobs),-1),
	servEndDate = MonthStart
	FROM cf_SurveyCompanyMonthlyBkpJobStats AS csInfo WITH (NOLOCK)
	INNER JOIN #LatestResult AS resultView
	ON resultView.CommServUniqueId = csInfo.CommServUniqueId
	INNER JOIN #TenantClientGroups AS T ON T.CommServUniqueId = csInfo.CommServUniqueId AND T.ClientGroupId = csInfo.ClientGroupId
			GROUP BY MonthStart
			) T
		INNER JOIN @Month_table AS mon
		ON mon.servEndDate = T.servEndDate
	IF EXISTS(SELECT Total FROM @Month_table WHERE Total<>-1)
	BEGIN
		SELECT
		CAST(CASE S_Rate
				 WHEN -1 THEN '-'
				 ELSE CAST(S_Rate AS VARCHAR(MAX))
				 END
			 AS VARCHAR(MAX)) AS 'Success Rate (%)',
			CAST(CASE Total
				 WHEN -1 THEN '-'
				 ELSE CAST(Total AS VARCHAR(MAX))
				 END
			 AS VARCHAR(MAX)) AS 'Total',
			CAST(CASE Successful
				 WHEN -1 THEN '-'
				 ELSE CAST(Successful AS VARCHAR(MAX))
				 END
			 AS VARCHAR(MAX)) AS 'Completed',
			CAST(CASE CompletedWithErrorJobs + CompletedWithWarningJobs
				 WHEN -2 THEN '-'
				 ELSE CAST(CompletedWithErrorJobs + CompletedWithWarningJobs AS VARCHAR(MAX))
				 END
			 AS VARCHAR(MAX)) AS 'Completed with Errors or Warnings',
			CAST(CASE Failed
				 WHEN -1 THEN '-'
				 ELSE CAST(Failed AS VARCHAR(MAX))
				 END
			 AS VARCHAR(MAX)) AS 'Failed',
			CAST(CASE Killed
				 WHEN -1 THEN '-'
				 ELSE CAST(Killed AS VARCHAR(MAX))
				 END
			 AS VARCHAR(MAX)) AS 'Killed',
			CAST(CASE Skipped
				 WHEN -1 THEN '-'
				 ELSE CAST(Skipped AS VARCHAR(MAX))
				 END
			 AS VARCHAR(MAX)) AS 'Skipped',
			CAST(CASE CommittedJ
				 WHEN -1 THEN '-'
				 ELSE CAST(CommittedJ AS VARCHAR(MAX))
				 END
			 AS VARCHAR(MAX)) AS 'Committed',
			 datediff(second, '01/01/1970',servEndDate) AS 'As Of<DWDDMMM>'
		FROM @Month_table
		ORDER BY DATEPART(YEAR, servEndDate) ,DATEPART(MONTH,servEndDate)
	END
	ELSE
	BEGIN
		SELECT
		CAST(CASE S_Rate
				 WHEN -1 THEN '-'
				 ELSE CAST(S_Rate AS VARCHAR(MAX))
				 END
			 AS VARCHAR(MAX)) AS 'Success Rate (%)',
			CAST(CASE Total
				 WHEN -1 THEN '-'
				 ELSE CAST(Total AS VARCHAR(MAX))
				 END
			 AS VARCHAR(MAX)) AS 'Total',
			CAST(CASE Successful
				 WHEN -1 THEN '-'
				 ELSE CAST(Successful AS VARCHAR(MAX))
				 END
			 AS VARCHAR(MAX)) AS 'Completed',
			CAST(CASE CompletedWithErrorJobs + CompletedWithWarningJobs
				 WHEN -2 THEN '-'
				 ELSE CAST(CompletedWithErrorJobs + CompletedWithWarningJobs AS VARCHAR(MAX))
				 END
			 AS VARCHAR(MAX)) AS 'Completed with Errors or Warnings',
			CAST(CASE Failed
				 WHEN -1 THEN '-'
				 ELSE CAST(Failed AS VARCHAR(MAX))
				 END
			 AS VARCHAR(MAX)) AS 'Failed',
			CAST(CASE Killed
				 WHEN -1 THEN '-'
				 ELSE CAST(Killed AS VARCHAR(MAX))
				 END
			 AS VARCHAR(MAX)) AS 'Killed',
		CAST(CASE Skipped
				 WHEN -1 THEN '-'
				 ELSE CAST(Skipped AS VARCHAR(MAX))
				 END
			 AS VARCHAR(MAX)) AS 'Skipped',
		CAST(CASE CommittedJ
				 WHEN -1 THEN '-'
				 ELSE CAST(CommittedJ AS VARCHAR(MAX))
				 END
			 AS VARCHAR(MAX)) AS 'Committed',
			 datediff(second, '01/01/1970',servEndDate) AS 'As Of<DWDDMMM>'
		FROM @Month_table
		WHERE Total<>-1
		ORDER BY DATEPART(YEAR, servEndDate) ,DATEPART(MONTH,servEndDate)
	END
END
SET NOCOUNT OFF
GO

IF EXISTS (select * from GxQscripts where name = 'RptBkpJobStatus_WMonForCompany')
	delete from GxQscripts where name = 'RptBkpJobStatus_WMonForCompany'
GO

IF EXISTS (select * from GXDBVersions where aliasname='RptBkpJobStatus_WMonForCompany')
	delete from GXDBVersions where aliasname = 'RptBkpJobStatus_WMonForCompany'
GO

insert into GXDBVersions values(2, 'RptBkpJobStatus_WMonForCompany',  '00010001000200030000', 'RptBkpJobStatus_WMonForCompany', '00010001000200030000')
GO

