

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Sp/RptDATroubleshootingInfo.sp] ---------- 

-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Sp/RptDATroubleshootingInfo.sp,v $ $Id: RptDATroubleshootingInfo.sp,v 1.1.2.3 2020/12/28 18:13:05 pkrishnan Exp $";
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON


IF EXISTS (select * from sysobjects where name='RptDATroubleshootingInfo')
BEGIN
	print '>>> Drop Stored Procedure: RptDATroubleshootingInfo <<<'
	drop procedure RptDATroubleshootingInfo
END
IF EXISTS (select * from GxQscripts where name='RptDATroubleshootingInfo')
	delete from GxQscripts where name = 'RptDATroubleshootingInfo'
GO

IF EXISTS (select * from GXDBVersions where aliasname='RptDATroubleshootingInfo')
	delete from GXDBVersions where aliasname = 'RptDATroubleshootingInfo'
GO
print '... Creating Procedure: RptDATroubleshootingInfo'
GO
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON
GO
create procedure RptDATroubleshootingInfo
  @i_UserId INT = NULL,
  @i_GroupId INT = NULL,
  @blaggregate INT = 1,
  @blLatestSurvey INT = 1,
  @i_CommServUniqueID INT = 0,
  @i_LogDateStart DATETIME = NULL,
  @i_LogDateEND DATETIME = NULL
AS
SET NOCOUNT ON
DECLARE @i_QueryId BIGINT = 260
SET @blLatestSurvey = 1 --Always pickup the latest
IF(@blaggregate=1)
	RETURN
DECLARE @strGood     VARCHAR(10) = '1_Good'
DECLARE @strInfo     VARCHAR(10) = '2_Info'
DECLARE @strwarning  VARCHAR(10) = '3_Warning'
DECLARE @strCritical VARCHAR(10) = '4_Critical'
CREATE TABLE #LatestResults (ResultId INT, CommservUniqueId INT, CommCellID VARCHAR(32), CommServName NVARCHAR(288))
INSERT	INTO #LatestResults
SELECT	SurverResultId, CommservUniqueId, CommCellID, DisplayName
FROM	dbo.cf_SurveyResultFuncV1(@i_QueryId, @i_CommServUniqueID, 1, NULL, NULL, @i_UserId, @i_GroupId)
IF @i_CommServUniqueID = 0
BEGIN
	SELECT 	R.CommServUniqueId  AS 'CommServ UniqueId',
			R.CommCellID        AS 'CommCell ID',
			R.CommServName      AS 'CommCell Name',
			L.LibraryName       AS 'Library',
			CASE L.LibraryTypeId WHEN 3 THEN 'Disk' WHEN -3 THEN 'Cloud' ELSE 'Tape' END AS 'Library Type',
			Info.MountPathName  AS 'Mount Path',
--			CASE Info.PendingDeletes WHEN 0 THEN 'No' ELSE 'Yes' END AS 'Pending Deletes',
			ProblemDescription	AS 'Problem',
			Recommendation		AS 'Recommendation',
--			Doclink				AS 'Document',
			'<a href="/webconsole/reportsplus/reportViewer.jsp?reportId=Data%20Aging%20Troubleshooting&input.Libraries=%5B'+CAST(Info.LibraryId AS VARCHAR(16))+'%5D" target="_blank" >View report</a>' AS 'View Report',
			CASE Info.Severity WHEN 3 THEN @strCritical	WHEN 2 THEN	@strWarning ELSE @strGood END AS 'Status<HEALTH_STATUS>'
	FROM	#LatestResults R
			INNER JOIN cf_SurveyDATroubleshootingInfo Info ON R.ResultId = Info.SurveyResultId
			INNER JOIN cf_SurveyLibrary AS L ON R.CommServUniqueId = L.CommServUniqueId AND Info.LibraryId = L.LibraryId
	ORDER BY R.CommServName, [Status<HEALTH_STATUS>] DESC, L.LibraryName, Info.MountPathName
END
ELSE
BEGIN
	SELECT 	L.LibraryName       AS 'Library',
			CASE L.LibraryTypeId WHEN 3 THEN 'Disk' WHEN -3 THEN 'Cloud' ELSE 'Tape' END AS 'Library Type',
			Info.MountPathName  AS 'Mount Path',
--			CASE Info.PendingDeletes WHEN 0 THEN 'No' ELSE 'Yes' END AS 'Pending Deletes',
			ProblemDescription	AS 'Problem',
			Recommendation		AS 'Recommendation',
--			Doclink				AS 'Document',
			'<a href="/webconsole/reportsplus/reportViewer.jsp?reportId=Data%20Aging%20Troubleshooting&input.Libraries=%5B'+CAST(Info.LibraryId AS VARCHAR(16))+'%5D" target="_blank" >View report</a>' AS 'View Report',
			CASE Info.Severity WHEN 3 THEN @strCritical	WHEN 2 THEN	@strWarning ELSE @strGood END AS 'Status<HEALTH_STATUS>'
	FROM	#LatestResults R
			INNER JOIN cf_SurveyDATroubleshootingInfo Info ON R.ResultId = Info.SurveyResultId
			INNER JOIN cf_SurveyLibrary AS L ON R.CommServUniqueId = L.CommServUniqueId AND Info.LibraryId = L.LibraryId
	ORDER BY [Status<HEALTH_STATUS>] DESC, L.LibraryName, Info.MountPathName
END
DROP TABLE #LatestResults
SET NOCOUNT OFF
GO

IF EXISTS (select * from GxQscripts where name = 'RptDATroubleshootingInfo')
	delete from GxQscripts where name = 'RptDATroubleshootingInfo'
GO

IF EXISTS (select * from GXDBVersions where aliasname='RptDATroubleshootingInfo')
	delete from GXDBVersions where aliasname = 'RptDATroubleshootingInfo'
GO

insert into GXDBVersions values(2, 'RptDATroubleshootingInfo',  '00010001000200030000', 'RptDATroubleshootingInfo', '00010001000200030000')
GO

