

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Sp/RptDiskLibraryUsageWrapper.sp] ---------- 

-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Sp/RptDiskLibraryUsageWrapper.sp,v $ $Id: RptDiskLibraryUsageWrapper.sp,v 1.1.2.1 2020/10/29 01:13:12 junlu Exp $";
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON


IF EXISTS (select * from sysobjects where name='RptDiskLibraryUsageWrapper')
BEGIN
	print '>>> Drop Stored Procedure: RptDiskLibraryUsageWrapper <<<'
	drop procedure RptDiskLibraryUsageWrapper
END
IF EXISTS (select * from GxQscripts where name='RptDiskLibraryUsageWrapper')
	delete from GxQscripts where name = 'RptDiskLibraryUsageWrapper'
GO

IF EXISTS (select * from GXDBVersions where aliasname='RptDiskLibraryUsageWrapper')
	delete from GXDBVersions where aliasname = 'RptDiskLibraryUsageWrapper'
GO
print '... Creating Procedure: RptDiskLibraryUsageWrapper'
GO
SET QUOTED_IDENTIFIER ON
SET NOCOUNT ON
GO
create procedure RptDiskLibraryUsageWrapper
  @i_UserId INT = NULL,
  @i_GroupId INT = NULL,
  @blaggregate INT = 1, -- 0 for Disk libraries and 2 for Cloud libraries
  @blLatestSurvey INT = 1,
  @i_CSUniqueID INT = 0,
  @i_LogDateStart DATETIME = NULL,
  @i_LogDateEND DATETIME = NULL,
  @i_optParameter VARCHAR(MAX) = 0, -- '1' for showing Average Space Consumed/Freed Per Day
  @i_trend INT = 0,
  @i_Library VARCHAR(MAX) =NULL
AS
SET NOCOUNT ON
/* This temp table is created by caller
CREATE TABLE #RptDiskLibraryUsageWrapper_Output (
    CommServUniqueId      INT,
    CommCellName          NVARCHAR(256),
    Library               NVARCHAR(256),
    MountPathShared       NVARCHAR(32),
    CapacityMB            BIGINT,
    FreeSpaceMB           BIGINT,
    AvailableSpaceMB      BIGINT,
    AvailableSpacePct     DECIMAL(10,2),
    ReserveSpaceMB        BIGINT,
    DateToBeFull          NVARCHAR(256),
    RangeOfDateToBeFull   NVARCHAR(256),
    DataWrittenMB         BIGINT,
    AppSizeMB             BIGINT,
    PrevMonthChangeMB     BIGINT,
    PrevMonthChangePct    DECIMAL(10,2),
    CurrMonthChangeMB     BIGINT,
    CurrMonthChangePct    DECIMAL(10,2),
    LowWatermarkPct       NVARCHAR(256),
    ReachLowWatermark     BIGINT,
    SixMonthGrowthMB      BIGINT,
    TwelveMonthGrowthMB   BIGINT,
    EighteenMonthGrowthMB BIGINT,
    Status                NVARCHAR(32)
)
*/
IF OBJECT_ID('tempdb.dbo.#DiskLibraryUsage') IS NOT NULL DROP TABLE #DiskLibraryUsage
CREATE TABLE #DiskLibraryUsage (
    CommServUniqueId      INT,
    CommCellName          NVARCHAR(256),
    CommCellID            INT,
    Library               NVARCHAR(256),
    MountPathShared       NVARCHAR(32),
    CapacityMB            BIGINT,
    FreeSpaceMB           BIGINT,
    AvailableSpaceMB      BIGINT,
    AvailableSpacePct     DECIMAL(10,2),
    ReserveSpaceMB        BIGINT,
    DateToBeFull          BIGINT,
    RangeOfDateToBeFull   NVARCHAR(256),
    DataWrittenMB         BIGINT,
    AppSizeMB             BIGINT,
	AvgConsumedMBPerDay   BIGINT,
	AvgFreedMBPerDay      BIGINT,
	DataAgingProblem      NVARCHAR(MAX),
    PrevMonthChangeMB     BIGINT,
    PrevMonthChangePct    DECIMAL(10,2),
    CurrMonthChangeMB     BIGINT,
    CurrMonthChangePct    DECIMAL(10,2),
    LowWatermarkPct       NVARCHAR(256),
    ReachLowWatermark     BIGINT,
    SixMonthGrowthMB      BIGINT,
    TwelveMonthGrowthMB   BIGINT,
    EighteenMonthGrowthMB BIGINT,
    Status                NVARCHAR(32)
)
IF @i_CSUniqueID > 0
	ALTER TABLE #DiskLibraryUsage DROP COLUMN CommCellID
IF @i_optParameter = 0
BEGIN
	ALTER TABLE #DiskLibraryUsage DROP COLUMN AvgConsumedMBPerDay
	ALTER TABLE #DiskLibraryUsage DROP COLUMN AvgFreedMBPerDay
END
INSERT INTO #DiskLibraryUsage
EXEC Rpt_96DiskLibDetails @i_UserId, @i_GroupId, @blaggregate, @blLatestSurvey, @i_CSUniqueID, @i_LogDateStart, @i_LogDateEND, @i_optParameter, @i_trend, @i_Library
INSERT INTO #RptDiskLibraryUsageWrapper_Output
SELECT
	CommServUniqueId,
    CommCellName,
    Library,
	MountPathShared,
    CapacityMB,
    FreeSpaceMB,
    AvailableSpaceMB,
    AvailableSpacePct,
    ReserveSpaceMB,
    DateToBeFull,
	RangeOfDateToBeFull,
    DataWrittenMB,
    AppSizeMB,
    PrevMonthChangeMB,
    PrevMonthChangePct,
    CurrMonthChangeMB,
    CurrMonthChangePct,
    LowWatermarkPct,
    ReachLowWatermark,
    SixMonthGrowthMB,
    TwelveMonthGrowthMB,
    EighteenMonthGrowthMB,
    Status
FROM #DiskLibraryUsage
SET NOCOUNT OFF
GO

IF EXISTS (select * from GxQscripts where name = 'RptDiskLibraryUsageWrapper')
	delete from GxQscripts where name = 'RptDiskLibraryUsageWrapper'
GO

IF EXISTS (select * from GXDBVersions where aliasname='RptDiskLibraryUsageWrapper')
	delete from GXDBVersions where aliasname = 'RptDiskLibraryUsageWrapper'
GO

insert into GXDBVersions values(2, 'RptDiskLibraryUsageWrapper',  '00010001000200010000', 'RptDiskLibraryUsageWrapper', '00010001000200010000')
GO

