

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Sp/RptLargestNoSnapClients.sp] ---------- 

-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Sp/RptLargestNoSnapClients.sp,v $ $Id: RptLargestNoSnapClients.sp,v 1.10.40.2 2018/08/16 11:33:47 skatz Exp $";
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER OFF
print '>>> Drop Stored Procedure: RptLargestNoSnapClients <<<'

IF EXISTS (select * from sysobjects where name='RptLargestNoSnapClients')
	drop procedure RptLargestNoSnapClients
IF EXISTS (select * from GxQscripts where name='RptLargestNoSnapClients')
	delete from GxQscripts where name = 'RptLargestNoSnapClients'
GO

IF EXISTS (select * from GXDBVersions where aliasname='RptLargestNoSnapClients')
	delete from GXDBVersions where aliasname = 'RptLargestNoSnapClients'
GO
print '... Creating Procedure: RptLargestNoSnapClients'
GO
SET QUOTED_IDENTIFIER ON
GO
create procedure RptLargestNoSnapClients
  @i_UserId INT = NULL,
  @i_GroupId INT = NULL,
  @blaggregate INT = 1,
  @blLatestSurvey INT = 1,
  @i_CommServUniqueID INT = 0,
  @i_LogDateStart DATETIME = NULL,
  @i_LogDateEND DATETIME = NUll
AS
IF(@blaggregate=1)
	RETURN
SET NOCOUNT ON
SET @blLatestSurvey = 1 --Always pickup the latest
DECLARE @i_QueryId BIGINT = 23
IF @i_CommServUniqueID = 0
BEGIN
 SELECT
	resultView.CommServUniqueId  AS 'CommServ UniqueId',
	resultView.CommCellID AS 'CommCell ID',
	resultView.CommServIP AS 'CommServe IP<HIDDEN>',
	resultView.DisplayName AS 'CommCell Name',
	ISNULL(CL.clientDisplayName, csInfo.ClientName) AS 'Client',
	csInfo.AppTypeName AS 'Agent Type',
	CAST(ISNULL(csInfo.ApplicationSizeTB, 0)*1024.00*1024.00 AS DECIMAL(32,2)) AS 'Application Size<SIZEMB>',
	CASE
		WHEN csInfo.RestoreThroughput <= 0 THEN '-1'
		ELSE CAST(csInfo.RestoreThroughput AS DECIMAL(32,2))
	END AS 'Last Restore Throughput (GB/HR)<NumberNA>',
	CASE
		WHEN csInfo.RestoreThroughput <= 0 THEN '-1'
		ELSE CAST((csInfo.ApplicationSizeTB*1024.0/csInfo.RestoreThroughput)*60 AS BIGINT)
	END AS 'Estimated Full Recovery Time (hh:mm)<HHMM>',
	csInfo.RecoverDurationInSeconds/60 AS 'Last Recovery Time (hh:mm)<HHMM>'
 FROM cf_SurveyLargestNoSnapClients AS csInfo WITH (NOLOCK)
	INNER JOIN dbo.cf_SurveyResultFuncV1(@i_QueryId, @i_CommServUniqueID, @blLatestSurvey, @i_LogDateStart, @i_LogDateEND,@i_UserId,@i_GroupId) AS resultView
		ON resultView.SurverResultId = csInfo.SurveyResultId AND csInfo.ClientId <> 0
	LEFT  JOIN cf_SurveyClient CL WITH (NOLOCK) ON CL.CommServUniqueId = csInfo.CommServUniqueId AND CL.ClientId = csInfo.ClientId
 ORDER BY csInfo.ApplicationSizeTB DESC
END
ELSE
SELECT
	csInfo.CommServUniqueId AS 'CommServ UniqueId',
	ISNULL(CL.clientDisplayName, csInfo.ClientName) AS 'Client',
	csInfo.AppTypeName AS 'Agent Type',
	CAST(ISNULL(csInfo.ApplicationSizeTB, 0)*1024.00*1024.00 AS DECIMAL(32,2)) AS 'Application Size<SIZEMB>',
	CASE
		WHEN csInfo.RestoreThroughput <= 0 THEN '-1'
		ELSE CAST(csInfo.RestoreThroughput AS DECIMAL(32,2))
	END AS 'Last Restore Throughput (GB/HR)<NumberNA>',
	CASE
		WHEN csInfo.RestoreThroughput <= 0 THEN '-1'
		ELSE CAST((csInfo.ApplicationSizeTB*1024.0/csInfo.RestoreThroughput)*60 AS BIGINT)
	END AS 'Estimated Full Recovery Time (hh:mm)<HHMM>',
	csInfo.RecoverDurationInSeconds/60 AS 'Last Recovery Time (hh:mm)<HHMM>'
FROM cf_SurveyLargestNoSnapClients AS csInfo WITH (NOLOCK)
	INNER JOIN dbo.cf_SurveyResultFuncV1(@i_QueryId, @i_CommServUniqueID, @blLatestSurvey, @i_LogDateStart, @i_LogDateEND,@i_UserId,@i_GroupId) AS resultView
		ON resultView.SurverResultId = csInfo.SurveyResultId AND csInfo.ClientId <> 0
	LEFT  JOIN cf_SurveyClient CL WITH (NOLOCK) ON CL.CommServUniqueId = csInfo.CommServUniqueId AND CL.ClientId = csInfo.ClientId
ORDER BY csInfo.ApplicationSizeTB DESC
SET NOCOUNT OFF
GO
/*
-- FOR STANDALONE TESTING:
  DECLARE @i_UserId INT					= 1
  DECLARE @i_GroupId INT				= NULL
  DECLARE @blaggregate INT				= 0
  DECLARE @blLatestSurvey INT			= 1
  DECLARE @i_CommServUniqueID INT		= 11065
  DECLARE @i_LogDateEND DATETIME		= 	NULL    -- getDate()
  DECLARE @i_LogDateStart DATETIME		= NULL   --DateAdd(Month, -36, @i_LogDateEND)
exec RptLargestNoSnapClients @i_UserId, @i_GroupId, @blaggregate, @blLatestSurvey, @i_CommServUniqueID, @i_LogDateStart, @i_LogDateEND
*/

IF EXISTS (select * from GxQscripts where name = 'RptLargestNoSnapClients')
	delete from GxQscripts where name = 'RptLargestNoSnapClients'
GO

IF EXISTS (select * from GXDBVersions where aliasname='RptLargestNoSnapClients')
	delete from GXDBVersions where aliasname = 'RptLargestNoSnapClients'
GO

insert into GXDBVersions values(2, 'RptLargestNoSnapClients',  '00010010004000020000', 'RptLargestNoSnapClients', '00010010004000020000')
GO

