

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Sp/RptLastFullInDDB.sp] ---------- 

-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Sp/RptLastFullInDDB.sp,v $ $Id: RptLastFullInDDB.sp,v 1.1.2.3 2018/08/16 11:33:50 skatz Exp $";
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER OFF
print '>>> Drop Stored Procedure: RptLastFullInDDB <<<'

IF EXISTS (select * from sysobjects where name='RptLastFullInDDB')
	drop procedure RptLastFullInDDB
IF EXISTS (select * from GxQscripts where name='RptLastFullInDDB')
	delete from GxQscripts where name = 'RptLastFullInDDB'
GO

IF EXISTS (select * from GXDBVersions where aliasname='RptLastFullInDDB')
	delete from GXDBVersions where aliasname = 'RptLastFullInDDB'
GO
print '... Creating Procedure: RptLastFullInDDB'
GO
SET QUOTED_IDENTIFIER ON
GO
create procedure RptLastFullInDDB
  @i_UserId INT = NULL,
  @i_GroupId INT = NULL,
  @blaggregate INT = 1,
  @blLatestSurvey INT = 1,
  @i_CommServUniqueID INT = 0,
  @i_LogDateStart DATETIME = NULL,
  @i_LogDateEND DATETIME = NUll
AS
SET NOCOUNT ON
SET @blLatestSurvey = 1 --Always pickup the latest
DECLARE @i_QueryId BIGINT = 213
DECLARE @strGood VARCHAR(10) = '1_Good'
DECLARE @strInfo VARCHAR(10) = '2_Info'
DECLARE @strwarning VARCHAR(10) = '3_Warning'
DECLARE @strCritical VARCHAR(10) = '4_Critical'
/*DECLARE @criticalVal int
DECLARE @warningVal int
SELECT  @warningVal = WarningThreshold,
        @criticalVal =CriticalThreshold
FROM    cf_SurveyHealthParam WITH(NOLOCK) where queryId = @i_QueryId*/
DECLARE @utcTimeNow BIGINT = (SELECT dbo.getUnixTimeBig(GETUTCDATE()))
IF @i_CommServUniqueID = 0
BEGIN
	SELECT
		resultView.CommServUniqueId  AS 'CommServ UniqueId<DONOTSHOW>',
		resultView.CommCellID AS 'CommCell ID',
		resultView.DisplayName AS 'CommCell Name',
		ISNULL(CL.clientDisplayName, sub.ClientName) AS 'Client',
		sub.AgentName AS 'Agent',
		sub.SubclientName AS 'Subclient',
		copy.PolicyName AS 'Storage Policy',
		copy.CopyName AS 'Copy',
		csinfo.JobId AS 'Last Job Id<NumberNA>',
		CASE
			WHEN csinfo.JobId = -1 THEN -50
			ELSE dbo.GetUnixTimeBig(csinfo.StartTime)
		END AS 'Start Time<MMMDDYYYYHrMinAM>',
		csinfo.TotalBackupSize AS 'Total Backup Size<capacity>',
		CASE
				WHEN csinfo.Status = 3 THEN @strWarning
				WHEN csinfo.Status = 4 THEN @strCritical
				ELSE @strGood
		END as 'Status<HEALTH_STATUS>'
	FROM cf_SurveyLastFullInDDB csinfo WITH(NOLOCK)
		INNER JOIN dbo.cf_SurveyResultFuncV1(@i_QueryId, @i_CommServUniqueID, @blLatestSurvey, @i_LogDateStart, @i_LogDateEND, @i_UserId, @i_GroupId) AS resultView
					ON resultView.SurverResultId = csInfo.SurveyResultId
		INNER JOIN cf_SurveySubclientAssociation sub WITH(NOLOCK) ON resultView.CommServUniqueId = sub.CommServUniqueId AND csInfo.SubclientId = sub.AppId
		INNER JOIN cf_SurveyCopyBasicRetention copy WITH(NOLOCK) ON resultView.CommServUniqueId = copy.CommServUniqueId AND csInfo.CopyId = copy.CopyId
		LEFT  JOIN cf_SurveyClient CL WITH (NOLOCK) ON CL.CommServUniqueId = sub.CommServUniqueId AND CL.ClientId = sub.ClientId
	ORDER BY csinfo.Status DESC,resultView.DisplayName ASC, csinfo.TotalBackupSize DESC
END
ELSE
BEGIN
	SELECT
		ISNULL(CL.clientDisplayName, sub.ClientName) AS 'Client',
		sub.AgentName AS 'Agent',
		sub.SubclientName AS 'Subclient',
		copy.PolicyName AS 'Storage Policy',
		copy.CopyName AS 'Copy',
		csinfo.JobId AS 'Last Job Id<NumberNA>',
		CASE
			WHEN csinfo.JobId = -1 THEN -50
			ELSE dbo.GetUnixTimeBig(csinfo.StartTime)
		END AS 'Start Time<MMMDDYYYYHrMinAM>',
		csinfo.TotalBackupSize AS 'Total Backup Size<capacity>',
		CASE
			WHEN csinfo.Status = 3 THEN @strWarning
			WHEN csinfo.Status = 4 THEN @strCritical
			ELSE @strGood
		END as 'Status<HEALTH_STATUS>'
	FROM cf_SurveyLastFullInDDB csinfo WITH(NOLOCK)
		INNER JOIN dbo.cf_SurveyResultFuncV1(@i_QueryId, @i_CommServUniqueID, @blLatestSurvey, @i_LogDateStart, @i_LogDateEND, @i_UserId, @i_GroupId) AS resultView
					ON resultView.SurverResultId = csInfo.SurveyResultId
		INNER JOIN cf_SurveySubclientAssociation sub WITH(NOLOCK) ON resultView.CommServUniqueId = sub.CommServUniqueId AND csInfo.SubclientId = sub.AppId
		INNER JOIN cf_SurveyCopyBasicRetention copy WITH(NOLOCK) ON resultView.CommServUniqueId = copy.CommServUniqueId AND csInfo.CopyId = copy.CopyId
		LEFT  JOIN cf_SurveyClient CL WITH (NOLOCK) ON CL.CommServUniqueId = sub.CommServUniqueId AND CL.ClientId = sub.ClientId
	ORDER BY csinfo.Status DESC,csinfo.TotalBackupSize DESC
END
SET NOCOUNT OFF
GO
/*
-- FOR STANDALONE TESTING:
  DECLARE @i_UserId INT					= 1
  DECLARE @i_GroupId INT				= NULL
  DECLARE @blaggregate INT				= 0
  DECLARE @blLatestSurvey INT			= 1
  DECLARE @i_CommServUniqueID INT		= 11065
  DECLARE @i_LogDateEND DATETIME		= 	NULL    -- getDate()
  DECLARE @i_LogDateStart DATETIME		= NULL   --DateAdd(Month, -36, @i_LogDateEND)
exec RptLastFullInDDB @i_UserId, @i_GroupId, @blaggregate, @blLatestSurvey, @i_CommServUniqueID, @i_LogDateStart, @i_LogDateEND
*/

IF EXISTS (select * from GxQscripts where name = 'RptLastFullInDDB')
	delete from GxQscripts where name = 'RptLastFullInDDB'
GO

IF EXISTS (select * from GXDBVersions where aliasname='RptLastFullInDDB')
	delete from GXDBVersions where aliasname = 'RptLastFullInDDB'
GO

insert into GXDBVersions values(2, 'RptLastFullInDDB',  '00010001000200030000', 'RptLastFullInDDB', '00010001000200030000')
GO

