

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Sp/RptUnsupportedClient.sp] ---------- 

-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Sp/RptUnsupportedClient.sp,v $ $Id: RptUnsupportedClient.sp,v 1.5.56.2 2018/08/16 11:34:17 skatz Exp $";
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER OFF
print '>>> Drop Stored Procedure: RptUnsupportedClient <<<'

IF EXISTS (select * from sysobjects where name='RptUnsupportedClient')
	drop procedure RptUnsupportedClient
IF EXISTS (select * from GxQscripts where name='RptUnsupportedClient')
	delete from GxQscripts where name = 'RptUnsupportedClient'
GO

IF EXISTS (select * from GXDBVersions where aliasname='RptUnsupportedClient')
	delete from GXDBVersions where aliasname = 'RptUnsupportedClient'
GO
print '... Creating Procedure: RptUnsupportedClient'
GO
SET QUOTED_IDENTIFIER ON
GO
create procedure RptUnsupportedClient
  @i_UserId INT = NULL,
  @i_GroupId INT = NULL,
  @blaggregate INT = 1,
  @blLatestSurvey INT = 1,
  @i_CommServUniqueID INT = 0,
  @i_LogDateStart DATETIME = NULL,
  @i_LogDateEND DATETIME = NUll
AS
IF(@blaggregate=1)
	RETURN
SET NOCOUNT ON
SET @blLatestSurvey = 1 --Always pickup the latest
DECLARE @i_QueryId BIGINT = 18
IF @i_CommServUniqueID = 0
BEGIN
SELECT
	resultView.CommServUniqueId  AS 'CommServ UniqueId',
	resultView.CommCellID AS 'CommCell ID',
	resultView.CommServIP AS 'CommServe IP<HIDDEN>',
	resultView.CommServGUID AS 'CommServer GUID',
	resultView.DisplayName AS 'CommCell Name',
	--ISNULL((CONVERT(VARCHAR(20), csInfo.LogDate, 100) + ' (' + resultView.CommServTimeZone + ')'), 'N/A') AS 'Collection Time',
	CASE
		WHEN resultView.RunningTime = -1 THEN 'N/A'
		ELSE CAST(resultView.RunningTime AS VARCHAR(MAX))
	END AS 'Running Time in Seconds',
	--csInfo.ClientId AS 'Client Id',
	ISNULL (CL.ClientDisplayName, csInfo.clientName) AS [Client],
	csInfo.clientName  AS [Client(classic)<HIDDEN>],
	csInfo.ClientVersion AS 'Installed Version'
FROM cf_SurveyUnsupportedClientInfo AS csInfo WITH (NOLOCK)
	INNER JOIN dbo.cf_SurveyResultFuncV1(@i_QueryId, @i_CommServUniqueID, @blLatestSurvey, @i_LogDateStart, @i_LogDateEND,@i_UserId,@i_GroupId) AS resultView
		ON resultView.SurverResultId = csInfo.SurveyResultId
		AND resultView.LogDateUTC = csInfo.LogDateUTC
		AND resultView.CommServUniqueId = csInfo.CommServUniqueId
		AND ((resultView.SureyResultFlags = @blLatestSurvey) OR @blLatestSurvey = 0)
		AND (csInfo.CommServUniqueId = @i_CommServUniqueID OR @i_CommServUniqueID = 0)
		LEFT JOIN cf_SurveyClient CL WITH (NOLOCK) ON CL.CommServUniqueId = csInfo.CommServUniqueId AND CL.ClientId = csInfo.ClientId
ORDER BY csInfo.LogDate DESC, resultView.DisplayName ASC
END
ELSE
SELECT
	csInfo.CommServUniqueId AS 'CommServ UniqueId',
	--CONVERT(VARCHAR(20), csInfo.LogDate, 100) AS 'Collection Time',
	--csInfo.ClientId AS 'Client Id',
	ISNULL (CL.ClientDisplayName, csInfo.clientName) AS [Client],
	csInfo.clientName  AS [Client(classic)<HIDDEN>],
	csInfo.ClientVersion AS 'Installed Version'
FROM cf_SurveyUnsupportedClientInfo AS csInfo WITH (NOLOCK)
	INNER JOIN dbo.cf_SurveyResultFuncV1(@i_QueryId, @i_CommServUniqueID, @blLatestSurvey, @i_LogDateStart, @i_LogDateEND,@i_UserId,@i_GroupId) AS resultView
		ON resultView.SurverResultId = csInfo.SurveyResultId
		AND resultView.LogDateUTC = csInfo.LogDateUTC
		AND resultView.CommServUniqueId = csInfo.CommServUniqueId
		AND ((resultView.SureyResultFlags = @blLatestSurvey) OR @blLatestSurvey = 0)
		AND (csInfo.CommServUniqueId = @i_CommServUniqueID OR @i_CommServUniqueID = 0)
	LEFT JOIN cf_SurveyClient CL WITH (NOLOCK) ON CL.CommServUniqueId = csInfo.CommServUniqueId AND CL.ClientId = csInfo.ClientId
ORDER BY [Client]    -- csInfo.clientName
SET NOCOUNT OFF
GO
/*
-- FOR STANDALONE TESTING:
  DECLARE @i_UserId INT					= 1
  DECLARE @i_GroupId INT				= 0
  DECLARE @blaggregate INT				= 0
  DECLARE @blLatestSurvey INT			= 1
  DECLARE @i_CommServUniqueID INT		= 0
  DECLARE @i_LogDateEND DATETIME		= getDate()
  DECLARE @i_LogDateStart DATETIME		= DateAdd(month, -36, @i_LogDateEND)
exec RptUnsupportedClient @i_UserId, @i_GroupId, @blaggregate, @blLatestSurvey, @i_CommServUniqueID, @i_LogDateStart, @i_LogDateEND
*/

IF EXISTS (select * from GxQscripts where name = 'RptUnsupportedClient')
	delete from GxQscripts where name = 'RptUnsupportedClient'
GO

IF EXISTS (select * from GXDBVersions where aliasname='RptUnsupportedClient')
	delete from GXDBVersions where aliasname = 'RptUnsupportedClient'
GO

insert into GXDBVersions values(2, 'RptUnsupportedClient',  '00010005005600020000', 'RptUnsupportedClient', '00010005005600020000')
GO

