

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Sp/Rpt_67ClientDetails.sp] ---------- 

-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Sp/Rpt_67ClientDetails.sp,v $ $Id: Rpt_67ClientDetails.sp,v 1.15.42.16 2020/10/27 19:57:06 junlu Exp $";
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER OFF

IF EXISTS (select * from sysobjects where name='Rpt_67ClientDetails')
BEGIN
	print '>>> Drop Stored Procedure: Rpt_67ClientDetails <<<'
	drop procedure Rpt_67ClientDetails
END
IF EXISTS (select * from GxQscripts where name='Rpt_67ClientDetails')
	delete from GxQscripts where name = 'Rpt_67ClientDetails'
GO

IF EXISTS (select * from GXDBVersions where aliasname='Rpt_67ClientDetails')
	delete from GXDBVersions where aliasname = 'Rpt_67ClientDetails'
GO
print '... Creating Procedure: Rpt_67ClientDetails'
GO
SET QUOTED_IDENTIFIER ON
GO
create procedure Rpt_67ClientDetails
  @i_UserId INT = NULL,
  @i_GroupId INT = NULL,
  @blaggregate INT = 1,
  @blLatestSurvey INT = 1,
  @i_CommServUniqueID INT = 0,
  @i_LogDateStart DATETIME = NULL,
  @i_LogDateEND DATETIME = NUll,
  @i_clientType INT = 0,
  @i_CategoryName NVARCHAR(255) = NULL,
  @i_TenantName NVARCHAR(255) = NULL,
  @i_IncludeUninstalledSince DATETIME = NULL
AS
SET NOCOUNT ON
IF @i_clientType <> 0
BEGIN
	EXEC Rpt_104ExceptionalClients @i_UserId,@i_GroupId,@blaggregate,@blLatestSurvey,@i_CommServUniqueID,@i_LogDateStart,@i_LogDateEND,@i_CategoryName,@i_TenantName
	RETURN
END
IF object_id('tempdb.dbo.#TenantClients') IS NOT NULL DROP TABLE #TenantClients
CREATE TABLE #TenantClients (CommServUniqueId INT, TenantName NVARCHAR(255), ClientId INT)
exec GetTenantEntities @i_UserId, @i_GroupId, @blaggregate, @blLatestSurvey, @i_CommServUniqueID, @i_LogDateStart, @i_LogDateEND, @i_TenantName
SET @blLatestSurvey = 1 --Always pickup the latest
DECLARE @i_QueryId BIGINT = 1
/*the actual id should be 77 or 240*/
IF(@blaggregate=1)
RETURN
IF OBJECT_ID('tempDB..#ClientGroupsString') IS NULL
	CREATE TABLE #ClientGroupsString (CommservUniqueId INT, ClientId INT, ClientGroups NVARCHAR(MAX))
EXEC GetClientGroupsString @i_CommServUniqueID, 0
IF(@i_CommServUniqueID = 0)
BEGIN
	IF @i_IncludeUninstalledSince IS NOT NULL
	SELECT
		R.CommServUniqueId  AS 'CommServ UniqueId',
		R.CommCellID  AS 'CommCell ID',
		R.DisplayName AS 'CommCell Name',
		ISNULL (C.ClientDisplayName, C.clientName) AS 'Client',
		C.clientName  AS 'Client(classic)<HIDDEN>',
		CASE WHEN (C.type & (1|8)) = 1 THEN 'Laptop'
				WHEN (C.type & (1|8)) = 9 THEN 'Laptop + VM'
				WHEN (C.type & (4|8)) = 0 THEN 'Server'
				WHEN (C.type & (4|8)) = 8 THEN 'Server + VM'
				WHEN (C.type & 8) = 8 THEN 'VM'
			    ELSE 'Server' END AS 'Client Type',
		CASE WHEN (C.type & 2) = 2 THEN 'Yes' ELSE 'No' END AS 'Is MediaAgent',
		ISNULL(CGS.ClientGroups, '') AS 'Client Group<HIDDEN>',
		CASE WHEN C.OperatingSystem IS NULL THEN 'N/A' ELSE C.OperatingSystem
			END AS 'Operating System',
		CASE WHEN C.ServicePack IS NULL THEN 'N/A' ELSE C.ServicePack
			END AS 'Version<ALTSORT>',
		CASE WHEN C.servicePack IS NULL then 0 ELSE dbo.GetServicePackSortRank(C.servicePack)
			END AS 'Version<SORTCOLUMN>',
		ISNULL(U.AdditionalUpdates, '') AS 'Additional Updates<HIDDEN>',
		ISNULL(U.MissingUpdates, '') AS 'Missing Updates<HIDDEN>',
		CASE WHEN ISNULL(C.InstallDate, '1970-01-01') > '1970-01-01' THEN datediff(second, '01/01/1970', C.InstallDate) ELSE -50
			END AS 'Installation Date<MMMDDYYYY><HIDDEN>',
		CASE WHEN C.InstallStatus > 0 AND ISNULL(C.UninstallTime, '1970-01-01') > ISNULL(C.InstallDate, '1970-01-01')
			THEN datediff(second, '01/01/1970', CAST(C.UninstallTime AS DATE)) ELSE -50
			END AS 'Deconfigured Date<MMMDDYYYY><HIDDEN>',
		CASE WHEN (C.Deleted > 0 OR C.InstallStatus = 2) THEN 'Uninstalled'
			 WHEN C.InstallStatus = 1 THEN 'Deconfigured'
			 WHEN (C.type & 8) = 8 THEN 'Discovered'
			 WHEN C.InstallStatus = 0 THEN 'Installed' ELSE 'N/A'
			END AS 'Status',
		CASE WHEN C.InstallStatus = 0 THEN 'Yes' ELSE 'No' END AS 'IsActive'
	FROM
		cf_SurveyClient AS C WITH (NOLOCK)
		INNER JOIN dbo.cf_SurveyResultFuncV1(@i_QueryId, @i_CommServUniqueID, @blLatestSurvey, @i_LogDateStart, @i_LogDateEND, @i_UserId, @i_GroupId) AS R
			ON C.CommServUniqueId = R.CommServUniqueId AND (C.UninstallTime IS NULL OR C.UninstallTime > @i_IncludeUninstalledSince)
		LEFT OUTER JOIN #ClientGroupsString CGS ON C.CommServUniqueId = CGS.CommServUniqueId AND C.ClientId = CGS.ClientId
		LEFT OUTER JOIN cf_SurveyVersionAndServicePack U ON C.CommServUniqueId = U.CommServUniqueId AND C.ClientId = U.ClientId
		LEFT OUTER JOIN #TenantClients TC WITH (NOLOCK)
                     ON C.CommServUniqueId = TC.CommServUniqueId AND C.ClientId = TC.ClientId
		WHERE ((@i_TenantName is NOT NULL AND TC.TenantName is NOT NULL) OR @i_TenantName is NULL)
	ORDER BY 'CommCell Name', 'Client Type', 'Client' ASC
	ELSE
	SELECT
		R.CommServUniqueId  AS 'CommServ UniqueId',
		R.CommCellID  AS 'CommCell ID',
		R.DisplayName AS 'CommCell Name',
		ISNULL (C.ClientDisplayName, C.clientName) AS 'Client',
		C.clientName  AS 'Client(classic)<HIDDEN>',
		CASE WHEN (C.type & (1|8)) = 1 THEN 'Laptop'
				WHEN (C.type & (1|8)) = 9 THEN 'Laptop + VM'
				WHEN (C.type & (4|8)) = 0 THEN 'Server'
				WHEN (C.type & (4|8)) = 8 THEN 'Server + VM'
				WHEN (C.type & 8) = 8 THEN 'VM'
			    ELSE 'Server' END AS 'Client Type',
		CASE WHEN (C.type & 2) = 2 THEN 'Yes' ELSE 'No' END AS 'Is MediaAgent',
		ISNULL(CGS.ClientGroups, '') AS 'Client Group<HIDDEN>',
		CASE WHEN C.OperatingSystem IS NULL THEN 'N/A' ELSE C.OperatingSystem
			END AS 'Operating System',
		CASE WHEN C.ServicePack IS NULL THEN 'N/A' ELSE C.ServicePack
			END AS 'Version<ALTSORT>',
		CASE WHEN C.servicePack IS NULL then 0 ELSE dbo.GetServicePackSortRank(C.servicePack)
			END AS 'Version<SORTCOLUMN>',
		ISNULL(U.AdditionalUpdates, '') AS 'Additional Updates<HIDDEN>',
		ISNULL(U.MissingUpdates, '') AS 'Missing Updates<HIDDEN>',
		CASE WHEN ISNULL(C.InstallDate, '1970-01-01') > '1970-01-01' THEN datediff(second, '01/01/1970', C.InstallDate) ELSE -50
			END AS 'Installation Date<MMMDDYYYY><HIDDEN>',
		CASE WHEN C.InstallStatus > 0 AND ISNULL(C.UninstallTime, '1970-01-01') > ISNULL(C.InstallDate, '1970-01-01')
			THEN datediff(second, '01/01/1970', CAST(C.UninstallTime AS DATE)) ELSE -50
			END AS 'Deconfigured Date<MMMDDYYYY><HIDDEN>',
		CASE WHEN C.InstallStatus IN (1,2) THEN 'Deconfigured' WHEN (C.type & 8) = 8 THEN 'Discovered' WHEN C.InstallStatus = 0 THEN 'Installed' ELSE 'N/A'
			END AS 'Status',
		CASE WHEN C.InstallStatus = 0 THEN 'Yes' ELSE 'No' END AS 'IsActive'
	FROM
		cf_SurveyClient AS C WITH (NOLOCK)
		INNER JOIN dbo.cf_SurveyResultFuncV1(@i_QueryId, @i_CommServUniqueID, @blLatestSurvey, @i_LogDateStart, @i_LogDateEND, @i_UserId, @i_GroupId) AS R
			ON C.CommServUniqueId = R.CommServUniqueId AND C.Deleted = 0 AND C.InstallStatus < 2
		LEFT OUTER JOIN #ClientGroupsString CGS ON C.CommServUniqueId = CGS.CommServUniqueId AND C.ClientId = CGS.ClientId
		LEFT OUTER JOIN cf_SurveyVersionAndServicePack U ON C.CommServUniqueId = U.CommServUniqueId AND C.ClientId = U.ClientId
		LEFT OUTER JOIN #TenantClients TC WITH (NOLOCK)
                     ON C.CommServUniqueId = TC.CommServUniqueId AND C.ClientId = TC.ClientId
		WHERE ((@i_TenantName is NOT NULL AND TC.TenantName is NOT NULL) OR @i_TenantName is NULL)
	ORDER BY 'CommCell Name', 'Client Type', 'Client' ASC
END
ELSE
BEGIN
	IF @i_IncludeUninstalledSince IS NOT NULL
	SELECT
		ISNULL (C.ClientDisplayName, C.clientName) AS 'Client',
		C.clientName  AS 'Client(classic)<HIDDEN>',
		CASE WHEN (C.type & (1|8)) = 1 THEN 'Laptop'
				WHEN (C.type & (1|8)) = 9 THEN 'Laptop + VM'
				WHEN (C.type & (4|8)) = 0 THEN 'Server'
				WHEN (C.type & (4|8)) = 8 THEN 'Server + VM'
				WHEN (C.type & 8) = 8 THEN 'VM'
			    ELSE 'Server' END AS 'Client Type',
		CASE WHEN (C.type & 2) = 2 THEN 'Yes' ELSE 'No' END AS 'Is MediaAgent',
		ISNULL(CGS.ClientGroups, '') AS 'Client Group<HIDDEN>',
		CASE WHEN C.OperatingSystem IS NULL THEN 'N/A' ELSE C.OperatingSystem
			END AS 'Operating System',
		CASE WHEN C.ServicePack IS NULL THEN 'N/A' ELSE C.ServicePack
			END AS 'Version<ALTSORT>',
		CASE WHEN C.servicePack IS NULL then 0 ELSE dbo.GetServicePackSortRank(C.servicePack)
			END AS 'Version<SORTCOLUMN>',
		ISNULL(U.AdditionalUpdates, '') AS 'Additional Updates<HIDDEN>',
		ISNULL(U.MissingUpdates, '') AS 'Missing Updates<HIDDEN>',
		CASE WHEN ISNULL(C.InstallDate, '1970-01-01') > '1970-01-01' THEN datediff(second, '01/01/1970', C.InstallDate) ELSE -50
			END AS 'Installation Date<MMMDDYYYY><HIDDEN>',
		CASE WHEN C.InstallStatus > 0 AND ISNULL(C.UninstallTime, '1970-01-01') > ISNULL(C.InstallDate, '1970-01-01')
			THEN datediff(second, '01/01/1970', CAST(C.UninstallTime AS DATE)) ELSE -50
			END AS 'Deconfigured Date<MMMDDYYYY><HIDDEN>',
		CASE WHEN (C.Deleted > 0 OR C.InstallStatus = 2) THEN 'Uninstalled'
			 WHEN C.InstallStatus = 1 THEN 'Deconfigured'
			 WHEN (C.type & 8) = 8 THEN 'Discovered'
			 WHEN C.InstallStatus = 0 THEN 'Installed' ELSE 'N/A'
			END AS 'Status',
		CASE WHEN C.InstallStatus = 0 THEN 'Yes' ELSE 'No' END AS 'IsActive'
	FROM
		cf_SurveyClient AS C WITH (NOLOCK)
		INNER JOIN dbo.cf_SurveyResultFuncV1(@i_QueryId, @i_CommServUniqueID, @blLatestSurvey, @i_LogDateStart, @i_LogDateEND, @i_UserId, @i_GroupId) AS R
			ON C.CommServUniqueId = R.CommServUniqueId AND (C.UninstallTime IS NULL OR C.UninstallTime > @i_IncludeUninstalledSince)
		LEFT OUTER JOIN #ClientGroupsString CGS ON C.CommServUniqueId = CGS.CommServUniqueId AND C.ClientId = CGS.ClientId
		LEFT OUTER JOIN cf_SurveyVersionAndServicePack U ON C.CommServUniqueId = U.CommServUniqueId AND C.ClientId = U.ClientId
		LEFT OUTER JOIN #TenantClients TC WITH (NOLOCK)
                     ON C.CommServUniqueId = TC.CommServUniqueId AND C.ClientId = TC.ClientId
		WHERE ((@i_TenantName is NOT NULL AND TC.TenantName is NOT NULL) OR @i_TenantName is NULL)
	ORDER BY 'Client Type', 'Client' ASC
	ELSE
	SELECT
		ISNULL (C.ClientDisplayName, C.clientName) AS 'Client',
		C.clientName  AS 'Client(classic)<HIDDEN>',
		CASE WHEN (C.type & (1|8)) = 1 THEN 'Laptop'
				WHEN (C.type & (1|8)) = 9 THEN 'Laptop + VM'
				WHEN (C.type & (4|8)) = 0 THEN 'Server'
				WHEN (C.type & (4|8)) = 8 THEN 'Server + VM'
				WHEN (C.type & 8) = 8 THEN 'VM'
			    ELSE 'Server' END AS 'Client Type',
		CASE WHEN (C.type & 2) = 2 THEN 'Yes' ELSE 'No' END AS 'Is MediaAgent',
		ISNULL(CGS.ClientGroups, '') AS 'Client Group<HIDDEN>',
		CASE WHEN C.OperatingSystem IS NULL THEN 'N/A' ELSE C.OperatingSystem
			END AS 'Operating System',
		CASE WHEN C.ServicePack IS NULL THEN 'N/A' ELSE C.ServicePack
			END AS 'Version<ALTSORT>',
		CASE WHEN C.servicePack IS NULL then 0 ELSE dbo.GetServicePackSortRank(C.servicePack)
			END AS 'Version<SORTCOLUMN>',
		ISNULL(U.AdditionalUpdates, '') AS 'Additional Updates<HIDDEN>',
		ISNULL(U.MissingUpdates, '') AS 'Missing Updates<HIDDEN>',
		CASE WHEN ISNULL(C.InstallDate, '1970-01-01') > '1970-01-01' THEN datediff(second, '01/01/1970', C.InstallDate) ELSE -50
			END AS 'Installation Date<MMMDDYYYY><HIDDEN>',
		CASE WHEN C.InstallStatus > 0 AND ISNULL(C.UninstallTime, '1970-01-01') > ISNULL(C.InstallDate, '1970-01-01')
			THEN datediff(second, '01/01/1970', CAST(C.UninstallTime AS DATE)) ELSE -50
			END AS 'Deconfigured Date<MMMDDYYYY><HIDDEN>',
		CASE WHEN C.InstallStatus IN (1,2) THEN 'Deconfigured' WHEN (C.type & 8) = 8 THEN 'Discovered' WHEN C.InstallStatus = 0 THEN 'Installed' ELSE 'N/A'
			END AS 'Status',
		CASE WHEN C.InstallStatus = 0 THEN 'Yes' ELSE 'No' END AS 'IsActive'
	FROM
		cf_SurveyClient AS C WITH (NOLOCK)
		INNER JOIN dbo.cf_SurveyResultFuncV1(@i_QueryId, @i_CommServUniqueID, @blLatestSurvey, @i_LogDateStart, @i_LogDateEND, @i_UserId, @i_GroupId) AS R
			ON C.CommServUniqueId = R.CommServUniqueId AND C.Deleted = 0 AND C.InstallStatus < 2
		LEFT OUTER JOIN #ClientGroupsString CGS ON C.CommServUniqueId = CGS.CommServUniqueId AND C.ClientId = CGS.ClientId
		LEFT OUTER JOIN cf_SurveyVersionAndServicePack U ON C.CommServUniqueId = U.CommServUniqueId AND C.ClientId = U.ClientId
		LEFT OUTER JOIN #TenantClients TC WITH (NOLOCK)
                     ON C.CommServUniqueId = TC.CommServUniqueId AND C.ClientId = TC.ClientId
		WHERE ((@i_TenantName is NOT NULL AND TC.TenantName is NOT NULL) OR @i_TenantName is NULL)
	ORDER BY 'Client Type', 'Client' ASC
END
IF OBJECT_ID('tempDB..#ClientGroupsString') IS NOT NULL
	DROP TABLE #ClientGroupsString
SET NOCOUNT OFF
GO

IF EXISTS (select * from GxQscripts where name = 'Rpt_67ClientDetails')
	delete from GxQscripts where name = 'Rpt_67ClientDetails'
GO

IF EXISTS (select * from GXDBVersions where aliasname='Rpt_67ClientDetails')
	delete from GXDBVersions where aliasname = 'Rpt_67ClientDetails'
GO

insert into GXDBVersions values(2, 'Rpt_67ClientDetails',  '00010015004200160000', 'Rpt_67ClientDetails', '00010015004200160000')
GO

