

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Sp/Rpt_unfinishedJobs.sp] ---------- 

-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Sp/Rpt_unfinishedJobs.sp,v $ $Id: Rpt_unfinishedJobs.sp,v 1.5.56.6 2020/09/25 00:03:49 nbirru Exp $";
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER OFF

IF EXISTS (select * from sysobjects where name='Rpt_unfinishedJobs')
BEGIN
	print '>>> Drop Stored Procedure: Rpt_unfinishedJobs <<<'
	drop procedure Rpt_unfinishedJobs
END
IF EXISTS (select * from GxQscripts where name='Rpt_unfinishedJobs')
	delete from GxQscripts where name = 'Rpt_unfinishedJobs'
GO

IF EXISTS (select * from GXDBVersions where aliasname='Rpt_unfinishedJobs')
	delete from GXDBVersions where aliasname = 'Rpt_unfinishedJobs'
GO
print '... Creating Procedure: Rpt_unfinishedJobs'
GO
SET QUOTED_IDENTIFIER ON
GO
create procedure Rpt_unfinishedJobs
  @i_UserId INT = NULL,
  @i_GroupId INT = NULL,
  @blaggregate INT = 1,
  @blLatestSurvey INT = 1,
  @i_CommServUniqueID INT = 0,
  @i_LogDateStart DATETIME = NULL,
  @i_LogDateEND DATETIME = NUll
AS
SET NOCOUNT ON
DECLARE @i_QueryId BIGINT = 103
IF(@blaggregate=1)
	RETURN
CREATE TABLE #ClientGroupsString (CommservUniqueId INT, ClientId INT, ClientGroups NVARCHAR(MAX))
EXEC GetClientGroupsString @i_CommServUniqueID,0,NULL
IF @i_CommServUniqueID = 0
BEGIN
	SELECT
		resultView.CommServUniqueId  AS 'CommServ UniqueId',
		resultView.CommCellID AS 'CommCell ID',
		resultView.CommServIP AS 'CommServe IP<HIDDEN>',
		resultView.CommServGUID AS 'CommServer GUID',
		resultView.DisplayName AS 'CommCell Name',
		DATEDIFF(s, '1970-01-01 00:00:00', ISNULL(unfinishedJob.LogDate, '1970-01-01 00:00:00')) AS 'Collection Time<DATETIME><HIDDEN>',
		resultView.CommServTimeZone as 'TimeZone<HIDDEN>',
		CASE
			WHEN resultView.RunningTime = -1 THEN 'N/A'
			ELSE CAST(resultView.RunningTime AS VARCHAR(MAX))
			END AS 'Running Time in Seconds<HIDDEN>',
		unfinishedJob.jobId as 'Job Id',
		ISNULL (CL.ClientDisplayName, unfinishedJob.clientName) AS 'Client Name',
		ISNULL(CG.ClientGroups,'') AS 'Client Group',
		unfinishedJob.clientName  AS 'Client(classic)<HIDDEN>',
		unfinishedJob.idataAgent as 'iData Agent',
		unfinishedJob.instance as 'Instance<HIDDEN>',
		unfinishedJob.backupset as 'BackupSet<HIDDEN>',
		unfinishedJob.subclient as 'SubClient',
		unfinishedJob.data_sp as 'Storage Policy<HIDDEN>',
		unfinishedJob.backupLevel as 'Backup Level',
		unfinishedJob.jobStatus as 'Job Status',
		unfinishedJob.jobFailedReason as 'Job Failure Reason',
		dbo.cf_surveyKBLink(unfinishedJob.ErrorCode) as 'Error Code',
		unfinishedJob.startDateUTC as 'Start Time<DATETIME><HIDDEN>',
		unfinishedJob.endDateUTC AS 'End Time<DATETIME><HIDDEN>'
	FROM cf_SurveyunfinishedJobs AS unfinishedJob WITH (NOLOCK)
			JOIN dbo.cf_SurveyResultFuncV1(@i_QueryId, @i_CommServUniqueID, @blLatestSurvey, @i_LogDateStart, @i_LogDateEND, @i_UserId,@i_GroupId) AS resultView
				ON resultView.SurverResultId = unfinishedJob.SurveyResultId
					AND resultView.LogDateUTC = unfinishedJob.LogDateUTC
					AND resultView.CommServUniqueId = unfinishedJob.CommServUniqueId
					AND ((resultView.SureyResultFlags = @blLatestSurvey) OR @blLatestSurvey = 0)
					--AND (unfinishedJob.CommServUniqueId = @i_CommServUniqueID OR @i_CommServUniqueID = 0)
			 LEFT JOIN cf_SurveyClient CL
				ON CL.CommServUniqueId = resultView.CommServUniqueId  AND CL.clientName = unfinishedJob.clientName AND CL.Deleted = 0
			 LEFT JOIN #ClientGroupsString CG
				ON CG.CommservUniqueId = resultView.CommServUniqueId AND CG.ClientId = CL.ClientId
	ORDER BY unfinishedJob.LogDate DESC, resultView.DisplayName ASC
END
ELSE
BEGIN
	SELECT
		resultView.CommServUniqueId  AS 'CommServ UniqueId',
		unfinishedJob.jobId as 'Job Id',
		ISNULL (CL.ClientDisplayName, unfinishedJob.clientName) AS 'Client Name',
		ISNULL(CG.ClientGroups,'') AS 'Client Group',
		unfinishedJob.clientName  AS 'Client(classic)<HIDDEN>',
		unfinishedJob.idataAgent as 'iData Agent',
		unfinishedJob.instance as 'Instance',
		unfinishedJob.backupset as 'BackupSet',
		unfinishedJob.subclient as 'SubClient',
		unfinishedJob.data_sp as 'Storage Policy',
		unfinishedJob.backupLevel as 'Backup Level',
		unfinishedJob.jobStatus as 'Job Status',
		unfinishedJob.jobFailedReason as 'Job Failure Reason',
		dbo.cf_surveyKBLink(unfinishedJob.ErrorCode) as 'Error Code',
		unfinishedJob.startDateUTC as 'Start Time<DATETIME>',
		unfinishedJob.endDateUTC AS 'End Time<DATETIME>'
	FROM cf_SurveyunfinishedJobs AS unfinishedJob WITH (NOLOCK)
			JOIN dbo.cf_SurveyResultFuncV1(@i_QueryId, @i_CommServUniqueID, @blLatestSurvey, @i_LogDateStart, @i_LogDateEND, @i_UserId,@i_GroupId) AS resultView
				ON resultView.SurverResultId = unfinishedJob.SurveyResultId
					AND resultView.LogDateUTC = unfinishedJob.LogDateUTC
					AND resultView.CommServUniqueId = unfinishedJob.CommServUniqueId
					AND ((resultView.SureyResultFlags = @blLatestSurvey) OR @blLatestSurvey = 0)
					AND (unfinishedJob.CommServUniqueId = @i_CommServUniqueID)-- OR @i_CommServUniqueID = 0)
			 LEFT JOIN cf_SurveyClient CL
				ON CL.CommServUniqueId = resultView.CommServUniqueId  AND CL.clientName = unfinishedJob.clientName AND CL.Deleted = 0
			 LEFT JOIN #ClientGroupsString CG
				ON CG.CommservUniqueId = resultView.CommServUniqueId AND CG.ClientId = CL.ClientId
	ORDER BY unfinishedJob.LogDate DESC, resultView.CustomerName ASC
END
DROP TABLE #ClientGroupsString
SET NOCOUNT OFF
GO
/*
  DECLARE @i_UserId INT					= 1
  DECLARE @i_GroupId INT				= NULL
  DECLARE @blaggregate INT				= 0
  DECLARE @blLatestSurvey INT			= 1
  DECLARE @i_CommServUniqueID INT		= 11065
  DECLARE @i_LogDateStart DATETIME		= NULL
  DECLARE @i_LogDateEND DATETIME		= NULL
  DECLARE @i_CategoryName NVARCHAR(255)	= NULL   --'Laptop Clients With No Storage Policy'
exec Rpt_unfinishedJobs @i_UserId, @i_GroupId, @blaggregate, @blLatestSurvey,
                               @i_CommServUniqueID, @i_LogDateStart, @i_LogDateEND
*/

IF EXISTS (select * from GxQscripts where name = 'Rpt_unfinishedJobs')
	delete from GxQscripts where name = 'Rpt_unfinishedJobs'
GO

IF EXISTS (select * from GXDBVersions where aliasname='Rpt_unfinishedJobs')
	delete from GXDBVersions where aliasname = 'Rpt_unfinishedJobs'
GO

insert into GXDBVersions values(2, 'Rpt_unfinishedJobs',  '00010005005600060000', 'Rpt_unfinishedJobs', '00010005005600060000')
GO

