

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Upgrade/Lic_CurrentUsage.upg] ---------- 

BEGIN

DECLARE @oldRev CHAR(20)    		
  	DECLARE @oldVal CHAR(256)			
  	DECLARE @retCode   INTEGER			
  	DECLARE @sqlError  INTEGER			
  	SET     @retCode = 0              	
  	DECLARE @sqlString nvarchar(MAX)	
  	DECLARE @macroValue nvarchar(MAX)	
      DECLARE @parentID INTEGER				
      DECLARE @tName nvarchar(128)			
      DECLARE @colID INTEGER					
      DECLARE @constId INTEGER				
      DECLARE @cName   nvarchar(128)			
  	DECLARE @oldConstraintName   nvarchar(128)	
  	DECLARE @newConstraintName   nvarchar(128)	
  	DECLARE @oldDataType         nvarchar(64)	
  	DECLARE @keyname   nvarchar(128)		
      DECLARE @dbName   nvarchar(128)			
  	DECLARE @IsNullableAttr VARCHAR(100)	
  	DECLARE @DefaultValAttr NVARCHAR(MAX)	
  	DECLARE @DataType     NVARCHAR(	256)	
  	DECLARE @ct_msg			VARCHAR(1024) = ''	
  	DECLARE @ct_tcMsg		VARCHAR(1024) = ''	
  	DECLARE @nl				VARCHAR(3) = CHAR(13) + CHAR(10)	
  	SET ROWCOUNT 0							
  	SET NOCOUNT ON

SELECT @dbName = DB_NAME()													
  SELECT @oldRev = (SELECT revision FROM GXDBVersions WHERE name = 'Lic_CurrentUsage')	
  IF (@oldRev IS NULL)														
  BEGIN                 														
      SET @oldRev = '0.0'														
  END																			
  IF NOT EXISTS (SELECT * FROM sysobjects										
  WHERE type = 'U'															
  AND name = 'Lic_CurrentUsage')														
  BEGIN																		
  	SET @oldRev = '0.0'														
  	DELETE FROM GXDBVersions WHERE name = 'Lic_CurrentUsage'							
  END																			
  IF (@oldRev = '1.4')       												
  BEGIN																		
      PRINT 'RETVAL: 0   Table [' +'Lic_CurrentUsage' +'] does NOT require upgrade.'	
  	
  END																			
  else																		
  BEGIN																		
      PRINT 'Upgrading Table [' +'Lic_CurrentUsage' +'].'							
  END


IF NOT EXISTS (select * from sysobjects where id = object_id(N'[dbo].[Lic_CurrentUsage]') and OBJECTPROPERTY(id, N'IsTable') = 1)
BEGIN



--  ------------  Generated from [../../../Source/CommServer/CloudDB/Tbl/Lic_CurrentUsage.tbl] ---------- 





-- ALLOW_COMMENTS_BELOW_HERE:

-- ----------------------------------------------------------------------

--

--           Copyright (c) 1998  CommVault Systems, Inc.

--                  All rights reserved.

--

--

--        This is unpublished proprietary source code of CommVault

--        Systems, Inc. The copyright notice above does not evidence

--        any actual or intended publication of such source code.

-- ----------------------------------------------------------------------*/

-- rcsid="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Tbl/Lic_CurrentUsage.tbl,v $ $Id: Lic_CurrentUsage.tbl,v 1.1.2.4 2019/12/12 19:17:11 junlu Exp $";

--+-+-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-+

--

--  BEGIN

--

--+-+-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-+

print '... Creating Table: Lic_CurrentUsage'

exec ('



DECLARE @tblRetCode integer

Set NOCOUNT ON





create table Lic_CurrentUsage (

	CommServUniqueId	 INT NOT NULL,

	UsageType            integer NOT NULL,

	ClientId             integer  NULL DEFAULT 0,

	ClientName           NVARCHAR(255) NULL,

	SubclientId          integer  NULL DEFAULT 0,

	AppTypeId	         integer  NULL DEFAULT 0,

	LicType              integer  NULL DEFAULT 0,

	JobId                integer  NULL DEFAULT 0,

	AppSizeMB            BIGINT   NULL DEFAULT 0,

	CapacityFlag         integer NOT NULL DEFAULT 0, -- -1  not capacity usage; = 0 count to capacity; >0 excluded from capacity

	VMFlag               integer NOT NULL DEFAULT 0,  -- 0 not VM; -- 1 VM; 2 VM only -- 3 VM with apps -- 4 unprotected VM with apps

	ObjectName           NVARCHAR(1024) NULL,

	ObjectId             integer  NULL DEFAULT 0,

	OrgGUID              uniqueidentifier NULL,

	PlanName             NVARCHAR(1024) NULL,

	BasePlanName         NVARCHAR(1024) NULL



) 

set @tblRetCode = @@error

if (@tblRetCode <> 0)

BEGIN

		set @tblRetCode = @@error;

		print ''RETVAL: 10 Table [Lic_CurrentUsage]''

END

--------





CREATE CLUSTERED INDEX Lic_CurrentUsage_CommServUniqueId_UsageType_ClientId_SubclientId_idx ON Lic_CurrentUsage (CommServUniqueId, UsageType, ClientId, SubclientId)

 

set @tblRetCode = @@error 

if (@tblRetCode <> 0)

BEGIN

	set @tblRetCode = @@error;

	print ''RETVAL: 99 Table [Lic_CurrentUsage]''

END

----------



--+-+-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-+

--

--  END

--

--+-+-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-+



insert into GXDBVersions values(1, ''Lic_CurrentUsage'',  ''1.1.2.4'', ''Lic_CurrentUsage'', '''')

set @tblRetCode = @@error

if (@tblRetCode <> 0)

BEGIN

	set @tblRetCode = @@error;

	print ''RETVAL: 10 Table [GXDBVersions]''

END

ALTER TABLE Lic_CurrentUsage  ADD CONSTRAINT Lic_CurrentUsage_CommServUniqueId_FK	FOREIGN KEY (CommServUniqueId)references	 cf_CommcellIdNameMap(ID) ON DELETE CASCADE



set @tblRetCode = @@error 

if (@tblRetCode <> 0)

BEGIN

	set @tblRetCode = @@error;

	print ''RETVAL: 02 Table [Lic_CurrentUsage]''

END

----------


')
END
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'Lic_CurrentUsage' AND COLUMN_NAME='BasePlanName')			
  	BEGIN																														
  		SET @sqlString = 'ALTER TABLE ' + 'Lic_CurrentUsage'+ ' ADD ' +'BasePlanName'+ ' ' +'NVARCHAR(1024)'			
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																										
  	END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'Lic_CurrentUsage' AND xType = 'U')				
      IF EXISTS (SELECT * FROM sysindexes WHERE id = @parentID AND name = 'Lic_CurrentUsage_CommServUniqueId_UsageType_idx')						
      BEGIN																								
  		SET @sqlString = 'DROP INDEX [' + 'Lic_CurrentUsage' +'].[' + 'Lic_CurrentUsage_CommServUniqueId_UsageType_idx' +']'							
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'Lic_CurrentUsage' AND xType = 'U')								
      IF NOT EXISTS (SELECT * FROM sysindexes WHERE id = @parentID AND name = 'Lic_CurrentUsage_CommServUniqueId_UsageType_ClientId_SubclientId_idx')					
      BEGIN																								
  		SET @sqlString = 'CREATE CLUSTERED INDEX [' + 'Lic_CurrentUsage_CommServUniqueId_UsageType_ClientId_SubclientId_idx' +']' + 'ON [' + 'Lic_CurrentUsage' +']  (' + 'CommServUniqueId, UsageType, ClientId, SubclientId' + ')'		
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'Lic_CurrentUsage' AND COLUMN_NAME='SubclientName')			
  	BEGIN																							
  		SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'Lic_CurrentUsage' AND xType = 'U')				
  		SELECT @colID    = (SELECT colid FROM syscolumns WHERE id = @parentID AND NAME='SubclientName')			
  		SELECT @constId  = (SELECT a.constid FROM sysconstraints a, sysobjects b							
  					WHERE a.id = @parentID AND a.colid = @colid and a.constid = b.id and b.xtype = 'D')		
  		IF (@constId IS NOT NULL)																			
  		BEGIN																								
  			  SELECT @cName    = (SELECT name FROM sysobjects WHERE id=@constId)							
  			  SET  @sqlString = 'ALTER TABLE [' + 'Lic_CurrentUsage' +']' +'DROP CONSTRAINT [' + @cName + ']'		
  			  IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  		END 
  		SET @sqlString = 'ALTER TABLE ' + 'Lic_CurrentUsage'+ ' DROP COLUMN ' +'SubclientName'	
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  	END

IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'Lic_CurrentUsage' AND COLUMN_NAME='BackupSetId')			
  	BEGIN																							
  		SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'Lic_CurrentUsage' AND xType = 'U')				
  		SELECT @colID    = (SELECT colid FROM syscolumns WHERE id = @parentID AND NAME='BackupSetId')			
  		SELECT @constId  = (SELECT a.constid FROM sysconstraints a, sysobjects b							
  					WHERE a.id = @parentID AND a.colid = @colid and a.constid = b.id and b.xtype = 'D')		
  		IF (@constId IS NOT NULL)																			
  		BEGIN																								
  			  SELECT @cName    = (SELECT name FROM sysobjects WHERE id=@constId)							
  			  SET  @sqlString = 'ALTER TABLE [' + 'Lic_CurrentUsage' +']' +'DROP CONSTRAINT [' + @cName + ']'		
  			  IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  		END 
  		SET @sqlString = 'ALTER TABLE ' + 'Lic_CurrentUsage'+ ' DROP COLUMN ' +'BackupSetId'	
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  	END

IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'Lic_CurrentUsage' AND COLUMN_NAME='BackupSetName')			
  	BEGIN																							
  		SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'Lic_CurrentUsage' AND xType = 'U')				
  		SELECT @colID    = (SELECT colid FROM syscolumns WHERE id = @parentID AND NAME='BackupSetName')			
  		SELECT @constId  = (SELECT a.constid FROM sysconstraints a, sysobjects b							
  					WHERE a.id = @parentID AND a.colid = @colid and a.constid = b.id and b.xtype = 'D')		
  		IF (@constId IS NOT NULL)																			
  		BEGIN																								
  			  SELECT @cName    = (SELECT name FROM sysobjects WHERE id=@constId)							
  			  SET  @sqlString = 'ALTER TABLE [' + 'Lic_CurrentUsage' +']' +'DROP CONSTRAINT [' + @cName + ']'		
  			  IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  		END 
  		SET @sqlString = 'ALTER TABLE ' + 'Lic_CurrentUsage'+ ' DROP COLUMN ' +'BackupSetName'	
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  	END

IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'Lic_CurrentUsage' AND COLUMN_NAME='InstanceId')			
  	BEGIN																							
  		SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'Lic_CurrentUsage' AND xType = 'U')				
  		SELECT @colID    = (SELECT colid FROM syscolumns WHERE id = @parentID AND NAME='InstanceId')			
  		SELECT @constId  = (SELECT a.constid FROM sysconstraints a, sysobjects b							
  					WHERE a.id = @parentID AND a.colid = @colid and a.constid = b.id and b.xtype = 'D')		
  		IF (@constId IS NOT NULL)																			
  		BEGIN																								
  			  SELECT @cName    = (SELECT name FROM sysobjects WHERE id=@constId)							
  			  SET  @sqlString = 'ALTER TABLE [' + 'Lic_CurrentUsage' +']' +'DROP CONSTRAINT [' + @cName + ']'		
  			  IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  		END 
  		SET @sqlString = 'ALTER TABLE ' + 'Lic_CurrentUsage'+ ' DROP COLUMN ' +'InstanceId'	
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  	END

IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'Lic_CurrentUsage' AND COLUMN_NAME='InstanceName')			
  	BEGIN																							
  		SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'Lic_CurrentUsage' AND xType = 'U')				
  		SELECT @colID    = (SELECT colid FROM syscolumns WHERE id = @parentID AND NAME='InstanceName')			
  		SELECT @constId  = (SELECT a.constid FROM sysconstraints a, sysobjects b							
  					WHERE a.id = @parentID AND a.colid = @colid and a.constid = b.id and b.xtype = 'D')		
  		IF (@constId IS NOT NULL)																			
  		BEGIN																								
  			  SELECT @cName    = (SELECT name FROM sysobjects WHERE id=@constId)							
  			  SET  @sqlString = 'ALTER TABLE [' + 'Lic_CurrentUsage' +']' +'DROP CONSTRAINT [' + @cName + ']'		
  			  IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  		END 
  		SET @sqlString = 'ALTER TABLE ' + 'Lic_CurrentUsage'+ ' DROP COLUMN ' +'InstanceName'	
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  	END

IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'Lic_CurrentUsage' AND COLUMN_NAME='SPId')			
  	BEGIN																							
  		SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'Lic_CurrentUsage' AND xType = 'U')				
  		SELECT @colID    = (SELECT colid FROM syscolumns WHERE id = @parentID AND NAME='SPId')			
  		SELECT @constId  = (SELECT a.constid FROM sysconstraints a, sysobjects b							
  					WHERE a.id = @parentID AND a.colid = @colid and a.constid = b.id and b.xtype = 'D')		
  		IF (@constId IS NOT NULL)																			
  		BEGIN																								
  			  SELECT @cName    = (SELECT name FROM sysobjects WHERE id=@constId)							
  			  SET  @sqlString = 'ALTER TABLE [' + 'Lic_CurrentUsage' +']' +'DROP CONSTRAINT [' + @cName + ']'		
  			  IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  		END 
  		SET @sqlString = 'ALTER TABLE ' + 'Lic_CurrentUsage'+ ' DROP COLUMN ' +'SPId'	
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  	END

IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'Lic_CurrentUsage' AND COLUMN_NAME='SPName')			
  	BEGIN																							
  		SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'Lic_CurrentUsage' AND xType = 'U')				
  		SELECT @colID    = (SELECT colid FROM syscolumns WHERE id = @parentID AND NAME='SPName')			
  		SELECT @constId  = (SELECT a.constid FROM sysconstraints a, sysobjects b							
  					WHERE a.id = @parentID AND a.colid = @colid and a.constid = b.id and b.xtype = 'D')		
  		IF (@constId IS NOT NULL)																			
  		BEGIN																								
  			  SELECT @cName    = (SELECT name FROM sysobjects WHERE id=@constId)							
  			  SET  @sqlString = 'ALTER TABLE [' + 'Lic_CurrentUsage' +']' +'DROP CONSTRAINT [' + @cName + ']'		
  			  IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  		END 
  		SET @sqlString = 'ALTER TABLE ' + 'Lic_CurrentUsage'+ ' DROP COLUMN ' +'SPName'	
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  	END

IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'Lic_CurrentUsage' AND COLUMN_NAME='Organization')			
  	BEGIN																							
  		SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'Lic_CurrentUsage' AND xType = 'U')				
  		SELECT @colID    = (SELECT colid FROM syscolumns WHERE id = @parentID AND NAME='Organization')			
  		SELECT @constId  = (SELECT a.constid FROM sysconstraints a, sysobjects b							
  					WHERE a.id = @parentID AND a.colid = @colid and a.constid = b.id and b.xtype = 'D')		
  		IF (@constId IS NOT NULL)																			
  		BEGIN																								
  			  SELECT @cName    = (SELECT name FROM sysobjects WHERE id=@constId)							
  			  SET  @sqlString = 'ALTER TABLE [' + 'Lic_CurrentUsage' +']' +'DROP CONSTRAINT [' + @cName + ']'		
  			  IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  		END 
  		SET @sqlString = 'ALTER TABLE ' + 'Lic_CurrentUsage'+ ' DROP COLUMN ' +'Organization'	
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  	END

IF (@retCode < 10)													
  	BEGIN																
  		IF NOT EXISTS (SELECT * FROM GXDBVersions WHERE name = 'Lic_CurrentUsage')			
  			insert into GXDBVersions VALUES(1, 'Lic_CurrentUsage', '0.0', 'Lic_CurrentUsage', '')	
  			UPDATE GXDBVersions SET revision = '1.4' WHERE name = 'Lic_CurrentUsage'		
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), @retCode) + 'Table [' + 'Lic_CurrentUsage' + '] upgraded successfully to '			+ ' revision [' + '1.4' + '].'										
  	END																	
  	else																
  		PRINT 'RETVAL: ' + CONVERT(CHAR(5), @retCode) + ' TABLE ' + 'Lic_CurrentUsage' + ' Upgrade Completed with Errors.'  
  	RETURN			   -- No more upgrade for this TABLE!

END
GO
IF @@error <> 0 RETURN
GO
