

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Upgrade/cf_SurveyClient.upg] ---------- 

--$Id: cf_SurveyClient.upg,v 1.1.2.14 2020/10/26 06:21:41 chandru Exp $
BEGIN

DECLARE @oldRev CHAR(20)    		
  	DECLARE @oldVal CHAR(256)			
  	DECLARE @retCode   INTEGER			
  	DECLARE @sqlError  INTEGER			
  	SET     @retCode = 0              	
  	DECLARE @sqlString nvarchar(MAX)	
  	DECLARE @macroValue nvarchar(MAX)	
      DECLARE @parentID INTEGER				
      DECLARE @tName nvarchar(128)			
      DECLARE @colID INTEGER					
      DECLARE @constId INTEGER				
      DECLARE @cName   nvarchar(128)			
  	DECLARE @oldConstraintName   nvarchar(128)	
  	DECLARE @newConstraintName   nvarchar(128)	
  	DECLARE @oldDataType         nvarchar(64)	
  	DECLARE @keyname   nvarchar(128)		
      DECLARE @dbName   nvarchar(128)			
  	DECLARE @IsNullableAttr VARCHAR(100)	
  	DECLARE @DefaultValAttr NVARCHAR(MAX)	
  	DECLARE @DataType     NVARCHAR(	256)	
  	DECLARE @ct_msg			VARCHAR(1024) = ''	
  	DECLARE @ct_tcMsg		VARCHAR(1024) = ''	
  	DECLARE @nl				VARCHAR(3) = CHAR(13) + CHAR(10)	
  	SET ROWCOUNT 0							
  	SET NOCOUNT ON-- Declare/Initialize @oldRev, @oldVal, @retCode

SELECT @dbName = DB_NAME()													
  SELECT @oldRev = (SELECT revision FROM GXDBVersions WHERE name = 'cf_SurveyClient')	
  IF (@oldRev IS NULL)														
  BEGIN                 														
      SET @oldRev = '0.0'														
  END																			
  IF NOT EXISTS (SELECT * FROM sysobjects										
  WHERE type = 'U'															
  AND name = 'cf_SurveyClient')														
  BEGIN																		
  	SET @oldRev = '0.0'														
  	DELETE FROM GXDBVersions WHERE name = 'cf_SurveyClient'							
  END																			
  IF (@oldRev = '1.16')       												
  BEGIN																		
      PRINT 'RETVAL: 0   Table [' +'cf_SurveyClient' +'] does NOT require upgrade.'	
  	
  END																			
  else																		
  BEGIN																		
      PRINT 'Upgrading Table [' +'cf_SurveyClient' +'].'							
  END-- Get @oldRev, compare to '1.16'. Chk for work to do.


IF NOT EXISTS (select * from sysobjects where id = object_id(N'[dbo].[cf_SurveyClient]') and OBJECTPROPERTY(id, N'IsTable') = 1)
BEGIN



--  ------------  Generated from [../../../Source/CommServer/CloudDB/Tbl/cf_SurveyClient.tbl] ---------- 





-- ALLOW_COMMENTS_BELOW_HERE:

-- ----------------------------------------------------------------------

--

--           Copyright (c) 1998  CommVault Systems, Inc.

--                  All rights reserved.

--

--

--        This is unpublished proprietary source code of CommVault

--        Systems, Inc. The copyright notice above does not evidence

--        any actual or intended publication of such source code.

-- ----------------------------------------------------------------------*/

-- rcsid="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Tbl/cf_SurveyClient.tbl,v $ $Id: cf_SurveyClient.tbl,v 1.1.2.14 2020/10/26 06:21:47 chandru Exp $";

--+-+-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-+

--

--  BEGIN

--

--+-+-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-+

-- Bitmap column Type: 1 is for Laptop Clients, 2 is for MediaAgent, 4 for Clients not having any package installed, 8 for virtual server discovered VMs

-- InstallStatus: 0 for installed, 1 for deconfigured, 2 for deleted

print '... Creating Table: cf_SurveyClient'

exec ('



DECLARE @tblRetCode integer

Set NOCOUNT ON





create table cf_SurveyClient (

	CommServUniqueId			INT NOT NULL,

	ClientId					INT NOT NULL,

	ClientName					NVARCHAR (255) NULL,

	PhysicalClientName  		NVARCHAR (255) NULL,

	OperatingSystem				NVARCHAR (255) NULL,

	Timezone					VARCHAR  (255) NULL,

	Type						INT NULL,

	InstallStatus				INT NULL,

	InstallDate					DATETIME NULL,

	UninstallTime				DATETIME NULL,

	ServicePack					NVARCHAR (255) NULL,

	StoragePolicy				NVARCHAR (255) NULL,

	LatestDataProtection		DATETIME NULL,

	Deleted						TINYINT  NOT NULL,

	ClientHostName				NVARCHAR(510) NULL,

	ClientDisplayName			NVARCHAR (255) NULL,

	Latitude					DECIMAL(16,13) NULL,	

	Longitude					DECIMAL(16,13) NULL,	

	CountryCode					NVARCHAR(3) NOT NULL DEFAULT '''',

	ExceptionType				INT NULL,

	ClientGroups				NVARCHAR(MAX)NULL,

	LastOnlineTime				DATETIME NULL,

	LastOfflineTime				DATETIME NULL,



) 

set @tblRetCode = @@error

if (@tblRetCode <> 0)

BEGIN

		set @tblRetCode = @@error;

		print ''RETVAL: 10 Table [cf_SurveyClient]''

END

--------





CREATE INDEX cf_SurveyClient_CommServUniqueId_InstallDate_idx ON cf_SurveyClient (CommServUniqueId, InstallDate) INCLUDE (InstallStatus, UninstallTime, LatestDataProtection)

 

set @tblRetCode = @@error 

if (@tblRetCode <> 0)

BEGIN

	set @tblRetCode = @@error;

	print ''RETVAL: 02 Table [cf_SurveyClient]''

END

----------



CREATE INDEX cf_SurveyClient_CountryCode_idx ON cf_SurveyClient (CountryCode)

 

set @tblRetCode = @@error 

if (@tblRetCode <> 0)

BEGIN

	set @tblRetCode = @@error;

	print ''RETVAL: 02 Table [cf_SurveyClient]''

END

----------



CREATE INDEX cf_SurveyClient_CommServUniqueId_Type_idx ON cf_SurveyClient (CommServUniqueId, Type) INCLUDE (CountryCode)

 

set @tblRetCode = @@error 

if (@tblRetCode <> 0)

BEGIN

	set @tblRetCode = @@error;

	print ''RETVAL: 02 Table [cf_SurveyClient]''

END

----------



CREATE INDEX cf_SurveyClient_CommServUniqueId_Deleted_idx ON cf_SurveyClient (CommServUniqueId, Deleted)

 

set @tblRetCode = @@error 

if (@tblRetCode <> 0)

BEGIN

	set @tblRetCode = @@error;

	print ''RETVAL: 02 Table [cf_SurveyClient]''

END

----------



--+-+-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-+

--

--  END

--

--+-+-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-+



insert into GXDBVersions values(1, ''cf_SurveyClient'',  ''1.1.2.14'', ''cf_SurveyClient'', '''')

set @tblRetCode = @@error

if (@tblRetCode <> 0)

BEGIN

	set @tblRetCode = @@error;

	print ''RETVAL: 10 Table [GXDBVersions]''

END

ALTER TABLE cf_SurveyClient ADD CONSTRAINT cf_SurveyClient_CommServUniqueId_ClientId_PK 		primary key (CommServUniqueId, ClientId)



set @tblRetCode = @@error 

if (@tblRetCode <> 0)

BEGIN

	set @tblRetCode = @@error;

	print ''RETVAL: 02 Table [cf_SurveyClient]''

END

----------

ALTER TABLE cf_SurveyClient  ADD CONSTRAINT cf_SurveyClient_CommservUniqueId_FK	FOREIGN KEY (CommservUniqueId)references	 cf_CommcellIdNameMap (ID) ON DELETE CASCADE



set @tblRetCode = @@error 

if (@tblRetCode <> 0)

BEGIN

	set @tblRetCode = @@error;

	print ''RETVAL: 02 Table [cf_SurveyClient]''

END

----------


')
END
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'cf_SurveyClient' AND COLUMN_NAME='ClientHostName')			
  	BEGIN																														
  		SET @sqlString = 'ALTER TABLE ' + 'cf_SurveyClient'+ ' ADD ' +'ClientHostName'+ ' ' +'NVARCHAR(510)'			
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																										
  	END

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'cf_SurveyClient' AND COLUMN_NAME='ClientDisplayName')			
  	BEGIN																														
  		SET @sqlString = 'ALTER TABLE ' + 'cf_SurveyClient'+ ' ADD ' +'ClientDisplayName'+ ' ' +'NVARCHAR(256)'			
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																										
  	END

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'cf_SurveyClient' AND COLUMN_NAME='Latitude')			
  	BEGIN																														
  		SET @sqlString = 'ALTER TABLE ' + 'cf_SurveyClient'+ ' ADD ' +'Latitude'+ ' ' +'DECIMAL(16,13)'			
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																										
  	END

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'cf_SurveyClient' AND COLUMN_NAME='Longitude')			
  	BEGIN																														
  		SET @sqlString = 'ALTER TABLE ' + 'cf_SurveyClient'+ ' ADD ' +'Longitude'+ ' ' +'DECIMAL(16,13)'			
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																										
  	END

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'cf_SurveyClient' AND COLUMN_NAME='CountryCode')			
  	BEGIN																														
  		SET @macroValue=''''			
  	IF(@macroValue <> '')			
  	BEGIN			
  		IF(ISNUMERIC(@macroValue) = 1)			
  		BEGIN			
  			SET @macroValue = @macroValue			
  		END			
  		ELSE IF(@macroValue = 'NULL')			
  		BEGIN			
  			SET @macroValue = @macroValue			
  		END			
  		ELSE IF(@macroValue LIKE '{%}')			
  		BEGIN			
  			SET @macroValue = SUBSTRING(@macroValue, 2, LEN(@macroValue) - 2)			
  		END			
  		ELSE IF(@macroValue LIKE '"%"')			
  		BEGIN			
  			SET @macroValue = '''' + REPLACE(SUBSTRING(@macroValue, 2, LEN(@macroValue) - 2), '''', '''''') + ''''			
  		END			
  		ELSE IF(@macroValue LIKE '0x%')			
  		BEGIN			
  			SET @macroValue = @macroValue			
  		END			
  		ELSE IF(@macroValue = '''')		
  		BEGIN			
  			SET @macroValue = ''''''			
  		END			
  		ELSE IF(@macroValue LIKE '%(%)%')			
  		BEGIN			
  			SET @macroValue = @macroValue			
  		END			
  		ELSE			
  		BEGIN			
  			SET @macroValue = '''' + REPLACE(@macroValue, '''', '''''') + ''''			
  		END			
  	END			
  	ELSE			
  	BEGIN			
  		SET @macroValue = ''''''			
  	END		
  		SET @sqlString = 'ALTER TABLE ' + 'cf_SurveyClient'+ ' ADD ' +'CountryCode'+ ' ' +'NVARCHAR(3)'		
  			+ ' NOT NULL DEFAULT ' + @macroValue																	
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																											
  	END

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'cf_SurveyClient' AND COLUMN_NAME='ExceptionType')			
  	BEGIN																														
  		SET @sqlString = 'ALTER TABLE ' + 'cf_SurveyClient'+ ' ADD ' +'ExceptionType'+ ' ' +'INT'			
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																										
  	END

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'cf_SurveyClient' AND COLUMN_NAME='ClientGroups')			
  	BEGIN																														
  		SET @sqlString = 'ALTER TABLE ' + 'cf_SurveyClient'+ ' ADD ' +'ClientGroups'+ ' ' +'NVARCHAR(MAX)'			
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																										
  	END

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'cf_SurveyClient' AND COLUMN_NAME='LastOnlineTime')			
  	BEGIN																														
  		SET @sqlString = 'ALTER TABLE ' + 'cf_SurveyClient'+ ' ADD ' +'LastOnlineTime'+ ' ' +'DATETIME'			
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																										
  	END

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'cf_SurveyClient' AND COLUMN_NAME='LastOfflineTime')			
  	BEGIN																														
  		SET @sqlString = 'ALTER TABLE ' + 'cf_SurveyClient'+ ' ADD ' +'LastOfflineTime'+ ' ' +'DATETIME'			
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																										
  	END

IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'cf_SurveyClient' AND COLUMN_NAME='AdditionalUpdates')			
  	BEGIN																							
  		SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'cf_SurveyClient' AND xType = 'U')				
  		SELECT @colID    = (SELECT colid FROM syscolumns WHERE id = @parentID AND NAME='AdditionalUpdates')			
  		SELECT @constId  = (SELECT a.constid FROM sysconstraints a, sysobjects b							
  					WHERE a.id = @parentID AND a.colid = @colid and a.constid = b.id and b.xtype = 'D')		
  		IF (@constId IS NOT NULL)																			
  		BEGIN																								
  			  SELECT @cName    = (SELECT name FROM sysobjects WHERE id=@constId)							
  			  SET  @sqlString = 'ALTER TABLE [' + 'cf_SurveyClient' +']' +'DROP CONSTRAINT [' + @cName + ']'		
  			  IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  		END 
  		SET @sqlString = 'ALTER TABLE ' + 'cf_SurveyClient'+ ' DROP COLUMN ' +'AdditionalUpdates'	
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  	END

IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'cf_SurveyClient' AND COLUMN_NAME='UPNumber')			
  	BEGIN																							
  		SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'cf_SurveyClient' AND xType = 'U')				
  		SELECT @colID    = (SELECT colid FROM syscolumns WHERE id = @parentID AND NAME='UPNumber')			
  		SELECT @constId  = (SELECT a.constid FROM sysconstraints a, sysobjects b							
  					WHERE a.id = @parentID AND a.colid = @colid and a.constid = b.id and b.xtype = 'D')		
  		IF (@constId IS NOT NULL)																			
  		BEGIN																								
  			  SELECT @cName    = (SELECT name FROM sysobjects WHERE id=@constId)							
  			  SET  @sqlString = 'ALTER TABLE [' + 'cf_SurveyClient' +']' +'DROP CONSTRAINT [' + @cName + ']'		
  			  IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  		END 
  		SET @sqlString = 'ALTER TABLE ' + 'cf_SurveyClient'+ ' DROP COLUMN ' +'UPNumber'	
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  	END

IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'cf_SurveyClient' AND COLUMN_NAME='UPFriendlyName')			
  	BEGIN																							
  		SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'cf_SurveyClient' AND xType = 'U')				
  		SELECT @colID    = (SELECT colid FROM syscolumns WHERE id = @parentID AND NAME='UPFriendlyName')			
  		SELECT @constId  = (SELECT a.constid FROM sysconstraints a, sysobjects b							
  					WHERE a.id = @parentID AND a.colid = @colid and a.constid = b.id and b.xtype = 'D')		
  		IF (@constId IS NOT NULL)																			
  		BEGIN																								
  			  SELECT @cName    = (SELECT name FROM sysobjects WHERE id=@constId)							
  			  SET  @sqlString = 'ALTER TABLE [' + 'cf_SurveyClient' +']' +'DROP CONSTRAINT [' + @cName + ']'		
  			  IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  		END 
  		SET @sqlString = 'ALTER TABLE ' + 'cf_SurveyClient'+ ' DROP COLUMN ' +'UPFriendlyName'	
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  	END

IF NOT EXISTS (

	SELECT 1

	FROM   sys.indexes i

		   INNER JOIN sys.index_columns ic ON ic.object_id = i.object_id AND ic.index_id = i.index_id

		   INNER JOIN sys.columns c ON c.object_id = ic.object_id AND c.column_id = ic.column_id

	WHERE  ic.is_included_column = 1 AND i.name = 'cf_SurveyClient_CommServUniqueId_Type_idx' AND c.name = 'CountryCode')

BEGIN 

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'cf_SurveyClient' AND xType = 'U')				
      IF EXISTS (SELECT * FROM sysindexes WHERE id = @parentID AND name = 'cf_SurveyClient_CommServUniqueId_Type_idx')						
      BEGIN																								
  		SET @sqlString = 'DROP INDEX [' + 'cf_SurveyClient' +'].[' + 'cf_SurveyClient_CommServUniqueId_Type_idx' +']'							
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'cf_SurveyClient' AND xType = 'U')								
      IF NOT EXISTS (SELECT * FROM sysindexes WHERE id = @parentID AND name = 'cf_SurveyClient_CommServUniqueId_Type_idx')					
      BEGIN																								
  		SET @sqlString = 'CREATE INDEX [' + 'cf_SurveyClient_CommServUniqueId_Type_idx' +']' + 'ON [' + 'cf_SurveyClient' +']  (' + 'CommServUniqueId, Type' + ') INCLUDE ('+ 'CountryCode' + ')'		
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'cf_SurveyClient' AND xType = 'U')								
      IF NOT EXISTS (SELECT * FROM sysindexes WHERE id = @parentID AND name = 'cf_SurveyClient_CommServUniqueId_InstallDate_idx')					
      BEGIN																								
  		SET @sqlString = 'CREATE INDEX [' + 'cf_SurveyClient_CommServUniqueId_InstallDate_idx' +']' + 'ON [' + 'cf_SurveyClient' +']  (' + 'CommServUniqueId, InstallDate' + ') INCLUDE ('+ 'InstallStatus, UninstallTime, LatestDataProtection' + ')'		
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'cf_SurveyClient' AND xType = 'U')								
      IF NOT EXISTS (SELECT * FROM sysindexes WHERE id = @parentID AND name = 'cf_SurveyClient_CountryCode_idx')					
      BEGIN																								
  		SET @sqlString = 'CREATE INDEX [' + 'cf_SurveyClient_CountryCode_idx' +']' + 'ON [' + 'cf_SurveyClient' +']  (' + 'CountryCode' + ')'		
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'cf_SurveyClient' AND xType = 'U')								
      IF NOT EXISTS (SELECT * FROM sysindexes WHERE id = @parentID AND name = 'cf_SurveyClient_CommServUniqueId_Deleted_idx')					
      BEGIN																								
  		SET @sqlString = 'CREATE INDEX [' + 'cf_SurveyClient_CommServUniqueId_Deleted_idx' +']' + 'ON [' + 'cf_SurveyClient' +']  (' + 'CommServUniqueId, Deleted' + ')'		
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

IF (@retCode < 10)													
  	BEGIN																
  		IF NOT EXISTS (SELECT * FROM GXDBVersions WHERE name = 'cf_SurveyClient')			
  			insert into GXDBVersions VALUES(1, 'cf_SurveyClient', '0.0', 'cf_SurveyClient', '')	
  			UPDATE GXDBVersions SET revision = '1.16' WHERE name = 'cf_SurveyClient'		
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), @retCode) + 'Table [' + 'cf_SurveyClient' + '] upgraded successfully to '			+ ' revision [' + '1.16' + '].'										
  	END																	
  	else																
  		PRINT 'RETVAL: ' + CONVERT(CHAR(5), @retCode) + ' TABLE ' + 'cf_SurveyClient' + ' Upgrade Completed with Errors.'  
  	RETURN			   -- No more upgrade for this TABLE!

END

GO
IF @@error <> 0 RETURN
GO
