

--  ------------  Generated from [../../../Source/CommServer/CloudDB/Upgrade/cf_SurveyLongRunningJobs.upg] ---------- 

--$Id: cf_SurveyLongRunningJobs.upg,v 1.1.66.2 2020/12/20 15:14:14 junlu Exp $
BEGIN

DECLARE @oldRev CHAR(20)    		
  	DECLARE @oldVal CHAR(256)			
  	DECLARE @retCode   INTEGER			
  	DECLARE @sqlError  INTEGER			
  	SET     @retCode = 0              	
  	DECLARE @sqlString nvarchar(MAX)	
  	DECLARE @macroValue nvarchar(MAX)	
      DECLARE @parentID INTEGER				
      DECLARE @tName nvarchar(128)			
      DECLARE @colID INTEGER					
      DECLARE @constId INTEGER				
      DECLARE @cName   nvarchar(128)			
  	DECLARE @oldConstraintName   nvarchar(128)	
  	DECLARE @newConstraintName   nvarchar(128)	
  	DECLARE @oldDataType         nvarchar(64)	
  	DECLARE @keyname   nvarchar(128)		
      DECLARE @dbName   nvarchar(128)			
  	DECLARE @IsNullableAttr VARCHAR(100)	
  	DECLARE @DefaultValAttr NVARCHAR(MAX)	
  	DECLARE @DataType     NVARCHAR(	256)	
  	DECLARE @ct_msg			VARCHAR(1024) = ''	
  	DECLARE @ct_tcMsg		VARCHAR(1024) = ''	
  	DECLARE @nl				VARCHAR(3) = CHAR(13) + CHAR(10)	
  	SET ROWCOUNT 0							
  	SET NOCOUNT ON-- Declare/Initialize @oldRev, @oldVal, @retCode

SELECT @dbName = DB_NAME()													
  SELECT @oldRev = (SELECT revision FROM GXDBVersions WHERE name = 'cf_SurveyLongRunningJobs')	
  IF (@oldRev IS NULL)														
  BEGIN                 														
      SET @oldRev = '0.0'														
  END																			
  IF NOT EXISTS (SELECT * FROM sysobjects										
  WHERE type = 'U'															
  AND name = 'cf_SurveyLongRunningJobs')														
  BEGIN																		
  	SET @oldRev = '0.0'														
  	DELETE FROM GXDBVersions WHERE name = 'cf_SurveyLongRunningJobs'							
  END																			
  IF (@oldRev = '1.6')       												
  BEGIN																		
      PRINT 'RETVAL: 0   Table [' +'cf_SurveyLongRunningJobs' +'] does NOT require upgrade.'	
  	
  END																			
  else																		
  BEGIN																		
      PRINT 'Upgrading Table [' +'cf_SurveyLongRunningJobs' +'].'							
  END-- Get @oldRev, compare to '1.6'. Chk for work to do.


IF NOT EXISTS (select * from sysobjects where id = object_id(N'[dbo].[cf_SurveyLongRunningJobs]') and OBJECTPROPERTY(id, N'IsTable') = 1)
BEGIN



--  ------------  Generated from [../../../Source/CommServer/CloudDB/Tbl/cf_SurveyLongRunningJobs.tbl] ---------- 





-- ALLOW_COMMENTS_BELOW_HERE:

-- ----------------------------------------------------------------------

--

--           Copyright (c) 1998  CommVault Systems, Inc.

--                  All rights reserved.

--

--

--        This is unpublished proprietary source code of CommVault

--        Systems, Inc. The copyright notice above does not evidence

--        any actual or intended publication of such source code.

-- ----------------------------------------------------------------------*/

-- rcsid="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CloudDB/Tbl/cf_SurveyLongRunningJobs.tbl,v $ $Id: cf_SurveyLongRunningJobs.tbl,v 1.4.88.2 2020/12/20 15:10:13 junlu Exp $";

--+-+-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-+

--

--  BEGIN

--

--+-+-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-+

print '... Creating Table: cf_SurveyLongRunningJobs'

exec ('



DECLARE @tblRetCode integer

Set NOCOUNT ON





create table cf_SurveyLongRunningJobs (

	CommServUniqueId	int NOT NULL,

	SurveyResultId		bigint NOT NULL,

	LogDateUTC			datetime NOT NULL,

	LogDate				datetime NOT NULL,

	ClientGroups				nvarchar(max)NULL,

	JobId				bigint NULL,

	ClientId			bigint NULL,

	ClientName				nvarchar(max)NULL,

	AgentName				nvarchar(max)NULL,

	BackupType			nvarchar(25) NULL,

	DurationHr			float NULL,

	ApplicationSize		bigint NULL,

	TopN				int NOT NULL DEFAULT 25,

	LongRunningJobs		int NOT NULL DEFAULT 0,



) 

set @tblRetCode = @@error

if (@tblRetCode <> 0)

BEGIN

		set @tblRetCode = @@error;

		print ''RETVAL: 10 Table [cf_SurveyLongRunningJobs]''

END

--------





ALTER TABLE cf_SurveyLongRunningJobs ADD DEFAULT '''' FOR ClientName;

CREATE CLUSTERED INDEX cf_SurveyLongRunningJobs_idx1 ON cf_SurveyLongRunningJobs (SurveyResultId, CommServUniqueId, LogDateUTC)

 

set @tblRetCode = @@error 

if (@tblRetCode <> 0)

BEGIN

	set @tblRetCode = @@error;

	print ''RETVAL: 99 Table [cf_SurveyLongRunningJobs]''

END

----------



--+-+-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-+

--

--  END

--

--+-+-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-++-+



insert into GXDBVersions values(1, ''cf_SurveyLongRunningJobs'',  ''1.4.88.2'', ''cf_SurveyLongRunningJobs'', '''')

set @tblRetCode = @@error

if (@tblRetCode <> 0)

BEGIN

	set @tblRetCode = @@error;

	print ''RETVAL: 10 Table [GXDBVersions]''

END

ALTER TABLE cf_SurveyLongRunningJobs  ADD CONSTRAINT cf_SurveyLongRunningJobs_SurveyResultId_FK	FOREIGN KEY (SurveyResultId)references	 cf_CommservSurveyResults (CommservSurveyResults_ID) ON DELETE CASCADE



set @tblRetCode = @@error 

if (@tblRetCode <> 0)

BEGIN

	set @tblRetCode = @@error;

	print ''RETVAL: 02 Table [cf_SurveyLongRunningJobs]''

END

----------


')
END
IF COL_LENGTH('cf_SurveyLongRunningJobs', 'SurveyResultId ') = 4

BEGIN

EXECUTE @retCode = cvsp_drop_fkeys @fromTable = 'cf_SurveyLongRunningJobs', @fromColumn = 'CommservSurveyResults_ID', @toTable = 'cf_CommservSurveyResults'

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'cf_SurveyLongRunningJobs' AND xType = 'U')				
      IF EXISTS (SELECT * FROM sysindexes WHERE id = @parentID AND name = 'cf_SurveyLongRunningJobs_idx1')						
      BEGIN																								
  		SET @sqlString = 'DROP INDEX [' + 'cf_SurveyLongRunningJobs' +'].[' + 'cf_SurveyLongRunningJobs_idx1' +']'							
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

SET @oldDataType='INT'	
  	IF(@oldDataType LIKE '%char%')				
  	BEGIN										
  		IF(@oldDataType LIKE '%(%)%')			
  		BEGIN									
  			SET @oldDataType = SUBSTRING(@oldDataType, 0, CHARINDEX('(', @oldDataType, 0))	
  		END										
  	END			
  	IF (@oldDataType!='BIGINT')																
  			AND EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'cf_SurveyLongRunningJobs' AND COLUMN_NAME='SurveyResultId' AND DATA_TYPE = @oldDataType)			
  	BEGIN																														
  		SET @sqlString = 'ALTER TABLE ' + 'cf_SurveyLongRunningJobs'+ ' ALTER COLUMN ' +'SurveyResultId'+ ' ' +'BIGINT'		
  		+ ' NOT NULL '																											
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																											
  	END

END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'cf_SurveyLongRunningJobs' AND xType = 'U')				
  	IF NOT EXISTS (SELECT  name FROM sys.foreign_keys WHERE parent_object_id = @parentID AND name = 'cf_SurveyLongRunningJobs_SurveyResultId_FK')	
  	BEGIN																								
  		SET @sqlString = 'ALTER TABLE [' + 'cf_SurveyLongRunningJobs' +']' + 'ADD CONSTRAINT [' + 'cf_SurveyLongRunningJobs_SurveyResultId_FK' +'] FOREIGN KEY (' + 'SurveyResultId' + ') REFERENCES ['+ 'cf_CommservSurveyResults' +'] (' + 'CommservSurveyResults_ID' + ') ON DELETE CASCADE'		
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'cf_SurveyLongRunningJobs' AND xType = 'U')								
      IF NOT EXISTS (SELECT * FROM sysindexes WHERE id = @parentID AND name = 'cf_SurveyLongRunningJobs_idx1')					
      BEGIN																								
  		SET @sqlString = 'CREATE CLUSTERED INDEX [' + 'cf_SurveyLongRunningJobs_idx1' +']' + 'ON [' + 'cf_SurveyLongRunningJobs' +']  (' + 'SurveyResultId, CommServUniqueId, LogDateUTC' + ')'		
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

IF (@retCode < 10)													
  	BEGIN																
  		IF NOT EXISTS (SELECT * FROM GXDBVersions WHERE name = 'cf_SurveyLongRunningJobs')			
  			insert into GXDBVersions VALUES(1, 'cf_SurveyLongRunningJobs', '0.0', 'cf_SurveyLongRunningJobs', '')	
  			UPDATE GXDBVersions SET revision = '1.6' WHERE name = 'cf_SurveyLongRunningJobs'		
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), @retCode) + 'Table [' + 'cf_SurveyLongRunningJobs' + '] upgraded successfully to '			+ ' revision [' + '1.6' + '].'										
  	END																	
  	else																
  		PRINT 'RETVAL: ' + CONVERT(CHAR(5), @retCode) + ' TABLE ' + 'cf_SurveyLongRunningJobs' + ' Upgrade Completed with Errors.'  
  	RETURN			   -- No more upgrade for this TABLE!

END

GO
IF @@error <> 0 RETURN
GO
